SystemOrganization addCategory: #Tabular!
SystemOrganization addCategory: 'Tabular-Exporters'!
SystemOrganization addCategory: 'Tabular-Importers'!
SystemOrganization addCategory: 'Tabular-Model'!
SystemOrganization addCategory: 'Tabular-SAXParser'!
SystemOrganization addCategory: 'Tabular-Tests'!

TestCase subclass: #TabularCellTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Tests'!

!TabularCellTest commentStamp: '<historical>' prior: 0!
A TabularCellTest is a test class for testing the behavior of TabularCell!

!TabularCellTest methodsFor: 'tests-accessing - attributes' stamp: 'HannesHirzel 8/13/2015 17:09'!
testColspan

   <expectedFailure>! !

!TabularCellTest methodsFor: 'tests-accessing - attributes' stamp: 'HannesHirzel 8/13/2015 17:08'!
testRowspan

  <expectedFailure>! !

!TabularCellTest methodsFor: 'tests-accessing - attributes' stamp: 'HannesHirzel 8/13/2015 17:08'!
testStyle

   <expectedFailure>! !

!TabularCellTest methodsFor: 'tests-accessing - attributes' stamp: 'HannesHirzel 8/13/2015 17:09'!
testType

 <expectedFailure>
 ! !

TestCase subclass: #TabularColumnNameTest
	instanceVariableNames: 't'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Tests'!

!TabularColumnNameTest methodsFor: 'running' stamp: 'HannesHirzel 8/9/2015 17:20'!
setUp
	t:=TabularXSLXExport new.! !

!TabularColumnNameTest methodsFor: 'tests' stamp: 'VincentBlondeau 1/13/2015 13:52'!
testA
	self assert: (t columnName: 1) equals: 'A'! !

!TabularColumnNameTest methodsFor: 'tests' stamp: 'VincentBlondeau 1/13/2015 13:52'!
testAA
	self assert: (t columnName: 27) equals:'AA'! !

!TabularColumnNameTest methodsFor: 'tests' stamp: 'VincentBlondeau 1/13/2015 13:53'!
testAAA
	self assert: (t columnName: 703) equals: 'AAA'! !

!TabularColumnNameTest methodsFor: 'tests' stamp: 'VincentBlondeau 1/13/2015 13:53'!
testAZ
	self assert: (t columnName: 52) equals: 'AZ'! !

!TabularColumnNameTest methodsFor: 'tests' stamp: 'VincentBlondeau 1/13/2015 13:53'!
testBA
	self assert: (t columnName: 53)equals: 'BA'! !

!TabularColumnNameTest methodsFor: 'tests' stamp: 'VincentBlondeau 1/13/2015 13:53'!
testZ
	self assert: (t columnName: 26) equals: 'Z'! !

!TabularColumnNameTest methodsFor: 'tests' stamp: 'VincentBlondeau 1/13/2015 13:53'!
testZZ
	self assert: (t columnName: 702) equals: 'ZZ'! !

TestCase subclass: #TabularExportImportTest
	instanceVariableNames: 'worksheet fname fname2 fname3 fname0 fname4 fname5'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Tests'!

!TabularExportImportTest commentStamp: 'HannesHirzel 8/11/2015 06:58' prior: 0!
| workbook sheet |
	workbook := TabularWorkbook withSheets: 1.
	workbook filename: 'Test.xlsx'.
	sheet := workbook worksheets first.
	sheet
		at: 1 @ 1 putData: '-';
		at: 2 @ 1 putData: 'colspan test ...........';
		at: 1 @ 2 putData: 'rowspan test';
		at: 2 @ 2 putData: 777.77.
	(sheet cells at: 2 @ 1) colspan: 3.
	(sheet cells at: 1 @ 2) rowspan: 3.
	sheet  at: 4 @ 3 putData: 'Jurij -- Юрий'.
	
	^ workbook!

!TabularExportImportTest methodsFor: 'setUp' stamp: 'HannesHirzel 8/14/2015 19:09'!
setUp
    fname0 := 'TabularEmptySheetExported.xlsx'.
    fname4 := 'TabularConstructed4Exported.xlsx'.
    fname5 := 'TabularConstructed5Exported.xlsx'.
		
    fname := TabularResources fileNameOfExample1.
    (FileLocator home / fname ) ensureDelete.

    fname2 := TabularResources fileNameOfExample2.
    (FileLocator home / fname2 ) ensureDelete.
   
    fname3 := TabularResources fileNameOfExample1.
    (FileLocator home / fname3 ) ensureDelete
	! !

!TabularExportImportTest methodsFor: 'as yet unclassified' stamp: 'HannesHirzel 8/13/2015 05:34'!
testExport0EmptyWorkbook
"export empty workbook"

|w  |
	w := TabularWorkbook new.
	self assert:  (w worksheets isEmpty).	
		
	TabularXSLXExport workbook: w fileName: fname2.

	! !

!TabularExportImportTest methodsFor: 'tests-numbers' stamp: 'HannesHirzel 8/14/2015 15:36'!
testExport1CellAccess

	| wbk  wimported cell ws |

	wbk := XLSXImporter import: TabularResources testExcelFile1OneSheetOnly  readStream.
	TabularXSLXExport workbook: wbk fileName: fname.

	wimported := XLSXImporter import: (FileLocator home / fname ) .
	
	ws := (wimported worksheetNamed: 'Sheet1').
	self assert: (ws allCoord includes: 3@9).
	cell := ws at: 3@9.
	self assert: (cell notNil).
	self assert: (cell data = 39).
	! !

!TabularExportImportTest methodsFor: 'as yet unclassified' stamp: 'HannesHirzel 8/13/2015 12:06'!
testExport1DefaultSheetName

	| wbk  wimported |

	wbk := XLSXImporter import: TabularResources testExcelFile1OneSheetOnly  readStream.
	TabularXSLXExport workbook: wbk fileName: fname.

	wimported := XLSXImporter import: (FileLocator home / fname ) .
	
	self assert: (wimported worksheetNamed: 'Sheet1') name equals: 'Sheet1'.
	self should: [ (wimported worksheetNamed: 'Sheet2') name ] raise: NotFound.

	! !

!TabularExportImportTest methodsFor: 'expected failures' stamp: 'HannesHirzel 8/14/2015 20:26'!
testExport1SheetName
 <expectedFailure>
	| wbk   sheetImported theSheetName wbkimported |
	wbk := XLSXImporter import: TabularResources testExcelFile1OneSheetOnly  readStream.
	theSheetName := 'theTestWorkSheet'.
	wbk worksheets first name: theSheetName.
	TabularXSLXExport workbook: wbk fileName: fname.

	wbkimported := XLSXImporter import: (FileLocator home / fname ) .
	sheetImported := wbkimported worksheetNamed: theSheetName. 
	self assert: sheetImported name equals: theSheetName.
	self should: [ (wbkimported worksheetNamed: 'Sheet2') name ] raise: NotFound.! !

!TabularExportImportTest methodsFor: 'as yet unclassified' stamp: 'HannesHirzel 8/13/2015 05:21'!
testExport2

|  wbk wimported |
	wbk := XLSXImporter import: TabularResources testExcelFile2withThreeSheets   readStream.
		
	TabularXSLXExport workbook: wbk fileName: fname2.
	
	


	! !

!TabularExportImportTest methodsFor: 'as yet unclassified' stamp: 'HannesHirzel 8/14/2015 20:20'!
testExport3
	| wbk  wimported |

	wbk := XLSXImporter import: TabularResources testExcelFile1OneSheetOnly  readStream.
	TabularXSLXExport workbook: wbk fileName: fname3.

	wimported := XLSXImporter import: (FileLocator home / fname3 ) .
	
	self assert: (wimported worksheetNamed: 'Sheet1') name equals: 'Sheet1'.
	self should: [ (wimported worksheetNamed: 'Sheet4') name ] raise: NotFound.
	
	
	! !

!TabularExportImportTest methodsFor: 'tests-numbers' stamp: 'HannesHirzel 8/14/2015 10:40'!
testExport4Numbers

|wbk wsheet  wimported cell |
	wbk := TabularWorkbook new.
	self assert:  (wbk worksheets isEmpty).	
		
	wsheet := TabularWorksheet new.
	wsheet
		at: 1 @ 1 putData: 11;
		at: 2 @ 1 putData: 21;
		at: 3 @ 1 putData: 31.	
	wbk worksheets add: wsheet.
	TabularXSLXExport workbook: wbk fileName: fname4.

	wimported := XLSXImporter import: (FileLocator home / fname4 ) .
	cell := ((wimported worksheetNamed: 'Sheet1') at: 1@1).
	self assert: (cell isKindOf:  TabularCell).
	self assert: (cell data asString= '11').
	self assert: (cell data = 11).  "cell data is aString but should be a number"! !

!TabularExportImportTest methodsFor: 'tests-numbers' stamp: 'HannesHirzel 8/14/2015 10:40'!
testExport4NumbersStringContent

|wbk wsheet  wimported cell |
	wbk := TabularWorkbook new.
	self assert:  (wbk worksheets isEmpty).	
		
	wsheet := TabularWorksheet new.
	wsheet
		at: 1 @ 1 putData: 11;
		at: 2 @ 1 putData: 21;
		at: 3 @ 1 putData: 31.	
	wbk worksheets add: wsheet.
	TabularXSLXExport workbook: wbk fileName: fname4.

	wimported := XLSXImporter import: (FileLocator home / fname4 ) .
	cell := ((wimported worksheetNamed: 'Sheet1') at: 1@1).
	self assert: (cell isKindOf:  TabularCell).
	self assert: (cell data asString= '11').  "content OK"
     "cell data is aString but should be a number"! !

!TabularExportImportTest methodsFor: 'tests-strings' stamp: 'HannesHirzel 8/14/2015 10:39'!
testExport4Strings

|wbk wsheet  wimported cell |
	wbk := TabularWorkbook new.
	self assert:  (wbk worksheets isEmpty).	
		
	wsheet := TabularWorksheet new.
	wsheet
		at: 1 @ 1 putData: 'abc 11';
		at: 2 @ 1 putData: 'def 21';
		at: 3 @ 1 putData: 'ghi 31'.	
	wbk worksheets add: wsheet.
	TabularXSLXExport workbook: wbk fileName: fname4.

	wimported := XLSXImporter import: (FileLocator home / fname4 ) .
	cell := ((wimported worksheetNamed: 'Sheet1') at: 1@1).
	self assert: (cell isKindOf:  TabularCell).
	self assert: (cell data asString= 'abc 11').
	
"The import function cannot deal with the content constructed by the export function. 

How does the import function treat the inlineStr (inline strings). The t property is recognized, but later that assingment to the cell does not take place.
".


'<row r="1">
<c r="A1" t="inlineStr"><is><t>abc 11</t></is></c>
<c r="B1" t="inlineStr"><is><t>def 21</t></is></c>
<c r="C1" t="inlineStr"><is><t>ghi 31</t></is></c>
</row>'

! !

!TabularExportImportTest methodsFor: 'tests-strings' stamp: 'HannesHirzel 8/14/2015 19:17'!
testExport5
|wbk wsheet  wbkimported wsheetimported cell |
	wbk := TabularWorkbook new. wsheet := TabularWorksheet new.
	wsheet
		at: 1 @ 1 putData: 'abc 11';
		at: 2 @ 1 putData: 21.
	wbk worksheets add: wsheet.
		TabularXSLXExport workbook: wbk fileName: fname5.
	wbkimported := XLSXImporter import: (FileLocator home / fname5 ) .
	wsheetimported := wbkimported worksheetNamed: 'Sheet1' .
	cell := wsheetimported at: 1 @ 1.
	self assert: (cell isKindOf:  TabularCell).
	self assert: (cell data asString= 'abc 11').
	cell := wsheetimported at: 2 @ 1.
		self assert: (cell isKindOf:  TabularCell).
	self assert: (cell data = 21).

! !

TestCase subclass: #TabularWorkbookTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Tests'!

!TabularWorkbookTest methodsFor: 'tests' stamp: 'MYI 10/12/2014 16:37'!
testCreation
|w|
	w := TabularWorkbook withSheets: 5.
	self assert: (w worksheets size = 5).
	! !

!TabularWorkbookTest methodsFor: 'tests' stamp: 'MYI 10/12/2014 16:37'!
testCreationEmpty
|w|
	w := TabularWorkbook withSheets: 0.
	self assert:  (w worksheets isEmpty).
	! !

!TabularWorkbookTest methodsFor: 'tests' stamp: 'MYI 10/12/2014 16:37'!
testNew
|w|
	w := TabularWorkbook new.
	self assert:  (w worksheets isEmpty).
	! !

TestCase subclass: #TabularWorksheetTest
	instanceVariableNames: 'ws'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Tests'!

!TabularWorksheetTest methodsFor: 'running' stamp: 'VincentBlondeau 12/10/2014 11:32'!
setUp
	ws := TabularWorksheet new.! !

!TabularWorksheetTest methodsFor: 'tests-accessing' stamp: 'HannesHirzel 8/14/2015 10:33'!
testCells

 self assert: (ws allCoord notNil).  ! !

!TabularWorksheetTest methodsFor: 'tests' stamp: 'HannesHirzel 8/13/2015 17:06'!
testCellsReadingEmptyCell
     
	self assert: ((ws col: 100 row: 100) isNil).  
	
	
	
	
	! !

!TabularWorksheetTest methodsFor: 'tests' stamp: 'HannesHirzel 8/13/2015 05:59'!
testCellsReadingEmptyCell0
      "accessing a cell without data"

       ws col: 1 row: 1 putData: 11.
       ws col: 2 row: 1 putData: 21.

	self assert: (ws col: 1 row: 1) data equals: 11.
	self assert: (ws col: 2 row: 1) data equals: 21.
	
      self assert: ((ws col: 3 row: 1) isNil).   "Is this OK to have nil returned?"
	! !

!TabularWorksheetTest methodsFor: 'tests' stamp: 'HannesHirzel 8/9/2015 14:29'!
testCellsReadingWritingDate
	| endOfTheWorld |
	
	endOfTheWorld := Date year: 2020 month: 12 day: 31.
	ws col: 7 row: 12 putData: endOfTheWorld.
	self assert: (ws col: 7 row: 12) data equals: endOfTheWorld! !

!TabularWorksheetTest methodsFor: 'tests' stamp: 'HannesHirzel 8/9/2015 14:28'!
testCellsReadingWritingInteger

	ws col: 7 row: 12 putData: 1234567890.
	self assert: (ws col: 7 row: 12) data equals: 1234567890.
	! !

!TabularWorksheetTest methodsFor: 'tests' stamp: 'HannesHirzel 8/9/2015 14:27'!
testCellsReadingWritingString

	ws col: 7 row: 12 putData: 'aTest'.
	self assert: ((ws col: 7 row: 12) data = 'aTest').
	! !

!TabularWorksheetTest methodsFor: 'tests-accessing' stamp: 'HannesHirzel 8/13/2015 06:30'!
testFindCellsWithContent

    | result |
    ws col: 1 row: 1 putData: 'Lille'.
    ws col: 2 row: 1 putData: 'Rosario'.
    ws col: 3 row: 1 putData: 'Berne'.
    ws col: 4 row: 1 putData: 'Lille'.

    result := ws findCellsWithContent: 'Lille'.
    self assert: (result isKindOf: Dictionary).
    self assert: (result size =2).

! !

!TabularWorksheetTest methodsFor: 'tests-accessing' stamp: 'HannesHirzel 8/13/2015 06:30'!
testFindCellsWithContent2

    | result |
    ws col: 1 row: 1 putData: 'Lille'.
    ws col: 2 row: 1 putData: 'Rosario'.
    ws col: 3 row: 1 putData: 'Berne'.
    ws col: 4 row: 1 putData: 'Lille'.

    result := ws findCellsWithContent: 'll'.
    self assert: (result isKindOf: Dictionary).
    self deny: (result size =2).

! !

!TabularWorksheetTest methodsFor: 'tests-accessing' stamp: 'HannesHirzel 8/13/2015 06:19'!
testName

 self assert: (ws name notNil).  
 self assert: (ws name = 'New sheet').  
! !

!TabularWorksheetTest methodsFor: 'expected failures' stamp: 'HannesHirzel 8/13/2015 17:07'!
testRID
 <expectedFailure>
self assert: (ws rID notNil).  

"what should be the default value? Or is it OK to have it nil?"
"ws rID inspect"
 ! !

!TabularWorksheetTest methodsFor: 'tests' stamp: 'HannesHirzel 8/13/2015 05:59'!
testReadingFromEmptyTable

     "this is similar to testCellsReadingEmptyCell0"

	self assert: (ws col: 1 row: 10) isNil! !

!TabularWorksheetTest methodsFor: 'expected failures' stamp: 'VincentBlondeau 1/13/2015 13:51'!
testResizingOnTableFillingByData
	<expectedFailure>
	self assert: ws sizeOfWorksheet equals: 0 @ 0.
	ws col: 2 row: 100 putData: 1.
	self assert: ws sizeOfWorksheet equals: 100 @ 2.
	ws col: 2 row: 100 putData: 2.
	self assert: ws sizeOfWorksheet equals: 100 @ 100! !

!TabularWorksheetTest methodsFor: 'expected failures' stamp: 'HannesHirzel 8/13/2015 17:07'!
testSheetId
 <expectedFailure>
 self assert: (ws sheetId notNil).  

"What should this return?"! !

!TabularWorksheetTest methodsFor: 'expected failures' stamp: 'HannesHirzel 8/14/2015 20:25'!
testSizeOfEmptyTable
<expectedFailure>
	self assert: ws maxNumOfColumns equals: 0.
	self assert: ws maxNumOfRows equals: 0.
	self assert: ws sizeOfWorksheet equals: 0 @ 0! !

!TabularWorksheetTest methodsFor: 'expected failures' stamp: 'VincentBlondeau 1/13/2015 13:50'!
testTitleToStringConversion
	<expectedFailure>
	| ss |
	ss spreadsheetTitle: (Date current).
	self assert: (ss spreadsheetTitle isKindOf: String).
	
! !

!TabularWorksheetTest methodsFor: 'tests' stamp: 'HannesHirzel 8/14/2015 10:29'!
testValueErasing
	ws at: 4@3 putData: 'test'.
	self assert: (ws allCoord includes: 4@3).

	"Nil writing should erase the data"
	ws col: 4 row: 3 putData: nil. 
	self deny: (ws allCoord includes: 4@3).
! !

!TabularWorksheetTest methodsFor: 'tests' stamp: 'VincentBlondeau 1/13/2015 13:49'!
testValueWriting
	ws at: 4 @ 3 putData: 'test'.
	ws col: 5 row: 3 putData: 777.
	self assert: (ws at: 5 @ 3) data equals: 777.
	self assert: (ws col: 4 row: 3) data equals: 'test'! !

TestCase subclass: #TabularXLSXExportTest
	instanceVariableNames: 'worksheet fname4 fname5 fname6 fname7 fname8'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Tests'!

!TabularXLSXExportTest methodsFor: 'as yet unclassified' stamp: 'HannesHirzel 8/13/2015 10:31'!
setUp
    

    fname4 := 'TabularConstructed4Exported.xlsx'.
    fname5 := 'TabularConstructed5Exported.xlsx'.
    fname6 := 'TabularConstructed6Exported.xlsx'.
    fname7 := 'TabularConstructed7Exported.xlsx'.
    fname8 := 'TabularConstructed8ExportedSharedStringsAnalysis.xlsx'.


! !

!TabularXLSXExportTest methodsFor: 'as yet unclassified' stamp: 'HannesHirzel 8/13/2015 07:57'!
testExport4

|wbk wsheet    |
	wbk := TabularWorkbook new.
	self assert:  (wbk worksheets isEmpty).	
		
	wsheet := TabularWorksheet new.
	wsheet
		at: 1 @ 1 putData: 11;
		at: 2 @ 1 putData: 21;
		at: 3 @ 1 putData: 31.	
	wbk worksheets add: wsheet.
	TabularXSLXExport workbook: wbk fileName: fname4.
	
	"manual inspection shows that the exported file is fine"
! !

!TabularXLSXExportTest methodsFor: 'as yet unclassified' stamp: 'HannesHirzel 8/13/2015 08:02'!
testExport5

|wbk wsheet    |
	wbk := TabularWorkbook new.
	self assert:  (wbk worksheets isEmpty).	
		
	wsheet := TabularWorksheet new.
	wsheet
		at: 1 @ 1 putData: 11;
		at: 2 @ 1 putData: 21;
		at: 3 @ 1 putData: 31;
			
		at: 9 @ 9 putData: 99.		
	wbk worksheets add: wsheet.
	TabularXSLXExport workbook: wbk fileName: fname5.
	
	"manual inspection shows that the exported file is fine"
! !

!TabularXLSXExportTest methodsFor: 'as yet unclassified' stamp: 'HannesHirzel 8/13/2015 08:05'!
testExport6

|wbk wsheet    |
	wbk := TabularWorkbook new.
	self assert:  (wbk worksheets isEmpty).	
		
	wsheet := TabularWorksheet new.
	wsheet
		at: 1 @ 1 putData: 'aaa';
		at: 2 @ 1 putData: 'bbb';
		at: 3 @ 1 putData: 'ccc'.	
	wbk worksheets add: wsheet.
	TabularXSLXExport workbook: wbk fileName: fname6.
	
	"manual inspection shows that the exported file is fine"
! !

!TabularXLSXExportTest methodsFor: 'as yet unclassified' stamp: 'HannesHirzel 8/14/2015 10:31'!
testExport7

|wbk wsheet    |
	wbk := TabularWorkbook new.
	self assert:  (wbk worksheets isEmpty).	
		
	wsheet := TabularWorksheet new.
	wsheet
		at: 1 @ 1 putData: 'aaa';
		at: 3 @ 1 putData: 'ccc'.	
      (wsheet cellAt: 1 @ 1) colspan: 1.
			
	wbk worksheets add: wsheet.
	TabularXSLXExport workbook: wbk fileName: fname7.
	
	"manual inspection shows that the exported file is fine"
	"But is the colspan command fine? Add a colspan test to TabularCell"
! !

!TabularXLSXExportTest methodsFor: 'as yet unclassified' stamp: 'HannesHirzel 8/14/2015 10:32'!
testExport7b
"the same test as testExport7 but uses regular way of adressing spreadsheet cells"

|wbk wsheet    |
	wbk := TabularWorkbook new.
	self assert:  (wbk worksheets isEmpty).	
		
	wsheet := TabularWorksheet new.
	wsheet
		at: 'A1' asPoint putData: 'aaa';
		at: 'C1' asPoint putData: 'ccc'.	
      (wsheet cellAt: 'A1' asPoint) colspan: 1.
			
	wbk worksheets add: wsheet.
	TabularXSLXExport workbook: wbk fileName: fname7.
	
	"manual inspection shows that the exported file is fine"
	"But is the colspan command fine? Add a colspan test to TabularCell"
! !

!TabularXLSXExportTest methodsFor: 'as yet unclassified' stamp: 'HannesHirzel 8/13/2015 10:46'!
testExport8
	| wbk wsheet myString |
	wbk := TabularWorkbook new.
	myString := 'abcdefghijklmnopqrstuvwxyz 1234567890'.
	self assert: wbk worksheets isEmpty.
	wsheet := TabularWorksheet new.
	wsheet
		at: 'A1' asPoint putData: myString;
		at: 'A2' asPoint putData: myString;
		at: 'A3' asPoint putData: myString;
		at: 'A4' asPoint putData: myString;
		at: 'A5' asPoint putData: myString;
		at: 'A6' asPoint putData: myString;
		at: 'A7' asPoint putData: myString;
		at: 'A8' asPoint putData: myString;
		at: 'A9' asPoint putData: myString.
	wbk worksheets add: wsheet.
	TabularXSLXExport workbook: wbk fileName: fname8.
	
	"manual inspection shows that the exported file is fine"	
	
     "The generated code"

'<row r="2">
<c r="A2" t="inlineStr"><is><t>abcdefghijklmnopqrstuvwxyz 1234567890</t></is></c></row>'
! !

TestCase subclass: #TabularXLSXImporterTest1
	instanceVariableNames: 'workbook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Tests'!

!TabularXLSXImporterTest1 methodsFor: 'running' stamp: 'HannesHirzel 8/11/2015 21:12'!
setUp
	| file |
	file := TabularResources testExcelFile1OneSheetOnly  readStream.
	workbook := XLSXImporter import: file! !

!TabularXLSXImporterTest1 methodsFor: 'tests' stamp: 'HannesHirzel 8/14/2015 15:37'!
testAccessElementFromASheet
	self assert: (((workbook worksheetNamed: 'Sheet1') at: 3@9) data = 39).! !

!TabularXLSXImporterTest1 methodsFor: 'tests' stamp: 'HannesHirzel 8/11/2015 21:14'!
testAccessSheetByName
	self assert: (workbook worksheetNamed: 'Sheet1') name equals: 'Sheet1'.
	self should: [ (workbook worksheetNamed: 'Sheet2') name ] raise: NotFound! !

TestCase subclass: #TabularXLSXImporterTest2
	instanceVariableNames: 'workbook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Tests'!

!TabularXLSXImporterTest2 methodsFor: 'running' stamp: 'HannesHirzel 8/11/2015 21:00'!
setUp
	| file |
	file := TabularResources testExcelFile2withThreeSheets readStream.
	workbook := XLSXImporter import: file! !

!TabularXLSXImporterTest2 methodsFor: 'tests' stamp: 'HannesHirzel 8/13/2015 09:27'!
testAccessElementFromASheet

     | worksheet |
worksheet := workbook worksheetNamed: 'Feuil1'.
	self assert: ((worksheet at: 1@1) data = 'concatenation table').
! !

!TabularXLSXImporterTest2 methodsFor: 'tests' stamp: 'HannesHirzel 8/14/2015 19:06'!
testAccessNumberElementFromASheet

     | worksheet cell |

	worksheet := workbook worksheetNamed: 'Feuil1'.
	cell := worksheet at: 'A3' asPoint.
	self assert: (cell data = '1').
	
! !

!TabularXLSXImporterTest2 methodsFor: 'tests' stamp: 'VincentBlondeau 1/12/2015 15:41'!
testAccessSheetByName
	self assert: (workbook worksheetNamed: 'Feuil1') name equals: 'Feuil1'.
	self assert: (workbook worksheetNamed: 'Feuil2') name equals: 'Feuil2'.
	self assert: (workbook worksheetNamed: 'Feuil3') name equals: 'Feuil3'.
	self should: [ (workbook worksheetNamed: 'Feuil4') name ] raise: NotFound! !

!TabularXLSXImporterTest2 methodsFor: 'tests' stamp: 'VincentBlondeau 1/13/2015 13:54'!
testColumnConversion
	self assert: 'A1' asPoint equals: 1 @ 1.
	self assert: 'B3' asPoint equals: 2 @ 3.
	self assert: 'AA321' asPoint equals: 27 @ 321! !

!TabularXLSXImporterTest2 methodsFor: 'tests' stamp: 'VincentBlondeau 12/11/2014 15:13'!
testImport
	self assert: (workbook isKindOf: TabularWorkbook)! !

!TabularXLSXImporterTest2 methodsFor: 'tests' stamp: 'VincentBlondeau 12/11/2014 14:50'!
testNumberOfSheetsIs3
	self assert: workbook worksheets size equals: 3! !

TestCase subclass: #TabularXLSXImporterTest3
	instanceVariableNames: 'workbook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Tests'!

!TabularXLSXImporterTest3 methodsFor: 'as yet unclassified' stamp: 'HannesHirzel 8/12/2015 05:14'!
setUp
	| file |
	file := TabularResources testExcelFile3WithAlignment  readStream.
	workbook := XLSXImporter import: file! !

!TabularXLSXImporterTest3 methodsFor: 'as yet unclassified' stamp: 'HannesHirzel 8/13/2015 06:02'!
testAccessSheetByName
	self assert: (workbook worksheetNamed: 'Sheet1') name equals: 'Sheet1'.
	self should: [ (workbook worksheetNamed: 'Sheet2') name ] raise: NotFound! !

!Date class methodsFor: '*Tabular' stamp: 'VincentBlondeau 1/12/2015 17:37'!
fromExcelDays: dayCount 
	"Days since 1 January 1900"

	^ self julianDayNumber: SqueakEpoch + dayCount - 366 "It is supposed by excel that 1900 is a leap year...."! !

SAXHandler subclass: #TabularSAXParser
	instanceVariableNames: 'parsingStack saxStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-SAXParser'!

!TabularSAXParser commentStamp: 'MYI 8/4/2015 14:45' prior: 0!
TabularSAXParser is engine for even-simpler SAX-style XML parsing.

It was made for using by TabularImporter subclasses for XML-based speadsheets formats, but really it is not linked with Tabular at all, and may be used for other purposes aswell.

=========

Short manual:

1) Subclass me
2) implement a #registeredElements with the collection of tag names you are interested in
3) implement methods like #sometag_start: , #sometag_end , #sometag_characters: - you should substitute #sometag with one of the registered names
4) implement a #buildRootObject method, which will build...ehh...root object for you generated DOM

Methods from step 3 will be called as usual #startElement: , #endElements and #characters: for SAX parsers, but only for the tags with the appropriate names.
!

!TabularSAXParser class methodsFor: 'as yet unclassified' stamp: 'MYI 8/4/2015 09:20'!
generateMethods: aBuilder
	<nautilusGlobalClassMenu>
	| selectedClass |
	selectedClass := aBuilder model selectedClass.
	
	(aBuilder item: #'Generate XML elements handlers')
		action: [ selectedClass new generateMethodsForRegisteredElements ].
! !

!TabularSAXParser methodsFor: 'initialization' stamp: 'MYI 8/4/2015 13:29'!
buildRootObject
	^nil! !

!TabularSAXParser methodsFor: 'handling - content' stamp: 'MYI 8/4/2015 09:46'!
characters: aString
| aQualifiedName |
	aQualifiedName := saxStack top.
	(self registeredElements includes: aQualifiedName)
		ifTrue: [ self performIfExists: (self charactersMethodFor: aQualifiedName) with: aString ].! !

!TabularSAXParser methodsFor: 'private' stamp: 'MYI 8/4/2015 09:43'!
charactersMethodFor: aQualifiedName
	^(aQualifiedName, '_characters:') asSymbol! !

!TabularSAXParser methodsFor: 'handling - content' stamp: 'MYI 8/4/2015 09:42'!
endElement: aQualifiedName
	(self registeredElements includes: aQualifiedName)
		ifTrue: [ self performIfExists: (self endMethodFor: aQualifiedName)].
	saxStack pop.! !

!TabularSAXParser methodsFor: 'private' stamp: 'MYI 8/3/2015 07:00'!
endMethodFor: aQualifiedName
	^(aQualifiedName, '_end') asSymbol! !

!TabularSAXParser methodsFor: 'private' stamp: 'MYI 8/4/2015 12:53'!
generateMethod: aSymbol
	(self respondsTo: aSymbol) ifTrue: [^self]. "Do not override existing methods!!" 
	
	aSymbol endsWithAColon
		ifTrue: [self class compile: aSymbol, ' properties', Character cr asString, Character tab asString]
		ifFalse: [self class compile: aSymbol, Character cr asString, Character tab asString]
! !

!TabularSAXParser methodsFor: 'private' stamp: 'MYI 8/4/2015 12:54'!
generateMethodsForRegisteredElements
	self registeredElements do:[:elementName|
		self generateMethod: (self startMethodFor: elementName).
		self generateMethod: (self endMethodFor: elementName).
		self generateMethod: (self charactersMethodFor: elementName).
	]! !

!TabularSAXParser methodsFor: 'initialization' stamp: 'MYI 8/4/2015 13:29'!
initialize
	super initialize.
	parsingStack := Stack new.
	self buildRootObject ifNotNilDo: [:obj| parsingStack push: obj].
	saxStack := Stack new.
! !

!TabularSAXParser methodsFor: 'parsing' stamp: 'MYI 8/3/2015 07:38'!
parsingResult
	^ parsingStack top.! !

!TabularSAXParser methodsFor: 'private' stamp: 'MYI 8/3/2015 07:01'!
performIfExists: aSymbol
	^ (self respondsTo: aSymbol)
		ifTrue: [ self perform: aSymbol].! !

!TabularSAXParser methodsFor: 'private' stamp: 'MYI 8/3/2015 06:59'!
performIfExists: aSymbol with: anObject
	^ (self respondsTo: aSymbol)
		ifTrue: [ self perform: aSymbol with: anObject].! !

!TabularSAXParser methodsFor: 'elements' stamp: 'MYI 8/4/2015 13:02'!
registeredElements
"This should return collection of names of the elements, which will be handled by this parser. For example:
	^#(html head body table)
"
	^self shouldBeImplemented ! !

!TabularSAXParser methodsFor: 'handling - content' stamp: 'MYI 8/4/2015 09:42'!
startElement: aQualifiedName attributes: aDictionary
	saxStack push: aQualifiedName.
	(self registeredElements includes: aQualifiedName)
		ifTrue: [ self performIfExists: (self startMethodFor: aQualifiedName) with: aDictionary]! !

!TabularSAXParser methodsFor: 'private' stamp: 'MYI 8/2/2015 17:16'!
startMethodFor: aQualifiedName
	^(aQualifiedName, '_start:') asSymbol! !

TabularSAXParser subclass: #XLSXRelsParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-SAXParser'!

!XLSXRelsParser methodsFor: 'as yet unclassified' stamp: 'MYI 8/4/2015 14:08'!
Relationship_start: properties
	parsingStack top at: (properties at: #Id) put: (properties at: #Target)! !

!XLSXRelsParser methodsFor: 'as yet unclassified' stamp: 'MYI 8/4/2015 13:32'!
buildRootObject
	^ Dictionary new.! !

!XLSXRelsParser methodsFor: 'as yet unclassified' stamp: 'MYI 8/4/2015 13:41'!
registeredElements
	^ #(Relationship)! !

TabularSAXParser subclass: #XLSXSharedStringsParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-SAXParser'!

!XLSXSharedStringsParser methodsFor: 'initialization' stamp: 'MYI 8/4/2015 13:30'!
buildRootObject
	^ OrderedCollection new.! !

!XLSXSharedStringsParser methodsFor: 'elements' stamp: 'MYI 8/4/2015 07:06'!
registeredElements
	^ #(si t)! !

!XLSXSharedStringsParser methodsFor: 'acccessing' stamp: 'MYI 8/4/2015 09:54'!
sharedStringsTable
	^parsingStack top! !

!XLSXSharedStringsParser methodsFor: 'elements' stamp: 'MYI 8/4/2015 09:50'!
si_start: properties
	self sharedStringsTable add: nil.! !

!XLSXSharedStringsParser methodsFor: 'elements' stamp: 'VincentBlondeau 8/6/2015 10:57'!
t_characters: aString
	| table |
	table := self sharedStringsTable.
	table atLast: 1 put: (table last ifNil: [ aString ] ifNotNil: [ :str | str , aString ])	"whe we have multiple <t> inside <si>, which is possible if in-cell formatting used"! !

TabularSAXParser subclass: #XLSXSheetParser
	instanceVariableNames: 'rowCounter colCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-SAXParser'!

!XLSXSheetParser class methodsFor: 'as yet unclassified' stamp: 'HannesHirzel 8/14/2015 09:30'!
parse: aStringOrStream
	"Parse document in argument string or stream; method inserted for debugging purposes."

	| sheet |
	sheet := super parse: aStringOrStream.
	"self halt."
	^ sheet! !

!XLSXSheetParser methodsFor: 'initialization' stamp: 'MYI 8/4/2015 13:31'!
buildRootObject
	^ TabularWorksheet new.! !

!XLSXSheetParser methodsFor: 'elements' stamp: 'MYI 8/3/2015 07:58'!
c_end
	parsingStack pop.
	colCounter := colCounter + 1.! !

!XLSXSheetParser methodsFor: 'elements' stamp: 'HannesHirzel 8/14/2015 15:30'!
c_start: properties
|cell coord|
	cell := TabularCell new.

	properties at: #s ifPresent:[:styleId| cell style: styleId]. "Should be substituted by actual style upon finalisation"
	properties at: #t ifPresent:[:type| cell attributeAt: 'xlsx:t' put: type. cell type: type].

	properties at: #r ifPresent: [:r| coord := r asPoint].
	coord
		ifNil: [ coord := colCounter @ rowCounter  ]
		ifNotNil: [ colCounter := coord x ]. "It's expected that row of r attribute is always points to current row. If it is not - have no idea how to manage this"
	
	self worksheet at: coord putCell: cell.
		
	parsingStack push: cell.! !

!XLSXSheetParser methodsFor: 'accessing' stamp: 'MYI 8/3/2015 08:16'!
cell
| current |
	current := parsingStack top.
	^current isTabularCell
		ifTrue: [ current ]
		ifFalse: [ self error: '(Tabular)Cell expected at this stage of parsing, but found: ', current class name]! !

!XLSXSheetParser methodsFor: 'initialization' stamp: 'MYI 8/4/2015 13:31'!
initialize
	super initialize.
	colCounter := 1.
	rowCounter := 1.
! !

!XLSXSheetParser methodsFor: 'as yet unclassified' stamp: 'MYI 8/3/2015 08:16'!
parsingResult
	^ self worksheet! !

!XLSXSheetParser methodsFor: 'handling - content' stamp: 'HannesHirzel 8/14/2015 14:58'!
registeredElements
	^ #(row c v t)! !

!XLSXSheetParser methodsFor: 'elements' stamp: 'MYI 8/3/2015 07:55'!
row_end
	rowCounter := rowCounter + 1.! !

!XLSXSheetParser methodsFor: 'elements' stamp: 'VincentBlondeau 8/6/2015 10:54'!
row_start: properties
	properties at: 'r' ifPresent: [ :r | rowCounter := r asNumber ].
	colCounter := 1! !

!XLSXSheetParser methodsFor: 'elements' stamp: 'HannesHirzel 8/14/2015 14:59'!
t_characters: aString
	self cell data: aString.! !

!XLSXSheetParser methodsFor: 'elements' stamp: 'HannesHirzel 8/14/2015 15:35'!
v_characters: aString
"maybe the test below is not necessary as the type is always number in a v tag?"
(self cell type = 'n' "number") ifTrue: [ self cell data: aString  asNumber ] 
	ifFalse: [self cell data: aString].! !

!XLSXSheetParser methodsFor: 'accessing' stamp: 'VincentBlondeau 8/6/2015 10:58'!
worksheet
	| current |
	current := parsingStack top.
	^ current isTabularWorksheet
		ifTrue: [ current ]
		ifFalse: [ self error: '(Tabular)Worksheet expected at this stage of parsing, but found: ' , current class name ]! !

TabularSAXParser subclass: #XLSXWorkbookParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-SAXParser'!

!XLSXWorkbookParser methodsFor: 'as yet unclassified' stamp: 'MYI 8/4/2015 14:08'!
buildRootObject
	^ StandardOrderedDictionary new.! !

!XLSXWorkbookParser methodsFor: 'as yet unclassified' stamp: 'MYI 8/4/2015 14:03'!
registeredElements
	^ #(sheet)! !

!XLSXWorkbookParser methodsFor: 'as yet unclassified' stamp: 'MYI 8/4/2015 14:08'!
sheet_start: properties
	parsingStack top at: (properties at: #r:id) put: (properties at: #name)! !

Object subclass: #TabularExport
	instanceVariableNames: 'workbook sheet stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Exporters'!

!TabularExport commentStamp: 'HannesHirzel 8/9/2015 09:23' prior: 0!
I am TabularExport the root of a class of objects which export Tabular models.

Usage example:   

    TabularNNNNExport on: aWorkbook


NEXT STEP: add subclass  TabularHTMLExport1

Responsibility part: I define the general export API every export class supports.

Note: The API is not  fully defined yet.  Subclass TabularXSLXExport1 has hard coded parameters.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!TabularExport class methodsFor: 'examples' stamp: 'HannesHirzel 8/9/2015 11:52'!
example1

    self export: (TabularWorkbook example1)! !

!TabularExport class methodsFor: 'exporting' stamp: 'HannesHirzel 8/9/2015 11:51'!
export: aWorkbook

      self new workbook: aWorkbook; generate.! !

!TabularExport class methodsFor: 'exporting' stamp: 'HannesHirzel 8/9/2015 11:56'!
export: aWorkbook fileName: aFileNameString

      aWorkbook filename: aFileNameString.
      self new workbook: aWorkbook; generate.! !

!TabularExport class methodsFor: 'exporting' stamp: 'HannesHirzel 8/9/2015 11:59'!
export: aWorkbook stream: aStream

   self halt.

"Implementation ???"! !

!TabularExport class methodsFor: 'exporting' stamp: 'HannesHirzel 8/9/2015 12:01'!
workbook: aWorkbook fileName: aFileNameString

      self export: aWorkbook fileName: aFileNameString
      ! !

!TabularExport methodsFor: 'accessing' stamp: 'HannesHirzel 8/9/2015 08:36'!
cellName: coord
	^((self columnName: coord x), (coord y asString))! !

!TabularExport methodsFor: 'accessing' stamp: 'HannesHirzel 8/9/2015 08:36'!
columnName: n
	(n <= 26) ifTrue: [^(Character value: 64 + n) asString].
	
	^(self columnName: ((n-1) quo: 26)), (self columnName: ((n-1) rem: 26) +1 )! !

!TabularExport methodsFor: 'generating' stamp: 'HannesHirzel 8/9/2015 08:47'!
generate

	self subclassResponsibility ! !

!TabularExport methodsFor: 'initialization' stamp: 'HannesHirzel 8/9/2015 09:12'!
initialize

     super initialize! !

!TabularExport methodsFor: 'accessing' stamp: 'HannesHirzel 8/9/2015 08:54'!
workbook
	^ workbook! !

!TabularExport methodsFor: 'accessing' stamp: 'HannesHirzel 8/13/2015 05:32'!
workbook: anObject
	workbook := anObject.
	workbook worksheets isEmpty ifFalse: [ sheet := workbook worksheets first  "Limitation: only first worksheet is exported"]
									ifTrue: [ sheet := TabularWorksheet new ] 
	! !

TabularExport subclass: #TabularXSLXExport
	instanceVariableNames: 'zip writer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Exporters'!

!TabularXSLXExport commentStamp: 'HannesHirzel 8/9/2015 17:00' prior: 0!
I am TabularXSLXExport and exports worksheets to Excel XSLX file format.

NEXT STEPS:

1. Make workbook export functional. Currently only the first sheet is exported.
2. Add more test cases and examples.
3. Create a class TabularDOCXExport as a copy of this class and make it work.


LIMITATIONS:

see example2



!

!TabularXSLXExport class methodsFor: 'examples' stamp: 'HannesHirzel 8/9/2015 15:40'!
example1

    self workbook: (TabularWorkbook example1) fileName: 'TabularTest1.xlsx'! !

!TabularXSLXExport class methodsFor: 'examples' stamp: 'HannesHirzel 8/9/2015 17:24'!
example2
"round trip"
 | workbook |

self halt. "does not work yet"
self workbook: (TabularWorkbook example1) fileName: 'TabularTest2Export.xlsx'.

workbook := XLSXImporter import: (FileLocator home / 'TabularTest2Export.xlsx') asFileReference.

self workbook: (TabularWorkbook example1) fileName: 'TabularTest2ExportAndReimported.xlsx'.! !

!TabularXSLXExport class methodsFor: 'examples' stamp: 'HannesHirzel 8/11/2015 21:01'!
example3

    | file workbook |
	file := TabularResources testExcelFile3WithAlignment readStream.
	workbook := XLSXImporter import: file.

    self workbook: workbook fileName: 'TabularTest2WithAlingment.xlsx'

"merged cells are not properly rendered; alingment is not rendered"! !

!TabularXSLXExport methodsFor: 'files' stamp: 'HannesHirzel 8/13/2015 08:43'!
content_types_xml

" [Content_Types].xml file, this describes the location of the major files in the archive and the standards to which it itself adheres and the content types of those files. 

hard coded at the moment, should be constructed later, I Hannes Hirzel assume.
"

^'<?xml version="1.0" encoding="UTF-8"?>
<Types xmlns="http://schemas.openxmlformats.org/package/2006/content-types">

<Override PartName="/_rels/.rels" ContentType="application/vnd.openxmlformats-package.relationships+xml"/><Override PartName="/docProps/app.xml" ContentType="application/vnd.openxmlformats-officedocument.extended-properties+xml"/>

<Override PartName="/docProps/core.xml" ContentType="application/vnd.openxmlformats-package.core-properties+xml"/>

<Override PartName="/xl/_rels/workbook.xml.rels" ContentType="application/vnd.openxmlformats-package.relationships+xml"/><Override PartName="/xl/sharedStrings.xml" ContentType="application/vnd.openxmlformats-officedocument.spreadsheetml.sharedStrings+xml"/>

<Override PartName="/xl/worksheets/sheet1.xml" ContentType="application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml"/>

<Override PartName="/xl/styles.xml" ContentType="application/vnd.openxmlformats-officedocument.spreadsheetml.styles+xml"/><Override PartName="/xl/workbook.xml" ContentType="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml"/>
</Types>'.! !

!TabularXSLXExport methodsFor: 'files' stamp: 'HannesHirzel 8/12/2015 07:24'!
content_types_xmlOLD
^'<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<Types xmlns="http://schemas.openxmlformats.org/package/2006/content-types">
  <Default Extension="rels" ContentType="application/vnd.openxmlformats-package.relationships+xml"/>
  <Override PartName="/workbook.xml" ContentType="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml"/>
  <Override PartName="/worksheet.xml" ContentType="application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml"/>
</Types>'.! !

!TabularXSLXExport methodsFor: 'files' stamp: 'HannesHirzel 8/12/2015 10:26'!
docPropsApp_xml
^'<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<Properties xmlns="http://schemas.openxmlformats.org/officeDocument/2006/extended-properties" xmlns:vt="http://schemas.openxmlformats.org/officeDocument/2006/docPropsVTypes">

<TotalTime>125</TotalTime>

<Application>TabularExport </Application>

</Properties>'.! !

!TabularXSLXExport methodsFor: 'files-docPropsCore' stamp: 'HannesHirzel 8/13/2015 09:03'!
docPropsCore_xml
^ self docPropsCore_xml_1,
self docPropsCore_xml_2_creation_date ,
self docPropsCore_xml_3 ! !

!TabularXSLXExport methodsFor: 'files-docPropsCore' stamp: 'HannesHirzel 8/13/2015 09:04'!
docPropsCore_xml_1
^'<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<cp:coreProperties xmlns:cp="http://schemas.openxmlformats.org/package/2006/metadata/core-properties" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:dcterms="http://purl.org/dc/terms/" xmlns:dcmitype="http://purl.org/dc/dcmitype/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">

'.! !

!TabularXSLXExport methodsFor: 'files-docPropsCore' stamp: 'HannesHirzel 8/13/2015 09:07'!
docPropsCore_xml_2_creation_date
^'
<dcterms:created xsi:type="dcterms:W3CDTF">',

DateAndTime now asString,

'</dcterms:created>

<dc:creator>tabular </dc:creator><dc:language>en-GB</dc:language>
'.! !

!TabularXSLXExport methodsFor: 'files-docPropsCore' stamp: 'HannesHirzel 8/13/2015 09:05'!
docPropsCore_xml_3
^'
<cp:revision>1</cp:revision>

</cp:coreProperties>
'.! !

!TabularXSLXExport methodsFor: 'files' stamp: 'HannesHirzel 8/13/2015 08:52'!
generate
   
	| fname |
	zip:= ZipArchive new.
	fname := workbook filename.
	zip addString: self content_types_xml as: '[Content_Types].xml'.
	zip addString: self rels as: '_rels/.rels'.

	zip addString: self docPropsApp_xml as: 'docProps/app.xml'.
	zip addString: self docPropsCore_xml as: 'docProps/core.xml'.

    "Everything outside the xl/ folder is just meta data"

	zip addString: self workbook_xml as: 'xl/workbook.xml'.
	zip addString: self sharedStrings_xml  as: 'xl/sharedStrings.xml'.
	zip addString: self styles_xml   as: 'xl/styles.xml'.
	
	zip addString: self worksheet_xml as: 'xl/worksheets/sheet1.xml'.
	zip addString: self workbook_xml_rels as: 'xl/_rels/workbook.xml.rels'.

	zip writeToFileNamed: (FileLocator home / fname ).
	! !

!TabularXSLXExport methodsFor: 'files' stamp: 'HannesHirzel 8/12/2015 07:27'!
generateOLD
   
	| fname |
	zip:= ZipArchive new.
	fname := workbook filename.
	zip addString: self workbook_xml as: 'workbook.xml'.
	zip addString: self worksheet_xml as: 'worksheet.xml'.
	zip addString: self content_types_xmlOLD as: '[Content_Types].xml'.
	zip addString: self relsOLD as: '_rels/.rels'.
	zip addString: self workbook_xml_rels as: '_rels/workbook.xml.rels'.
	zip writeToFileNamed: (FileLocator home / fname ).
	! !

!TabularXSLXExport methodsFor: 'rendering' stamp: 'HannesHirzel 8/14/2015 10:12'!
mergeCells
|res|
	res := Dictionary new.
	sheet cellsKeysAndValuesDo: [:coord :cell|
		(cell colspan notNil | cell rowspan notNil) ifTrue:[ |offset|
			offset := (cell colspan ifNil:[0]) @ (cell rowspan ifNil:[0]). "Should upgrade it with Protected Arithmetic"
			res at: coord put: (coord + offset).
		].
	].
	^res.! !

!TabularXSLXExport methodsFor: 'files' stamp: 'HannesHirzel 8/12/2015 07:45'!
rels
^'<?xml version="1.0" encoding="UTF-8"?>
<Relationships xmlns="http://schemas.openxmlformats.org/package/2006/relationships">

<Relationship Id="rId1" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/officeDocument" Target="xl/workbook.xml"/>

<Relationship Id="rId2" Type="http://schemas.openxmlformats.org/package/2006/relationships/metadata/core-properties" Target="docProps/core.xml"/>


<Relationship Id="rId3" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/extended-properties" Target="docProps/app.xml"/>

</Relationships>'.! !

!TabularXSLXExport methodsFor: 'files' stamp: 'HannesHirzel 8/12/2015 07:43'!
relsOLD
^'<?xml version="1.0" encoding="UTF-8"?>
<Relationships xmlns="http://schemas.openxmlformats.org/package/2006/relationships">

<Relationship Id="rId1" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/officeDocument" Target="xl/workbook.xml"/>

<Relationship Id="rId2" Type="http://schemas.openxmlformats.org/package/2006/relationships/metadata/core-properties" Target="docProps/core.xml"/>


<Relationship Id="rId3" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/extended-properties" Target="docProps/app.xml"/>

</Relationships>'.! !

!TabularXSLXExport methodsFor: 'rendering' stamp: 'HannesHirzel 8/14/2015 10:08'!
renderCell: coord
	| cell |
	cell := sheet cellAt: coord.
	^ cell data isNumber
		ifTrue: [ self renderCellWithNumber: coord ]
		ifFalse: [ 
			(cell data isKindOf: Date)
				ifTrue: [ self renderCellWithDate: coord ]
				ifFalse: [ self renderCellWithString: coord ] ]! !

!TabularXSLXExport methodsFor: 'rendering' stamp: 'HannesHirzel 8/9/2015 14:36'!
renderCellWithDate: coord
	writer tag
		name: 'c';
		attributeAt: 'r' put: (self cellName: coord);
		attributeAt: 't' put: 'inlineStr';
		with:[ writer tag: 'is' with: [ writer tag: 't' with: ((sheet cells at: coord) data ddmmyyyy)]]! !

!TabularXSLXExport methodsFor: 'rendering' stamp: 'HannesHirzel 8/14/2015 10:27'!
renderCellWithNumber:  coord
	writer tag
		name: 'c';
		attributeAt: 'r' put: (self cellName: coord);
		attributeAt: 't' put: 'n';
		with:[ writer tag: 'v' with: ((sheet cellAt: coord) data asString)]! !

!TabularXSLXExport methodsFor: 'rendering' stamp: 'HannesHirzel 8/14/2015 10:10'!
renderCellWithString: coord
"do NOT use the construction of a file sharedStrings.xml at the moment; all strings are inlineStr"

	writer tag
		name: 'c';
		attributeAt: 'r' put: (self cellName: coord);
		attributeAt: 't' put: 'inlineStr';
		with:[ writer tag: 'is' with: [ writer tag: 't' with: ((sheet cellAt: coord) data asString)]]! !

!TabularXSLXExport methodsFor: 'rendering' stamp: 'HannesHirzel 8/9/2015 12:41'!
renderMergeCells
	self mergeCells ifNotEmptyDo: [ : mergeCells |
		writer tag: 'mergeCells' with:[
			mergeCells keysAndValuesDo: [:topleft :bottomright|
				writer tag
					name: 'mergeCell';
					attributeAt: 'ref' put: ((self cellName: topleft),':', (self cellName: bottomright)).
			]
		]
	 ]
! !

!TabularXSLXExport methodsFor: 'rendering' stamp: 'HannesHirzel 8/14/2015 10:04'!
renderRow: rowN
	| keys |
	keys := (sheet allCoord
	select: [ :coord | coord y = rowN ]) 
	sort: [ :coord1 :coord2 | coord1 x < coord2 x ].	
		
	"cells must be sorted by column in the file"
	keys do: [ :coord | self renderCell: coord ]! !

!TabularXSLXExport methodsFor: 'rendering' stamp: 'HannesHirzel 8/9/2015 12:42'!
renderRows
	sheet rows do:[:rowN|
		writer tag
			name: 'row';
			attributeAt: 'r' put: rowN asString;
			with:[ self renderRow: rowN]
	] ! !

!TabularXSLXExport methodsFor: 'rendering' stamp: 'HannesHirzel 8/9/2015 14:14'!
renderWorksheet
	writer tag
		name: 'worksheet';
		attributeAt: 'xmlns' put: 'http://schemas.openxmlformats.org/spreadsheetml/2006/main';
		attributeAt: 'xmlns:r' put: 'http://schemas.openxmlformats.org/officeDocument/2006/relationships';
		with: [ 
					writer tag: 'sheetData' with: [ self renderRows ].
					self renderMergeCells ]! !

!TabularXSLXExport methodsFor: 'files' stamp: 'HannesHirzel 8/12/2015 12:12'!
sharedStrings_xml
^'<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<sst xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main" count="1" uniqueCount="1">
<si><t> </t></si>
</sst>'.! !

!TabularXSLXExport methodsFor: 'files' stamp: 'HannesHirzel 8/12/2015 12:15'!
styles_xml
^'<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<styleSheet xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main">
<numFmts count="1">
<numFmt numFmtId="164" formatCode="GENERAL"/></numFmts>
<fonts count="4">

<font><sz val="10"/><name val="Arial"/><family val="2"/></font><font><sz val="10"/><name val="Arial"/><family val="0"/></font>

<font><sz val="10"/><name val="Arial"/><family val="0"/></font><font><sz val="10"/><name val="Arial"/><family val="0"/></font>
</fonts>

<fills count="2"><fill><patternFill patternType="none"/></fill><fill><patternFill patternType="gray125"/></fill></fills><borders count="1"><border diagonalUp="false" diagonalDown="false"><left/><right/><top/><bottom/><diagonal/></border></borders><cellStyleXfs count="20"><xf numFmtId="164" fontId="0" fillId="0" borderId="0" applyFont="true" applyBorder="true" applyAlignment="true" applyProtection="true"><alignment horizontal="general" vertical="bottom" textRotation="0" wrapText="false" indent="0" shrinkToFit="false"/><protection locked="true" hidden="false"/></xf><xf numFmtId="0" fontId="1" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="0" fontId="1" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="0" fontId="2" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="0" fontId="2" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="0" fontId="0" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="0" fontId="0" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="0" fontId="0" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="0" fontId="0" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="0" fontId="0" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="0" fontId="0" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="0" fontId="0" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="0" fontId="0" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="0" fontId="0" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="0" fontId="0" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="43" fontId="1" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="41" fontId="1" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="44" fontId="1" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="42" fontId="1" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf><xf numFmtId="9" fontId="1" fillId="0" borderId="0" applyFont="true" applyBorder="false" applyAlignment="false" applyProtection="false"></xf></cellStyleXfs><cellXfs count="1"><xf numFmtId="164" fontId="0" fillId="0" borderId="0" xfId="0" applyFont="false" applyBorder="false" applyAlignment="false" applyProtection="false"><alignment horizontal="general" vertical="bottom" textRotation="0" wrapText="false" indent="0" shrinkToFit="false"/><protection locked="true" hidden="false"/></xf></cellXfs><cellStyles count="6"><cellStyle name="Normal" xfId="0" builtinId="0" customBuiltin="false"/><cellStyle name="Comma" xfId="15" builtinId="3" customBuiltin="false"/><cellStyle name="Comma [0]" xfId="16" builtinId="6" customBuiltin="false"/><cellStyle name="Currency" xfId="17" builtinId="4" customBuiltin="false"/><cellStyle name="Currency [0]" xfId="18" builtinId="7" customBuiltin="false"/><cellStyle name="Percent" xfId="19" builtinId="5" customBuiltin="false"/></cellStyles></styleSheet>'.! !

!TabularXSLXExport methodsFor: 'files' stamp: 'HannesHirzel 8/12/2015 12:10'!
workbook_xml
^'<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<workbook xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main" xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships">
<fileVersion appName="Calc"/>
<workbookPr backupFile="false" showObjects="all" date1904="false"/>
<workbookProtection/>

<bookViews>
<workbookView showHorizontalScroll="true" showVerticalScroll="true" showSheetTabs="true" xWindow="0" yWindow="0" windowWidth="16384" windowHeight="8192" tabRatio="236" firstSheet="0" activeTab="0"/>
</bookViews>

<sheets>
<sheet name="Sheet1" sheetId="1" state="visible" r:id="rId2"/></sheets>

<calcPr iterateCount="100" refMode="A1" iterate="false" iterateDelta="0.001"/>

</workbook>'.! !

!TabularXSLXExport methodsFor: 'files' stamp: 'HannesHirzel 8/12/2015 10:31'!
workbook_xmlOLD
^'<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<workbook xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main" xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships">
  <sheets>
    <sheet name="Page 1" sheetId="1" r:id="rId1"/>
  </sheets>
</workbook>'.! !

!TabularXSLXExport methodsFor: 'files' stamp: 'HannesHirzel 8/12/2015 12:28'!
workbook_xml_rels
^'<?xml version="1.0" encoding="UTF-8"?>
<Relationships xmlns="http://schemas.openxmlformats.org/package/2006/relationships">

<Relationship Id="rId1" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/styles" Target="styles.xml"/>

<Relationship Id="rId2" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/worksheet" Target="worksheets/sheet1.xml"/>

<Relationship Id="rId3" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/sharedStrings" Target="sharedStrings.xml"/>

</Relationships>'.! !

!TabularXSLXExport methodsFor: 'files' stamp: 'HannesHirzel 8/12/2015 12:26'!
workbook_xml_relsOLD
^'<?xml version="1.0" encoding="UTF-8" standalone="yes"?>

<Relationships xmlns="http://schemas.openxmlformats.org/package/2006/relationships">

  <Relationship Id="rId1" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/worksheet" Target="worksheet.xml"/>

</Relationships>'.! !

!TabularXSLXExport methodsFor: 'files' stamp: 'HannesHirzel 8/9/2015 14:45'!
worksheet_xml
	writer := XMLWriter new.
	writer xml standalone: true.
	self renderWorksheet.
	^ writer write contents convertToEncoding: 'utf-8'! !

!TabularXSLXExport methodsFor: 'files' stamp: 'HannesHirzel 8/12/2015 12:25'!
worksheet_xml_example
	^ '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<worksheet xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main" xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships">
<sheetPr filterMode="false">
<pageSetUpPr fitToPage="false"/></sheetPr>
<dimension ref="A1:C9"/>
<sheetViews><sheetView windowProtection="false" showFormulas="false" showGridLines="true" showRowColHeaders="true" showZeros="true" rightToLeft="false" tabSelected="true" showOutlineSymbols="true" defaultGridColor="true" view="normal" topLeftCell="A1" colorId="64" zoomScale="100" zoomScaleNormal="100" zoomScalePageLayoutView="100" workbookViewId="0"><selection pane="topLeft" activeCell="C10" activeCellId="0" sqref="C10"/></sheetView></sheetViews><sheetFormatPr defaultRowHeight="12.8"></sheetFormatPr><cols><col collapsed="false" hidden="false" max="1025" min="1" style="0" width="11.5204081632653"/></cols><sheetData><row r="1" customFormat="false" ht="12.8" hidden="false" customHeight="false" outlineLevel="0" collapsed="false"><c r="A1" s="0" t="n"><v>11</v></c><c r="B1" s="0" t="n"><v>21</v></c><c r="C1" s="0" t="n"><v>31</v></c></row><row r="3" customFormat="false" ht="12.8" hidden="false" customHeight="false" outlineLevel="0" collapsed="false"><c r="C3" s="0" t="n"><v>33</v></c></row><row r="4" customFormat="false" ht="12.8" hidden="false" customHeight="false" outlineLevel="0" collapsed="false"><c r="C4" s="0" t="s"><v>0</v></c></row><row r="6" customFormat="false" ht="12.8" hidden="false" customHeight="false" outlineLevel="0" collapsed="false"><c r="C6" s="0" t="n"><v>36</v></c></row><row r="9" customFormat="false" ht="12.8" hidden="false" customHeight="false" outlineLevel="0" collapsed="false"><c r="C9" s="0" t="n"><v>39</v></c></row></sheetData><printOptions headings="false" gridLines="false" gridLinesSet="true" horizontalCentered="false" verticalCentered="false"/><pageMargins left="0.7875" right="0.7875" top="1.05277777777778" bottom="1.05277777777778" header="0.7875" footer="0.7875"/><pageSetup paperSize="9" scale="100" firstPageNumber="1" fitToWidth="1" fitToHeight="1" pageOrder="downThenOver" orientation="portrait" usePrinterDefaults="false" blackAndWhite="false" draft="false" cellComments="none" useFirstPageNumber="true" horizontalDpi="300" verticalDpi="300" copies="1"/><headerFooter differentFirst="false" differentOddEven="false"><oddHeader>&amp;C&amp;&quot;Times New Roman,Regular&quot;&amp;12&amp;A</oddHeader><oddFooter>&amp;C&amp;&quot;Times New Roman,Regular&quot;&amp;12Page &amp;P</oddFooter></headerFooter></worksheet>'
	! !

Object subclass: #TabularImporter
	instanceVariableNames: 'workbook parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Importers'!

!TabularImporter commentStamp: 'HannesHirzel 8/8/2015 12:00' prior: 0!
I am TabularImporter the root of a hierarchy which imports Office files.

LATER:
Subclasses HTMLImporter and ODSImporter will be added.

Public API and Key Messages

- import: aStream  (a Stream of a flat file)
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	parameters:		<Object>
	workbook:		<Object>


    Implementation Points!

!TabularImporter methodsFor: 'importing' stamp: 'MYI 8/4/2015 14:35'!
import: aStream
	workbook := TabularWorkbook new.
	^workbook.! !

!TabularImporter methodsFor: 'as yet unclassified' stamp: 'MYI 8/4/2015 14:34'!
initialize
	parameters := Dictionary new.! !

TabularImporter subclass: #XMLZipImporter
	instanceVariableNames: 'archive xmlDOMs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Importers'!

!XMLZipImporter commentStamp: 'HannesHirzel 8/8/2015 12:01' prior: 0!
I am XMLZipImporter and import Office files which are packed in zip files.

For the Class part:  State the name of the class with one line description: For example, I'm xxx the root of the hierarchy of visitor objects.

For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	archive:		<Object>
	xmlDOMs:		<Object>


    Implementation Points!

XMLZipImporter subclass: #XLSXImporter
	instanceVariableNames: 'sharedStrings workbookRels sheetsToExtract'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Importers'!

!XLSXImporter commentStamp: 'HannesHirzel 8/14/2015 04:10' prior: 0!
I am ƖXLSXImporter which imports Excel files.

Key message for importing is in TabularCell>>extractFromXml: aXMLElement

The attribute t="s" of a cell c seems to indicate that the content has
to be interpreted as a shared string.

The other variant is an inline string

t="inlineStr"

<row r="1">
<c r="A1" t="inlineStr">
<is><t>abcdefghijklmnopqrstuvwxyz 1234567890</t></is>
</c>




For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- import: aReadStream   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	sharedStrings:		<Object>
	sheetsToExtract:		<Object>
	workbookRels:		<Object>


    Implementation Points!

!XLSXImporter class methodsFor: 'importing' stamp: 'VincentBlondeau 1/12/2015 16:39'!
import: aStream
	^ self new import: aStream

	! !

!XLSXImporter class methodsFor: 'importing' stamp: 'VincentBlondeau 1/14/2015 15:42'!
import: aFileReferenceOrAStream onlySheetsNamed: aCollection
	^ self new import: aFileReferenceOrAStream onlySheetsNamed: aCollection! !

!XLSXImporter methodsFor: 'extracting' stamp: 'HannesHirzel 8/11/2015 21:35'!
extractSharedStrings
      (archive memberNamed: 'xl/sharedStrings.xml') isNil ifTrue: [ ^sharedStrings    := '']
ifFalse: 
	[^sharedStrings := XLSXSharedStringsParser parse: (archive memberNamed: 'xl/sharedStrings.xml') contentStream]
	
! !

!XLSXImporter methodsFor: 'extracting' stamp: 'MYI 8/4/2015 12:51'!
extractStyles
	self notYetImplemented.
	"| styles |
	styles := self DOMfor: 'xl/styles.xml'.
	workbook
		styles:
			((TabularStylesContainer newFrom: workbook)
				extractFromXml: styles;
				yourself)"! !

!XLSXImporter methodsFor: 'extracting' stamp: 'MYI 8/4/2015 14:30'!
extractWorkbookRels
	^workbookRels := XLSXRelsParser parse: (archive memberNamed: 'xl/_rels/workbook.xml.rels') contentStream.! !

!XLSXImporter methodsFor: 'extracting' stamp: 'MYI 8/4/2015 14:27'!
extractWorksheets
	self extractWorkbookRels.
	self extractWorksheetsList keysAndValuesDo: [ :id :sheetName | | aSheet |
			aSheet := XLSXSheetParser	parse: ((archive memberNamed: (self getPathForSheet: id)) contentStream).				
			aSheet name: sheetName.
			workbook addSheet: aSheet.
		].
	^workbook worksheets.! !

!XLSXImporter methodsFor: 'extracting' stamp: 'MYI 8/4/2015 14:43'!
extractWorksheetsList
| list |
	list:=XLSXWorkbookParser parse: (archive memberNamed: 'xl/workbook.xml') contentStream.
	sheetsToExtract ifNotNil:[list := list associationsSelect: [:assoc| sheetsToExtract includes: assoc value] ].
	^list.
! !

!XLSXImporter methodsFor: 'extracting' stamp: 'MYI 8/4/2015 14:30'!
getPathForSheet: rID
	^'xl/',(workbookRels at: rID).
	! !

!XLSXImporter methodsFor: 'importing' stamp: 'HannesHirzel 8/11/2015 20:18'!
import: aStream
	archive := ZipArchive new readFrom: aStream.
	workbook := TabularWorkbook new.
	"self extractStyles."
	self extractSharedStrings.
	self extractWorksheets.

	self resolveSharedStrings.
	^ workbook! !

!XLSXImporter methodsFor: 'importing' stamp: 'VincentBlondeau 1/14/2015 15:44'!
import: aFileReference onlySheetsNamed: aCollection


	sheetsToExtract := aCollection.
	^ self import: aFileReference! !

!XLSXImporter methodsFor: 'as yet unclassified' stamp: 'HannesHirzel 8/14/2015 10:13'!
resolveSharedStrings
"Replace shared strings pointers to real strings"
	workbook worksheets do:[:worksheet|
		worksheet cellsDo:[:cell| 
			((cell attributeAt: #xlsx:t) = 's')
				ifTrue:[cell data: (sharedStrings at: (cell data asNumber + 1))] "XLSX uses 0-based arrays"
		]
	]! !

!XMLZipImporter methodsFor: 'importing' stamp: 'MYI 8/4/2015 14:35'!
import: aStream
	archive := ZipArchive new readFrom: aStream.
	^super import: aStream.
! !

Object subclass: #TabularObject
	instanceVariableNames: 'attributes workbook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Model'!

!TabularObject commentStamp: 'HannesHirzel 8/14/2015 06:54' prior: 0!
I am TabularObject, the root object of objects which model a workbook 

Diagram see: http://www.gliffy.com/go/publish/6148167

Standard:
 http://standards.iso.org/ittf/PubliclyAvailableStandards/c061750_ISO_IEC_29500-1_2012.zip

See also

http://www.ecma-international.org/news/TC45_current_work/TC45_available_docs.htm

Other links:

http://davidgohel.github.io/ReporteRs/FlexTable.html for ideas 

http://epplus.codeplex.com/

http://stackoverflow.com/questions/151005/create-excel-xls-and-xlsx-file-from-c-sharp


LATER:

Add subclasses

   TabularDimension
       TabularColumn
       TabularRow


For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	attributes:		<Object>
	workbook:		<Object>


    Implementation Points


!

TabularObject subclass: #TabularCell
	instanceVariableNames: 'data style type formula'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Model'!

!TabularCell commentStamp: 'HannesHirzel 8/14/2015 07:16' prior: 0!
I am TabularCell and the represent a cell in a Worksheet.

Responsibility:
I keep the value and type of a cell, the dimension and the formatting attributes.

Standard:

p. 1600
18.3.1.4 Cell

Example
<row r="1" spans="1:1">
<c r="A1" t="inlineStr">
<is><t>This is inline string example</t></is>
</c>
</row>

s attribute is style index,
t attribute is cell data type; values are on p. 2444, 18.18.11

b boolean
d date
e error
inlineStr (inline string)
n number
s shared string
str (formula string)

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!TabularCell methodsFor: 'accessing - attributes' stamp: 'VincentBlondeau 12/10/2014 11:44'!
colspan
	^ self attributeAt: #colspan! !

!TabularCell methodsFor: 'accessing - attributes' stamp: 'VincentBlondeau 12/10/2014 11:44'!
colspan: anObject
	^ self attributeAt: #colspan put: anObject! !

!TabularCell methodsFor: 'accessing' stamp: 'MYI 8/2/2015 12:45'!
data
	^data! !

!TabularCell methodsFor: 'accessing' stamp: 'MYI 10/12/2014 16:39'!
data: anObject
	data := anObject! !

!TabularCell methodsFor: 'accessing' stamp: 'VincentBlondeau 1/13/2015 16:05'!
dataIfNotNil
	^ self data ifNil: [ NotFound signal: 'The accessed data is nil!!' ]! !

!TabularCell methodsFor: 'conversion-not-used' stamp: 'HannesHirzel 8/14/2015 07:28'!
extractDataFromXml: aXMLElement
"reference document p. 1600 18.3.1.4 Cell and p. 2434 18.18.11 ST_CellType"
	self
		data:
			(self type = 's'
				ifTrue: [ (self stringAt: ((aXMLElement elementAt: 'v') 
					ifNotNil: [ :e | e firstNode ifNotNil: [ :s | s asString ] ])) asString ]
				ifFalse: [self type = 'inlineStr' 
					ifTrue: [ self halt.] 
					ifFalse: [(aXMLElement elementAt: 'v') ifNotNil: [ :e | e firstNode ifNotNil: [ :s | s asString ] ] ]])! !

!TabularCell methodsFor: 'conversion-not-used' stamp: 'HannesHirzel 8/13/2015 13:29'!
extractFromXml: aXMLElement

	self style: (aXMLElement attributeAt: 's') asString.
	self type: ((aXMLElement attributeAt: 't') asString ifEmpty: [ nil ]).
     self extractDataFromXml: aXMLElement.
	self formula: ((aXMLElement elementAt: 'f') ifNotNil: [ :e | e firstNode asString ])! !

!TabularCell methodsFor: 'accessing - attributes' stamp: 'VincentBlondeau 1/14/2015 15:33'!
formula
	"not in attributes for performance issues"

	^ formula! !

!TabularCell methodsFor: 'accessing - attributes' stamp: 'VincentBlondeau 1/14/2015 15:34'!
formula: anObject
	"not in attributes for performance issues"

	formula := anObject! !

!TabularCell methodsFor: 'testing' stamp: 'MYI 8/3/2015 07:43'!
isTabularCell
	^ true! !

!TabularCell methodsFor: 'printing' stamp: 'HannesHirzel 8/14/2015 09:43'!
printOn: stream
	super printOn: stream.
	stream << '(' << self data asString <<')'.! !

!TabularCell methodsFor: 'accessing - attributes' stamp: 'VincentBlondeau 12/10/2014 11:44'!
rowspan
	^ self attributeAt: #rowspan! !

!TabularCell methodsFor: 'accessing - attributes' stamp: 'VincentBlondeau 12/10/2014 11:44'!
rowspan: anObject
	^ self attributeAt: #rowspan put: anObject! !

!TabularCell methodsFor: 'accessing' stamp: 'VincentBlondeau 12/11/2014 15:20'!
stringAt: aXMLString
	^ self stringTable at: aXMLString asString asInteger! !

!TabularCell methodsFor: 'accessing - attributes' stamp: 'MYI 8/2/2015 12:41'!
style
	^ style ! !

!TabularCell methodsFor: 'accessing - attributes' stamp: 'VincentBlondeau 12/11/2014 14:27'!
style: anObject
	style := anObject! !

!TabularCell methodsFor: 'accessing - attributes' stamp: 'VincentBlondeau 1/14/2015 15:33'!
type
	^ type! !

!TabularCell methodsFor: 'accessing - attributes' stamp: 'VincentBlondeau 1/14/2015 15:33'!
type: anObject
	"not in attributes for performance issues"

	type := anObject! !

!TabularObject class methodsFor: 'as yet unclassified' stamp: 'VincentBlondeau 12/11/2014 15:26'!
newFrom: aTabularWorkbook
	^ self new
		workbook: aTabularWorkbook;
		yourself! !

!TabularObject methodsFor: 'accessing - attributes' stamp: 'MYI 10/12/2014 16:34'!
attributeAt: aKeySymbol
	^attributes at: aKeySymbol ifAbsent: nil. "Better default values management needed"! !

!TabularObject methodsFor: 'accessing - attributes' stamp: 'MYI 10/12/2014 16:30'!
attributeAt: aKeySymbol put: value
	attributes at: aKeySymbol put: value! !

!TabularObject methodsFor: 'conversion' stamp: 'VincentBlondeau 12/11/2014 14:25'!
extractFromXml: aXmlElement
	self subclassResponsibility ! !

!TabularObject methodsFor: 'initialization' stamp: 'MYI 10/12/2014 16:27'!
initialize
	super initialize.
	attributes := Dictionary new.! !

!TabularObject methodsFor: 'testing' stamp: 'MYI 8/3/2015 07:43'!
isTabularCell
	^false.! !

!TabularObject methodsFor: 'testing' stamp: 'MYI 8/3/2015 07:43'!
isTabularWorksheet
	^false.! !

!TabularObject methodsFor: 'accessing' stamp: 'VincentBlondeau 12/10/2014 17:15'!
rID: aString
	self attributeAt: #rID put: aString! !

!TabularObject methodsFor: 'accessing' stamp: 'VincentBlondeau 12/11/2014 15:22'!
stringTable
	^ workbook stringTable ! !

!TabularObject methodsFor: 'accessing' stamp: 'VincentBlondeau 12/11/2014 15:21'!
workbook
	^ workbook ! !

!TabularObject methodsFor: 'accessing' stamp: 'VincentBlondeau 12/11/2014 15:21'!
workbook: aTabularWorkbook
	workbook := aTabularWorkbook ! !

TabularObject subclass: #TabularStyle
	instanceVariableNames: 'numFmtId fontId fillId borderId xfId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Model'!

!TabularStyle commentStamp: 'VincentBlondeau 1/13/2015 11:46' prior: 0!
A TabularStyle is xxxxxxxxx.

http://standards.iso.org/ittf/PubliclyAvailableStandards/index.html

http://standards.iso.org/ittf/PubliclyAvailableStandards/c061750_ISO_IEC_29500-1_2012.zip

numFmtId :
0 General
1 0
2 0.00
3 #,##0
ISO/IEC 29500-1:2012(E)
1770 ©ISO/IEC 2012 – All rights reserved
ID formatCode
4 #,##0.00
9 0%
10 0.00%
11 0.00E+00
12 # ?/?
13 # ??/??
14 mm-dd-yy
15 d-mmm-yy
16 d-mmm
17 mmm-yy
18 h:mm AM/PM
19 h:mm:ss AM/PM
20 h:mm
21 h:mm:ss
22 m/d/yy h:mm
37 #,##0 ;(#,##0)
38 #,##0 ;[Red](#,##0)
39 #,##0.00;(#,##0.00)
40 #,##0.00;[Red](#,##0.00)
45 mm:ss
46 [h]:mm:ss
47 mmss.0
48 ##0.0E+0
49 @

Instance Variables
	borderId:		<Object>
	fillId:		<Object>
	fontId:		<Object>
	numFmtId:		<Object>
	xfId:		<Object>

borderId
	- xxxxx

fillId
	- xxxxx

fontId
	- xxxxx

numFmtId
	- xxxxx

xfId
	- xxxxx
!

!TabularStyle methodsFor: 'accessing' stamp: 'VincentBlondeau 1/13/2015 11:35'!
borderId
	^ borderId! !

!TabularStyle methodsFor: 'accessing' stamp: 'VincentBlondeau 1/13/2015 11:35'!
borderId: anObject
	borderId := anObject! !

!TabularStyle methodsFor: 'accessing' stamp: 'VincentBlondeau 1/13/2015 11:35'!
fillId
	^ fillId! !

!TabularStyle methodsFor: 'accessing' stamp: 'VincentBlondeau 1/13/2015 11:35'!
fillId: anObject
	fillId := anObject! !

!TabularStyle methodsFor: 'accessing' stamp: 'VincentBlondeau 1/13/2015 11:35'!
fontId
	^ fontId! !

!TabularStyle methodsFor: 'accessing' stamp: 'VincentBlondeau 1/13/2015 11:35'!
fontId: anObject
	fontId := anObject! !

!TabularStyle methodsFor: 'as yet unclassified' stamp: 'VincentBlondeau 1/14/2015 17:31'!
isDate
	^ ((self workbook styles formats at: self numFmtId ifAbsent: [ '' ]) includes: $y)
		or: [ #(14 15 16 17 22) includes: self numFmtId ]! !

!TabularStyle methodsFor: 'accessing' stamp: 'VincentBlondeau 1/13/2015 11:35'!
numFmtId
	^ numFmtId! !

!TabularStyle methodsFor: 'accessing' stamp: 'VincentBlondeau 1/13/2015 11:35'!
numFmtId: anObject
	numFmtId := anObject! !

!TabularStyle methodsFor: 'accessing' stamp: 'VincentBlondeau 1/13/2015 11:35'!
xfId
	^ xfId! !

!TabularStyle methodsFor: 'accessing' stamp: 'VincentBlondeau 1/13/2015 11:35'!
xfId: anObject
	xfId := anObject! !

TabularObject subclass: #TabularWorkbook
	instanceVariableNames: 'worksheets styles strings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Model'!

!TabularWorkbook commentStamp: 'HannesHirzel 8/9/2015 11:43' prior: 0!
I am a TabularWorkbook the model for a spreadsheet file.

TabularWorkbook example1

For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part: 
I keep one or more Worksheets


Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!TabularWorkbook class methodsFor: 'instance creation' stamp: 'HannesHirzel 8/9/2015 11:47'!
example1
	| workbook sheet |
	workbook := TabularWorkbook withSheets: 1.
	workbook filename: 'Test.xlsx'.
	sheet := workbook worksheets first.
	sheet
		at: 1 @ 1 putData: '-';
		at: 2 @ 1 putData: 'colspan test ...........';
		at: 1 @ 2 putData: 'rowspan test';
		at: 2 @ 2 putData: 777.77.
	(sheet cells at: 2 @ 1) colspan: 3.
	(sheet cells at: 1 @ 2) rowspan: 3.
	sheet  at: 4 @ 3 putData: 'Jurij -- Юрий'.
	
	^ workbook! !

!TabularWorkbook class methodsFor: 'instance creation' stamp: 'VincentBlondeau 12/11/2014 15:27'!
newFrom: aTabularWorkbook
	^ self shouldNotImplement! !

!TabularWorkbook class methodsFor: 'instance creation' stamp: 'MYI 9/24/2014 19:26'!
withSheets: n
| res |
	res:=self new.
	n timesRepeat: [ res addNewWorksheet].
	^res.! !

!TabularWorkbook methodsFor: 'as yet unclassified' stamp: 'MYI 10/12/2014 16:38'!
addNewWorksheet
	worksheets add: TabularWorksheet new. "Maybe worksheet name generation should be here"! !

!TabularWorkbook methodsFor: 'adding' stamp: 'VincentBlondeau 12/10/2014 17:16'!
addSheet: aTabularWorksheet 
	worksheets add: aTabularWorksheet ! !

!TabularWorkbook methodsFor: 'as yet unclassified' stamp: 'VincentBlondeau 1/21/2015 17:08'!
containsWorksheetNamed: aString
	self worksheetNamed: aString ifNone: [ ^ false ].
	^ true! !

!TabularWorkbook methodsFor: 'accessing - attributes' stamp: 'VincentBlondeau 12/10/2014 13:51'!
filename
	^ self attributeAt: #filename! !

!TabularWorkbook methodsFor: 'accessing - attributes' stamp: 'VincentBlondeau 12/10/2014 13:51'!
filename: anObject
	^ self attributeAt: #filename put: anObject ! !

!TabularWorkbook methodsFor: 'initialization' stamp: 'VincentBlondeau 12/10/2014 13:48'!
initialize
	super initialize.
	worksheets := OrderedCollection new! !

!TabularWorkbook methodsFor: 'accessing' stamp: 'VincentBlondeau 12/11/2014 15:23'!
stringTable
	^ strings! !

!TabularWorkbook methodsFor: 'accessing' stamp: 'VincentBlondeau 12/11/2014 15:35'!
stringTable: aTabularSharedStrings 
	strings := aTabularSharedStrings ! !

!TabularWorkbook methodsFor: 'accessing' stamp: 'VincentBlondeau 1/13/2015 11:37'!
styles
	^ styles ! !

!TabularWorkbook methodsFor: 'accessing' stamp: 'VincentBlondeau 1/13/2015 11:37'!
styles: aTabularStyleContainer
	styles := aTabularStyleContainer ! !

!TabularWorkbook methodsFor: 'finding' stamp: 'VincentBlondeau 1/12/2015 15:41'!
worksheetNamed: aString 
	^ self worksheets detect: [ :aSheet | aSheet name = aString ] ! !

!TabularWorkbook methodsFor: 'finding' stamp: 'VincentBlondeau 1/13/2015 17:29'!
worksheetNamed: aString ifNone: aBlock
	^ self worksheets detect: [ :aSheet | aSheet name = aString ] ifNone: aBlock! !

!TabularWorkbook methodsFor: 'accessing' stamp: 'vmusulainen 9/23/2014 03:37'!
worksheets
	^worksheets! !

TabularObject subclass: #TabularWorksheet
	instanceVariableNames: 'cells rows cols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Model'!

!TabularWorksheet commentStamp: 'HannesHirzel 8/8/2015 10:05' prior: 0!
I am TabularWorksheet, the model of a sheet in a spreadsheet file.


For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part:  I keep a dictionary of cells with TabularCell objects, TabularColumn and TabularRow objects


Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	cells:		<Object>
	cols:		<Object>
	rows:		<Object>


    Implementation Points!

!TabularWorksheet methodsFor: 'accessing' stamp: 'HannesHirzel 8/14/2015 10:04'!
allCoord
	^cells keys! !

!TabularWorksheet methodsFor: 'accessing' stamp: 'VincentBlondeau 1/13/2015 14:02'!
at: coord
	^ cells at: coord ifAbsent: [ ^ nil ].
! !

!TabularWorksheet methodsFor: 'accessing' stamp: 'HannesHirzel 8/14/2015 09:51'!
at: coord putCell: aCell
	^ cells at: coord put: aCell
! !

!TabularWorksheet methodsFor: 'accessing' stamp: 'HannesHirzel 8/14/2015 10:01'!
at: coord putData: anObject
	| cell |
	anObject ifNil: [ ^ self eraseCellAt: coord ].
	cell := cells at: coord ifAbsentPut: [ TabularCell new ].
	cell data: anObject! !

!TabularWorksheet methodsFor: 'accessing' stamp: 'HannesHirzel 8/14/2015 10:08'!
cellAt: coord
	^ cells at: coord ifAbsent: [ ^ nil ].
! !

!TabularWorksheet methodsFor: 'accessing' stamp: 'VincentBlondeau 1/12/2015 16:50'!
cellsAsMatrix
	| matrix |
	cols := self cells keys max x.
	rows := self cells keys max y.
	matrix := Matrix rows: rows columns: cols.
	cells associationsDo: [ :assoc | matrix at: assoc key y at: assoc key x put: assoc value ].
	^ matrix! !

!TabularWorksheet methodsFor: 'iterating elements' stamp: 'HannesHirzel 8/14/2015 10:14'!
cellsDo: aBlock
	^ cells do: aBlock
! !

!TabularWorksheet methodsFor: 'iterating elements' stamp: 'HannesHirzel 8/14/2015 10:13'!
cellsKeysAndValuesDo: aBlock
	^ cells keysAndValuesDo: aBlock
! !

!TabularWorksheet methodsFor: 'accessing' stamp: 'MYI 10/12/2014 16:57'!
col: col row: row
	^self at: (col @ row).
! !

!TabularWorksheet methodsFor: 'accessing' stamp: 'MYI 10/12/2014 16:56'!
col: col row: row putData: anObject
	^self at: (col @ row) putData: anObject.
! !

!TabularWorksheet methodsFor: 'removing' stamp: 'MYI 10/12/2014 16:55'!
eraseCellAt: coord
	cells removeKey: coord ifAbsent: [^self].
! !

!TabularWorksheet methodsFor: 'extraction' stamp: 'VincentBlondeau 2/16/2015 14:58'!
extractCellFromXml: aXMLElement
	cells
		at: (aXMLElement attributeAt: #r) asPoint
		put:
			((TabularCell newFrom: self workbook)
				extractFromXml: aXMLElement;
				yourself)! !

!TabularWorksheet methodsFor: 'extraction' stamp: 'MYI 8/2/2015 15:34'!
extractContentsFromXml: aXMLDocument
	aXMLDocument
		allElementsNamed: 'row'
		do: [ :aRow | 
			(TabularRow newFrom: self workbook) extractFromXml: aRow.
			aRow allElementsNamed: 'c' do: [ :aCell | self extractCellFromXml: aCell ] ]! !

!TabularWorksheet methodsFor: 'conversion' stamp: 'VincentBlondeau 12/10/2014 17:55'!
extractFromXml: aXMLElement
	^ self
		name: (aXMLElement attributeAt: 'name');
		sheetId: (aXMLElement attributeAt: 'sheetId');
		rID: (aXMLElement attributeAt: 'r:id');
		yourself! !

!TabularWorksheet methodsFor: 'accessing selection' stamp: 'HannesHirzel 8/14/2015 10:28'!
findCellsWithContent: aContent
	^ cells select: [ :cell | cell data = aContent ]! !

!TabularWorksheet methodsFor: 'initialization' stamp: 'MYI 8/3/2015 07:45'!
initialize
	super initialize.
	cells := Dictionary new.
	self name: 'New sheet'.! !

!TabularWorksheet methodsFor: 'testing' stamp: 'MYI 8/3/2015 07:43'!
isTabularWorksheet
	^true! !

!TabularWorksheet methodsFor: 'accessing' stamp: 'VincentBlondeau 12/10/2014 17:37'!
name
	^ self attributeAt: #name ! !

!TabularWorksheet methodsFor: 'accessing' stamp: 'VincentBlondeau 12/10/2014 17:14'!
name: aString 
	self attributeAt: #name put: aString! !

!TabularWorksheet methodsFor: 'printing' stamp: 'VincentBlondeau 1/13/2015 11:49'!
printOn: aStream
	super printOn: aStream.
	aStream << ' ''' .
	aStream << self name.
	aStream << '''' ! !

!TabularWorksheet methodsFor: 'accessing' stamp: 'VincentBlondeau 12/10/2014 17:50'!
rID
	^ (self attributeAt: #rID) copyWithoutAll: 'rId'! !

!TabularWorksheet methodsFor: 'accessing' stamp: 'VincentBlondeau 12/10/2014 17:16'!
rID: aString
	self attributeAt: #rID put: aString! !

!TabularWorksheet methodsFor: 'accessing' stamp: 'MYI 10/12/2014 20:50'!
rows
	^(cells keys collect: [ :coord| coord y]) asSet asOrderedCollection sort
	! !

!TabularWorksheet methodsFor: 'accessing' stamp: 'VincentBlondeau 12/10/2014 17:15'!
sheetId: aString 
	self attributeAt: #sheetId put: aString! !

!TabularWorksheet methodsFor: 'opening' stamp: 'VincentBlondeau 1/13/2015 11:53'!
show
	self showWithGlamour! !

!TabularWorksheet methodsFor: 'opening' stamp: 'VincentBlondeau 1/13/2015 11:03'!
showWithGlamour
	| wrapper matrix table |
	matrix := self cellsAsMatrix.
	wrapper := GLMWrapper new.
	wrapper
		show: [ :a | 
			table := a table.
			1 to: matrix columnCount do: [ :i | table column: i asString evaluated: [ :col | col at: i ] width: 50 ] ].
	wrapper openOn: ((1 to: matrix rowCount) collect: [ :i | matrix atRow: i ])! !

!TabularWorksheet methodsFor: 'opening' stamp: 'VincentBlondeau 1/13/2015 11:53'!
showWithSpec
	| matrix tree specCols |
	matrix := self cellsAsMatrix.
	tree := TreeModel new.
	specCols := (1 to: matrix columnCount)
		collect: [ :i | 
			TreeColumnModel new
				displayBlock: [ :node | (node content at: i) asString ];
				headerLabel: i asString;
				yourself ].
	tree columns: specCols.
	tree roots: ((1 to: matrix rowCount) collect: [ :i | matrix atRow: i ]).
	tree openWithSpec.
		
! !

Object subclass: #TabularResources
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tabular-Tests'!

!TabularResources commentStamp: 'HannesHirzel 8/14/2015 06:54' prior: 0!
I am TabularResources and keep example Excel files in binary format and offer a service to create them.


More examples see
http://www.openoffice.org/sc/testdocs/index.html (the links marked with 'XML')

https://github.com/GNOME/gnumeric

For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!TabularResources class methodsFor: 'examples' stamp: 'MYI 8/1/2015 00:01'!
bill
 ^ #[80 75 3 4 20 0 6 0 8 0 0 0 33 0 58 240 203 171 141 1 0 0 28 7 0 0 19 0 8 2 91 67 111 110 116 101 110 116 95 84 121 112 101 115 93 46 120 109 108 32 162 4 2 40 160 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 204 85 221 78 194 48 20 190 55 241 29 150 222 26 86 80 99 140 97 112 129 122 169 38 226 3 148 246 192 26 186 182 233 57 42 188 189 103 67 136 49 252 100 145 68 110 182 172 237 249 126 186 246 59 253 225 162 114 217 7 36 180 193 23 162 151 119 69 6 94 7 99 253 172 16 111 227 199 206 173 200 144 148 55 202 5 15 133 88 2 138 225 224 252 172 63 94 70 192 140 171 61 22 162 36 138 119 82 162 46 161 82 152 135 8 158 103 166 33 85 138 248 51 205 100 84 122 174 102 32 47 187 221 27 169 131 39 240 212 161 26 67 12 250 247 48 85 239 142 178 135 5 15 175 148 76 172 23 217 104 181 174 166 42 132 138 209 89 173 136 133 202 15 111 126 145 116 194 116 106 53 152 160 223 43 134 206 49 38 80 6 75 0 170 92 30 147 101 198 244 10 68 108 12 133 220 202 153 192 97 59 210 111 87 57 87 54 194 176 180 17 47 216 250 14 134 122 102 183 171 239 186 103 254 29 201 26 200 94 84 162 39 85 177 119 185 112 242 51 164 249 36 132 121 190 31 164 237 214 52 91 148 87 202 250 181 238 61 252 205 98 148 205 171 119 100 33 181 191 6 184 165 142 203 19 209 113 117 34 58 174 255 73 7 241 221 7 217 60 255 126 52 26 152 3 7 1 105 233 0 143 236 118 5 122 136 185 84 9 204 43 113 170 204 142 46 224 39 246 1 29 90 57 61 42 249 234 30 121 19 54 184 251 248 57 106 95 82 136 200 105 158 160 189 128 117 116 214 213 157 200 64 144 200 194 38 60 183 133 208 134 145 91 65 123 194 95 13 2 234 94 99 192 108 225 150 77 111 27 124 1 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 181 85 48 35 245 0 0 0 76 2 0 0 11 0 8 2 95 114 101 108 115 47 46 114 101 108 115 32 162 4 2 40 160 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 140 146 207 78 195 48 12 198 239 72 188 67 228 251 234 110 72 8 161 165 187 76 72 187 33 84 30 192 36 238 31 181 141 163 36 64 247 246 132 3 130 74 99 219 209 246 231 207 63 91 222 238 230 105 84 31 28 98 47 78 195 186 40 65 177 51 98 123 215 106 120 173 159 86 15 160 98 34 103 105 20 199 26 142 28 97 87 221 222 108 95 120 164 148 155 98 215 251 168 178 139 139 26 186 148 252 35 98 52 29 79 20 11 241 236 114 165 145 48 81 202 97 104 209 147 25 168 101 220 148 229 61 134 191 30 80 45 60 213 193 106 8 7 123 7 170 62 250 60 249 178 183 52 77 111 120 47 230 125 98 151 78 140 64 158 19 59 203 118 229 67 102 11 169 207 219 168 154 66 203 73 131 21 243 156 211 17 201 251 34 99 3 158 38 218 92 79 244 255 182 56 113 34 75 137 208 72 224 243 60 223 138 115 64 235 235 129 46 159 104 169 248 189 206 60 226 167 132 225 77 100 248 97 193 197 15 84 95 0 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 108 251 89 76 41 1 0 0 230 4 0 0 26 0 8 1 120 108 47 95 114 101 108 115 47 119 111 114 107 98 111 111 107 46 120 109 108 46 114 101 108 115 32 162 4 1 40 160 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 188 148 205 106 196 32 20 133 247 133 190 67 112 223 152 100 166 211 82 198 204 162 165 48 219 118 250 0 98 110 98 152 68 131 215 254 228 237 43 233 212 52 48 56 27 233 70 184 71 60 231 227 122 117 187 251 234 187 228 3 12 182 90 49 146 167 25 73 64 9 93 181 170 97 228 237 240 124 115 79 18 180 92 85 188 211 10 24 25 1 201 174 188 190 218 190 64 199 173 59 132 178 29 48 113 46 10 25 145 214 14 15 148 162 144 208 115 76 245 0 202 237 212 218 244 220 186 210 52 116 224 226 200 27 160 69 150 109 168 249 235 65 202 133 103 178 175 24 49 251 202 229 31 198 193 37 95 246 214 117 221 10 120 210 226 189 7 101 207 68 80 193 59 241 40 121 171 156 41 55 13 88 70 188 148 58 82 66 207 67 172 98 66 124 106 115 68 9 96 103 8 47 33 157 118 86 33 152 187 152 48 40 185 129 234 213 26 119 225 56 3 45 228 16 76 17 19 198 183 97 6 241 210 169 51 69 8 38 255 103 152 60 4 179 137 9 131 118 236 220 203 243 83 251 83 135 226 111 99 198 91 247 158 97 78 159 74 58 173 193 22 172 99 50 248 73 152 57 188 116 26 142 245 111 67 232 226 119 42 191 1 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 233 11 116 222 219 1 0 0 161 3 0 0 15 0 0 0 120 108 47 119 111 114 107 98 111 111 107 46 120 109 108 140 83 75 110 219 48 16 221 23 232 29 24 194 219 90 31 75 130 99 88 10 208 124 208 108 138 2 117 147 101 64 139 35 139 8 69 10 36 29 57 203 246 26 185 72 143 145 220 168 67 185 86 148 192 64 187 17 231 195 55 111 222 12 181 60 219 53 146 60 128 177 66 171 156 70 211 144 18 80 165 230 66 109 114 250 99 117 245 105 78 137 117 76 113 38 181 130 156 62 130 165 103 197 199 15 203 78 155 251 181 214 247 4 11 40 155 211 218 185 118 17 4 182 172 161 97 118 170 91 80 152 169 180 105 152 67 215 108 2 219 26 96 220 214 0 174 145 65 28 134 89 208 48 161 232 190 194 194 252 79 13 93 85 162 132 11 93 110 27 80 110 95 196 128 100 14 219 183 181 104 45 45 150 149 144 112 179 87 68 88 219 126 101 13 246 189 147 148 72 102 221 37 23 14 120 78 83 116 117 7 175 129 132 18 179 109 63 111 133 196 236 233 44 156 209 160 24 68 126 51 132 67 197 182 210 173 80 222 161 58 206 43 78 226 56 243 55 253 40 110 4 116 246 21 228 93 178 187 21 138 235 46 167 179 12 71 251 56 120 167 232 117 125 234 86 112 87 99 169 52 11 135 216 23 16 155 218 229 116 158 206 49 198 74 39 30 96 197 214 120 203 115 5 35 178 126 156 72 218 159 68 245 90 159 159 158 127 191 252 124 249 133 146 250 240 53 42 242 242 22 2 13 115 205 251 34 199 0 209 8 128 246 0 136 61 235 49 64 60 2 160 61 0 250 225 29 3 204 70 0 180 7 64 210 235 234 17 40 6 103 45 20 112 191 185 183 222 95 129 119 87 66 58 48 23 204 177 53 179 224 87 89 50 249 221 191 44 175 21 91 175 5 231 224 31 52 45 14 211 136 78 38 151 147 104 225 63 81 180 12 70 28 111 8 15 20 59 169 154 233 63 136 112 55 71 136 146 147 201 185 39 58 159 164 241 59 158 49 43 42 195 166 75 124 90 254 232 251 78 210 44 222 111 248 240 119 21 127 0 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 126 193 138 229 96 1 0 0 116 2 0 0 24 0 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 52 46 120 109 108 140 146 193 106 195 48 12 134 239 131 189 131 241 189 113 218 173 219 26 146 148 65 41 235 97 48 198 182 187 227 40 137 105 108 5 219 93 219 183 159 146 144 50 232 165 55 9 73 159 127 253 114 186 62 153 150 253 130 243 26 109 198 231 81 204 25 88 133 165 182 117 198 191 191 182 179 23 206 124 144 182 148 45 90 200 248 25 60 95 231 247 119 233 17 221 222 55 0 129 17 193 250 140 55 33 116 137 16 94 53 96 164 143 176 3 75 149 10 157 145 129 82 87 11 223 57 144 229 48 100 90 177 136 227 39 97 164 182 124 36 36 238 22 6 86 149 86 176 65 117 48 96 195 8 113 208 202 64 250 125 163 59 63 209 140 186 5 103 164 219 31 186 153 66 211 17 162 208 173 14 231 1 202 153 81 201 174 182 232 100 209 210 222 167 249 163 84 19 123 72 174 240 70 43 135 30 171 16 17 78 140 66 175 119 94 137 149 32 82 158 150 154 54 232 109 103 14 170 140 191 206 185 200 211 193 156 31 13 71 255 47 102 189 215 5 226 190 47 236 202 140 199 125 171 184 234 221 14 94 127 56 86 66 37 15 109 248 196 227 27 232 186 9 116 216 37 105 239 87 72 202 243 6 188 34 239 8 19 45 150 151 71 55 50 72 162 118 178 134 119 233 106 109 61 107 161 26 186 158 57 115 35 38 142 40 14 216 245 179 207 132 44 48 4 52 83 214 208 117 129 174 24 71 15 156 85 136 97 74 122 181 151 255 146 255 1 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 19 196 44 19 194 0 0 0 66 1 0 0 35 0 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 95 114 101 108 115 47 115 104 101 101 116 50 46 120 109 108 46 114 101 108 115 132 143 193 106 195 48 16 68 239 133 252 131 216 123 36 59 135 80 138 37 95 74 33 215 38 253 0 69 94 219 162 246 74 104 183 37 249 251 232 216 132 66 142 195 99 222 48 93 127 89 23 245 139 133 99 34 11 173 110 64 33 133 52 68 154 44 124 157 62 182 175 160 88 60 13 126 73 132 22 174 200 208 187 205 75 247 137 139 151 90 226 57 102 86 213 66 108 97 22 201 111 198 112 152 113 245 172 83 70 170 100 76 101 245 82 99 153 76 246 225 219 79 104 118 77 179 55 229 175 3 220 157 83 29 6 11 229 48 180 160 78 215 92 151 159 187 211 56 198 128 239 41 252 172 72 242 207 132 201 37 146 96 57 162 72 61 200 85 237 203 132 98 65 235 71 246 152 119 250 28 9 140 235 204 221 115 119 3 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 59 109 50 75 193 0 0 0 66 1 0 0 35 0 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 95 114 101 108 115 47 115 104 101 101 116 49 46 120 109 108 46 114 101 108 115 132 143 193 138 194 48 20 69 247 3 254 67 120 123 147 214 133 12 67 83 55 34 184 85 231 3 98 250 218 6 219 151 144 247 20 253 123 179 28 101 192 229 229 112 207 229 54 155 251 60 169 27 102 14 145 44 212 186 2 133 228 99 23 104 176 240 123 218 45 191 65 177 56 234 220 20 9 45 60 144 97 211 46 190 154 3 78 78 74 137 199 144 88 21 11 177 133 81 36 253 24 195 126 196 217 177 142 9 169 144 62 230 217 73 137 121 48 201 249 139 27 208 172 170 106 109 242 95 7 180 47 78 181 239 44 228 125 87 131 58 61 82 89 254 236 142 125 31 60 110 163 191 206 72 242 207 132 73 57 144 96 62 162 72 57 200 69 237 242 128 98 65 235 119 246 158 107 125 14 4 166 109 204 203 243 246 9 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 75 248 57 47 182 22 0 0 34 131 0 0 24 0 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 50 46 120 109 108 156 93 219 110 35 73 142 125 95 96 255 193 240 211 110 3 83 86 234 46 163 202 131 113 222 166 6 219 192 98 122 102 247 89 45 203 101 161 109 203 35 169 92 221 251 245 75 6 153 138 8 146 17 169 244 75 149 45 158 96 102 158 56 100 156 76 133 228 207 127 254 253 229 249 234 125 123 56 238 246 175 95 174 139 79 163 235 171 237 235 102 255 176 123 253 246 229 250 159 255 104 254 180 188 190 58 158 214 175 15 235 231 253 235 246 203 245 31 219 227 245 159 239 254 253 223 62 255 216 31 126 59 62 109 183 167 43 200 240 122 252 114 253 116 58 189 221 222 220 28 55 79 219 151 245 241 211 254 109 251 10 145 199 253 225 101 125 130 95 15 223 110 142 111 135 237 250 193 13 122 121 190 25 143 70 243 155 151 245 238 245 154 50 220 30 46 201 177 127 124 220 109 182 213 126 243 253 101 251 122 162 36 135 237 243 250 4 231 127 124 218 189 29 187 108 47 155 75 210 189 172 15 191 125 127 251 211 102 255 242 6 41 126 221 61 239 78 127 184 164 215 87 47 155 219 175 223 94 247 135 245 175 207 112 221 191 23 211 245 166 203 237 126 81 233 95 118 155 195 254 184 127 60 125 130 116 55 116 162 250 154 87 55 171 27 200 116 247 217 241 240 223 135 171 199 221 243 105 123 248 121 255 0 71 41 174 111 238 62 63 236 224 210 112 62 174 14 219 199 47 215 127 41 110 255 86 20 46 226 134 252 207 110 251 227 200 195 241 231 171 211 250 215 95 182 207 219 205 105 251 128 25 174 78 251 183 255 218 62 158 202 237 243 51 140 94 76 175 175 112 174 126 221 239 127 67 248 87 0 141 240 240 110 8 30 101 189 57 237 222 183 4 175 86 11 152 239 127 185 3 227 207 112 58 55 231 163 134 63 119 103 208 184 249 133 203 120 216 62 174 191 63 159 254 190 255 241 215 237 238 219 211 9 78 101 6 124 33 109 183 15 127 84 219 227 6 230 11 14 253 105 60 195 172 155 253 51 164 128 127 175 94 118 32 188 9 240 189 254 221 253 255 99 247 112 122 250 114 61 7 37 110 190 31 79 251 151 255 165 23 28 3 55 52 206 157 82 181 62 173 239 62 31 246 63 174 64 57 112 221 199 183 53 234 176 184 45 96 40 252 48 238 18 208 57 58 12 158 215 100 242 105 145 56 53 224 101 131 217 254 130 233 220 0 192 31 225 213 247 187 209 231 155 119 32 96 195 136 123 141 40 98 68 169 17 227 24 81 105 196 36 70 212 26 49 141 17 141 70 204 98 68 171 17 243 24 241 87 141 88 196 136 175 26 177 140 17 127 211 136 213 25 113 3 147 116 158 41 152 150 104 166 108 137 116 19 129 104 39 139 243 68 20 114 38 12 136 156 10 3 34 231 130 32 83 55 215 242 16 53 5 65 87 168 132 98 42 24 110 32 236 79 175 16 7 111 199 48 234 241 174 26 255 84 195 49 31 57 131 191 136 136 28 168 131 1 228 32 186 135 28 3 34 52 86 26 16 33 178 138 32 68 142 184 248 154 98 204 205 196 95 151 43 164 6 162 1 53 130 244 118 130 212 56 192 211 250 176 125 184 166 142 215 78 110 219 41 82 190 115 173 170 154 252 84 195 57 19 115 51 127 128 136 56 232 114 3 136 67 116 15 113 6 68 92 121 105 64 68 101 85 4 97 226 68 176 166 96 138 57 136 102 152 195 148 17 115 68 22 116 86 16 232 124 153 96 9 218 222 0 150 16 221 195 146 1 17 173 163 52 32 162 119 84 4 97 34 230 254 220 157 132 234 40 90 44 133 54 27 8 103 120 154 229 120 42 70 83 127 176 72 78 243 65 68 33 186 135 40 3 226 251 163 187 206 82 67 198 254 236 28 164 34 8 55 41 33 199 154 130 120 193 239 119 193 117 81 29 66 48 195 210 60 195 210 124 228 207 34 226 8 157 66 184 228 62 237 30 30 182 104 34 83 203 126 215 211 113 96 15 93 26 50 22 109 181 36 8 24 35 127 97 99 209 95 170 51 6 57 241 151 65 186 226 32 182 103 21 108 23 25 70 124 162 136 15 116 202 33 31 249 133 13 209 61 36 104 200 88 246 110 3 34 234 163 34 8 107 198 159 58 113 64 193 2 251 240 251 157 204 222 64 52 35 154 101 134 162 113 176 16 68 36 173 6 145 132 232 30 146 52 100 44 10 163 52 32 162 21 87 4 33 146 22 162 48 107 10 118 125 90 100 111 32 154 33 105 149 35 105 49 247 201 34 150 224 88 177 150 46 174 45 55 178 135 50 3 51 150 93 155 49 113 121 201 190 237 65 70 9 213 217 104 11 209 244 10 230 101 26 211 130 38 243 242 18 195 147 239 147 143 129 25 139 249 47 13 76 32 111 234 204 140 33 5 205 212 26 198 97 106 206 114 112 131 209 64 67 162 200 91 8 167 169 194 197 62 69 23 122 168 144 174 203 85 68 134 55 50 111 254 32 238 138 239 11 141 153 200 30 205 152 232 250 38 178 73 123 144 169 34 58 140 227 64 183 105 24 155 166 198 159 113 172 34 116 172 31 163 133 188 110 158 22 141 153 136 9 45 161 223 162 48 99 90 100 223 246 32 147 150 115 10 35 218 186 134 158 178 135 41 90 208 142 126 140 22 50 178 121 90 52 102 226 155 159 83 84 89 16 38 166 69 118 106 15 50 46 188 238 162 246 162 14 209 225 106 65 251 25 210 146 95 214 241 161 71 111 207 209 152 137 234 191 6 70 181 95 194 36 150 118 62 19 94 219 11 209 212 26 12 7 61 71 20 101 11 225 52 85 197 42 165 33 244 160 3 200 34 203 154 23 142 198 76 196 181 148 5 97 240 191 243 37 73 7 92 121 144 41 28 78 129 190 79 181 153 38 202 92 20 162 84 91 8 167 201 74 81 133 246 179 163 10 126 238 145 21 153 213 60 83 26 51 85 13 217 192 136 169 175 10 194 144 172 198 162 254 106 142 210 74 38 111 80 26 140 158 167 160 40 68 234 22 194 105 162 102 65 182 184 97 163 75 189 156 42 242 180 121 170 52 102 170 154 52 97 162 169 159 138 153 175 138 51 200 144 77 221 69 19 162 130 177 1 87 162 27 182 48 56 205 85 74 84 104 85 47 103 138 140 109 158 41 141 145 143 191 202 194 192 8 217 84 140 97 127 116 126 50 72 119 33 28 228 86 37 253 123 131 225 128 40 37 170 156 199 46 130 108 145 168 198 161 197 6 213 230 235 207 161 123 108 181 129 153 202 182 110 97 100 91 103 12 215 159 236 99 53 135 153 44 57 25 13 134 51 100 65 56 173 170 98 148 244 146 227 208 122 247 211 117 129 243 118 25 99 74 167 178 177 27 152 224 1 32 57 111 198 216 202 226 96 226 161 8 70 115 92 229 124 55 188 125 117 86 113 44 172 208 117 247 51 165 93 180 124 250 124 63 214 152 153 108 236 22 70 20 74 197 152 4 83 116 16 190 67 17 205 168 193 161 57 166 114 54 188 88 248 108 49 83 208 121 46 239 86 99 68 199 122 209 76 105 204 76 246 117 35 207 76 182 117 198 184 123 212 247 59 127 250 212 174 186 40 61 53 209 21 24 53 84 181 6 194 232 116 5 142 147 237 42 116 231 253 170 210 110 91 115 165 49 51 113 165 229 216 192 200 206 206 152 132 170 40 1 19 57 22 173 174 193 177 57 89 97 210 212 109 76 17 116 198 88 86 104 139 47 94 4 225 237 200 126 89 105 204 76 117 118 194 68 118 97 38 174 183 226 131 57 191 168 92 102 221 69 109 187 128 209 128 43 49 85 45 132 211 92 165 90 21 154 222 203 153 34 139 28 169 219 39 118 165 113 63 214 152 153 106 234 26 35 159 151 84 156 135 68 37 42 184 230 160 187 155 131 167 150 65 35 118 39 209 96 60 199 84 206 173 39 159 118 143 161 232 6 112 133 232 190 102 165 49 115 213 214 13 140 106 235 132 33 174 68 39 171 221 105 195 163 6 234 85 133 230 10 6 7 92 137 220 45 12 79 171 106 26 100 139 43 16 93 241 229 186 34 15 157 215 149 198 204 133 44 202 177 129 17 116 84 140 73 112 69 9 58 27 26 244 23 214 21 196 3 174 196 92 181 144 59 205 213 42 144 120 204 21 154 231 203 185 210 86 91 55 118 141 9 158 51 187 75 41 199 6 70 53 118 194 16 87 178 117 215 156 129 252 66 177 16 141 160 193 112 142 171 156 103 159 46 82 100 77 132 105 191 248 129 166 27 216 83 143 6 102 46 187 60 99 162 71 84 115 217 229 61 200 186 41 204 70 27 140 6 188 201 46 15 225 180 198 252 28 68 10 155 12 178 238 14 221 199 148 182 247 115 217 229 141 60 82 36 21 99 72 97 82 199 53 71 187 214 21 60 29 160 114 196 120 142 170 156 123 47 194 85 35 102 11 125 112 80 143 151 75 76 187 116 121 73 247 19 141 89 136 54 82 50 38 146 216 66 244 229 202 131 76 137 209 97 32 133 17 109 97 236 112 13 161 177 14 88 201 223 45 79 16 221 167 33 141 89 200 142 110 228 89 200 142 206 24 210 144 16 97 205 65 150 144 124 224 220 96 56 80 144 32 185 133 112 154 168 73 225 107 51 22 16 90 222 128 170 203 5 164 205 182 22 144 198 4 119 87 212 219 39 132 137 5 36 155 187 7 25 18 169 187 168 253 24 29 162 105 94 82 77 8 237 241 135 88 209 222 91 179 162 49 11 213 185 9 19 179 162 58 247 25 100 178 146 139 182 147 15 24 240 9 90 225 15 177 162 61 180 102 69 99 228 91 219 165 59 1 241 78 84 176 121 200 9 170 242 32 147 21 58 76 170 217 228 204 118 74 43 104 104 3 86 122 154 141 182 200 154 10 141 89 170 190 107 96 68 71 168 38 132 161 102 227 235 223 209 84 115 176 91 175 2 115 204 235 21 12 14 186 141 56 126 11 195 211 85 53 11 178 197 221 6 61 107 192 213 229 221 70 187 101 77 155 198 44 85 143 38 76 84 87 114 143 86 53 57 131 76 5 113 212 236 54 13 143 157 187 93 195 184 57 183 133 87 210 76 165 52 133 102 54 224 169 71 83 218 30 107 114 52 102 41 36 81 78 12 140 234 196 132 73 153 32 138 118 15 80 196 1 26 60 64 160 41 161 215 22 194 105 166 198 193 163 212 72 83 83 225 178 243 92 57 116 207 98 111 96 150 178 65 91 24 217 159 25 99 215 31 7 153 170 96 121 166 242 195 112 134 42 8 167 169 10 214 216 152 169 65 214 122 170 109 179 82 149 129 89 10 87 83 26 152 224 13 89 234 217 140 33 166 164 199 172 57 74 55 111 43 41 42 140 230 152 202 25 235 249 34 120 30 26 115 37 140 117 143 170 180 83 214 92 105 204 74 116 213 210 237 35 142 213 185 18 85 82 49 134 185 18 108 212 28 229 182 46 239 164 27 12 231 200 202 153 237 233 50 41 172 65 126 123 74 94 218 125 92 195 77 255 189 122 165 84 175 84 234 149 154 95 89 250 86 203 175 184 54 114 247 203 63 127 254 143 118 140 123 179 255 147 183 99 207 23 139 224 166 46 158 110 97 131 123 166 91 251 218 149 88 105 238 167 26 35 247 218 151 22 70 77 55 229 73 52 92 206 208 117 145 64 205 220 70 96 116 48 223 66 111 45 12 135 54 114 87 77 167 63 213 248 110 113 207 126 255 41 90 202 139 151 37 135 22 98 86 44 145 73 141 238 108 4 166 52 242 200 61 13 21 99 82 44 177 21 198 166 249 126 167 54 180 225 224 128 36 49 3 45 132 69 175 117 31 56 130 215 111 91 252 104 14 238 101 135 38 3 231 0 36 66 61 58 18 39 41 11 52 21 38 186 71 105 218 21 107 165 105 140 92 78 74 119 212 120 46 10 185 180 51 134 56 20 147 80 115 144 133 166 41 132 115 200 81 104 250 106 247 25 169 247 187 96 53 136 107 18 237 107 160 182 139 205 226 84 123 99 77 154 129 17 55 235 37 231 137 204 162 92 126 42 15 178 204 98 23 53 205 98 11 81 161 44 210 146 251 92 68 194 26 78 209 126 6 172 244 232 135 204 106 88 95 154 10 141 41 148 221 49 48 202 238 16 134 245 227 79 223 117 162 218 157 55 20 10 213 160 254 96 4 198 115 10 50 93 52 43 104 150 220 140 51 69 67 122 57 91 100 95 243 108 105 140 220 173 86 186 163 198 213 38 159 7 86 140 33 182 4 149 53 7 201 241 168 39 251 24 205 81 101 218 104 166 106 18 156 72 84 109 51 97 163 47 174 54 55 48 190 88 37 49 3 163 62 33 193 152 168 218 212 71 36 60 200 170 182 46 106 87 27 68 7 87 219 108 144 101 118 232 62 42 180 173 150 159 100 40 141 60 99 209 156 42 198 36 170 141 163 108 3 229 1 26 12 103 20 4 225 52 83 243 84 191 158 13 178 204 14 221 199 149 182 204 193 142 3 215 87 74 35 143 220 5 88 49 134 184 146 100 212 28 237 150 54 225 168 27 12 231 184 50 45 51 87 219 114 228 179 197 213 134 30 56 232 75 151 87 27 14 236 163 77 99 212 39 38 102 132 137 171 77 180 161 202 131 204 106 227 20 212 209 69 191 111 97 108 90 67 30 28 179 130 94 55 96 37 191 182 205 180 195 214 141 199 192 8 223 83 90 121 196 250 87 49 134 20 36 87 199 154 163 172 32 101 194 49 28 40 200 75 194 41 184 133 112 154 169 228 135 110 102 232 60 47 231 138 28 48 204 216 249 68 52 87 26 163 62 92 226 142 26 203 79 122 193 138 49 204 149 159 106 242 1 28 165 165 77 142 109 48 122 62 195 162 16 46 180 133 112 154 170 164 229 158 9 203 125 121 177 105 103 173 89 211 24 245 193 18 119 2 226 185 181 250 96 137 7 153 197 70 135 129 122 53 162 45 140 77 243 226 103 32 46 182 143 218 235 153 97 157 197 68 221 27 24 245 185 18 198 68 45 104 162 150 57 58 152 125 221 181 79 97 178 242 1 123 61 67 19 27 148 213 229 90 209 14 89 107 69 99 228 187 124 165 59 1 169 21 209 178 42 15 50 174 187 238 162 9 27 148 115 210 41 173 12 178 209 51 109 145 53 21 26 163 62 40 193 121 162 77 106 210 12 87 30 100 82 65 135 113 59 249 213 22 182 6 199 6 221 70 104 175 133 240 224 170 194 47 2 9 245 147 95 194 28 58 110 167 138 41 3 163 62 40 97 97 196 99 140 138 49 212 150 197 165 214 28 164 174 28 220 34 184 158 221 96 52 224 73 100 110 33 156 230 41 120 127 46 106 63 243 65 206 218 161 251 136 210 206 90 125 76 130 243 196 146 18 100 84 30 100 73 170 139 98 115 209 146 194 104 64 149 92 235 33 156 166 42 81 124 243 65 190 218 161 251 152 210 190 90 237 253 55 242 76 165 63 100 12 73 74 222 171 213 28 229 123 16 229 138 48 28 48 165 68 149 243 213 171 212 61 200 28 61 233 71 218 183 27 216 71 27 25 222 200 68 9 74 74 206 19 45 106 43 241 150 72 229 65 134 132 234 46 106 182 239 6 163 1 109 74 96 31 176 221 243 65 182 219 161 251 152 210 182 91 237 108 55 242 168 157 237 140 97 99 45 174 181 238 162 180 91 84 11 44 182 221 74 96 57 219 157 220 217 62 23 182 251 98 127 224 6 246 209 166 29 184 218 3 91 114 162 72 97 197 72 60 217 175 60 202 148 24 29 200 118 85 45 140 29 222 164 132 199 238 89 247 180 105 214 235 158 198 168 109 236 115 118 197 240 223 185 38 212 54 118 15 50 169 224 20 137 118 30 102 46 228 99 245 22 82 15 103 74 248 238 30 166 46 48 219 115 141 81 219 141 45 140 90 247 40 79 194 33 80 176 123 162 36 125 88 131 7 56 207 1 124 3 220 249 227 70 116 147 11 225 52 83 201 237 198 115 225 198 123 184 210 246 90 171 74 99 212 102 80 119 212 184 84 131 247 13 221 245 84 140 33 174 228 123 189 53 71 153 44 216 190 25 179 209 96 60 32 75 52 182 22 194 105 178 210 155 65 231 104 118 63 180 248 105 51 174 137 211 24 249 70 125 233 78 64 220 187 168 205 160 30 100 150 35 29 198 238 76 13 142 13 120 83 45 253 3 134 125 49 200 176 59 116 44 13 197 148 129 81 123 69 45 140 44 71 198 144 196 132 133 168 57 200 10 147 119 145 45 132 211 10 74 110 6 93 8 79 126 241 226 230 6 246 209 162 237 121 49 18 51 88 114 34 177 184 137 167 11 149 71 89 18 202 70 91 136 166 153 241 117 26 221 171 44 132 3 191 156 23 109 180 181 92 52 70 109 7 117 39 32 11 75 88 207 202 131 76 86 232 48 118 97 181 48 118 56 43 31 245 218 11 195 71 139 41 190 55 48 106 59 40 99 34 177 4 183 155 212 168 61 200 100 133 78 37 197 202 7 204 52 126 131 105 216 132 243 75 150 67 247 21 142 54 211 106 59 168 145 103 41 106 171 98 12 245 19 177 228 212 28 236 86 172 96 247 2 61 2 192 120 208 121 229 242 14 225 180 126 146 219 65 221 238 137 96 193 234 225 74 187 99 93 76 6 70 156 107 233 142 42 56 87 92 81 30 226 42 216 246 228 200 168 57 3 147 165 54 89 97 56 224 74 228 198 61 35 105 174 210 155 172 22 104 84 47 39 139 108 109 176 201 202 141 255 114 237 95 41 213 43 149 122 165 230 87 130 77 86 252 74 176 201 106 58 197 141 48 221 46 171 98 53 9 118 150 198 125 20 61 228 229 151 64 142 51 186 223 29 137 69 242 126 97 128 212 132 27 24 49 41 21 231 161 9 87 126 142 163 221 230 5 117 171 137 241 96 198 197 9 180 16 134 25 191 131 131 252 84 99 111 239 217 102 181 24 228 122 29 58 150 51 124 83 100 108 56 239 45 144 104 1 165 133 145 15 158 25 67 52 137 158 93 115 176 123 35 213 47 166 220 66 98 211 43 102 160 133 209 162 44 104 155 213 98 121 11 223 41 134 46 13 246 89 193 50 85 45 150 192 34 44 126 142 197 212 131 160 5 250 200 203 165 166 205 173 193 161 6 173 4 207 165 59 108 60 25 106 199 16 99 136 67 49 9 53 7 187 62 172 110 179 48 30 40 77 145 104 58 224 49 110 145 124 191 91 4 93 61 170 203 229 32 15 236 208 241 53 106 178 44 144 120 83 181 180 48 210 212 48 134 235 82 92 110 205 209 174 46 229 78 254 6 227 25 182 32 44 36 71 26 115 108 141 199 35 127 50 49 93 194 38 231 151 173 165 229 123 133 110 238 45 144 176 252 165 129 145 55 150 21 99 136 46 127 250 180 108 113 144 30 242 43 101 97 52 199 149 233 155 89 89 201 93 69 203 143 58 103 55 176 87 100 218 58 171 109 69 156 40 50 137 242 81 117 229 65 150 73 236 162 230 3 217 22 162 105 17 249 30 24 43 72 88 231 30 5 105 191 108 20 156 6 201 157 46 229 210 192 8 37 86 140 33 5 73 125 213 28 229 246 36 15 208 96 56 167 33 211 79 179 134 166 169 143 81 47 7 57 106 135 238 21 142 182 212 106 99 145 145 72 109 44 98 12 145 37 223 209 175 57 218 173 135 162 213 55 24 206 145 133 89 213 215 137 48 89 240 101 101 41 105 161 115 13 22 190 139 239 85 151 218 58 27 42 211 32 181 181 136 19 197 21 39 122 81 229 65 102 197 209 97 18 183 101 48 54 205 76 138 150 65 238 121 73 238 57 82 179 242 84 6 72 237 151 49 48 114 207 75 197 24 18 145 124 166 86 115 148 154 182 28 219 96 52 208 144 112 100 45 132 211 76 141 139 32 93 220 158 208 48 127 72 67 134 211 214 188 105 144 218 49 179 36 76 164 33 89 95 149 7 153 26 58 167 48 162 45 140 77 51 147 210 144 240 229 151 151 22 14 236 237 73 26 164 182 204 44 9 19 211 162 58 248 25 100 92 120 237 83 24 209 22 162 195 105 25 100 181 151 218 69 27 109 70 131 212 158 7 35 209 84 248 195 138 49 188 152 137 104 205 81 42 173 160 159 210 237 10 70 131 210 18 131 91 8 167 153 154 6 238 42 170 172 213 32 167 237 208 125 186 49 64 106 219 3 99 242 219 30 60 200 80 70 221 69 237 247 201 48 26 144 37 150 186 22 194 105 178 18 213 182 26 228 178 29 186 151 42 203 138 139 115 45 205 76 242 62 152 65 44 44 127 5 100 180 57 202 11 191 122 62 132 225 128 44 169 44 8 167 201 130 158 237 143 22 75 75 88 237 188 167 92 105 235 172 203 208 0 201 71 31 165 133 81 108 209 193 136 45 193 119 205 9 58 75 41 194 13 134 115 100 229 220 119 242 235 52 87 104 132 131 5 174 135 43 109 155 13 174 44 144 188 227 117 199 149 42 149 214 136 65 196 150 252 66 190 154 163 157 169 244 98 160 174 133 225 28 93 57 7 62 73 57 240 213 32 7 238 208 242 34 197 34 117 111 128 212 22 36 11 163 200 34 39 207 100 9 241 212 156 129 181 37 181 219 96 56 71 22 102 77 57 240 121 240 84 56 174 67 97 192 123 180 165 13 181 161 45 13 82 95 62 186 210 152 224 19 243 78 28 21 99 18 117 72 9 18 79 7 112 104 142 170 156 37 79 126 123 209 106 144 41 119 232 94 93 89 206 93 62 73 177 50 201 103 190 21 131 18 100 209 97 186 166 37 26 94 131 99 115 108 229 108 121 210 149 187 63 118 119 121 211 210 46 219 16 150 6 169 61 54 238 176 240 222 99 120 73 106 143 141 7 153 222 129 173 120 194 59 64 52 32 75 212 112 11 169 211 85 232 219 95 92 131 104 129 47 167 74 59 111 131 42 13 82 223 21 185 210 152 160 165 114 13 18 134 100 37 238 215 106 78 208 57 82 127 117 220 220 97 108 142 169 156 121 79 126 85 228 106 144 125 119 232 222 34 212 246 93 154 160 210 72 52 23 101 84 49 134 184 146 5 90 115 148 200 210 223 233 135 225 128 44 249 158 12 132 211 178 130 108 158 251 72 89 176 31 47 150 214 197 55 129 52 178 143 58 11 37 159 9 148 29 40 186 15 84 27 109 2 148 85 148 249 48 252 197 155 15 120 118 216 135 24 179 147 95 252 8 222 79 137 182 237 106 67 141 149 74 125 251 90 7 34 65 137 85 1 254 2 16 29 135 155 186 220 83 211 184 120 160 40 233 219 49 158 150 84 114 211 13 108 130 25 198 217 37 206 157 146 74 102 197 25 131 142 172 92 162 41 85 29 202 94 9 187 40 27 82 117 27 237 226 89 214 178 14 62 93 135 194 194 15 168 67 203 169 75 127 90 140 52 42 112 124 174 31 3 127 4 138 235 80 118 177 0 101 215 33 39 177 223 94 192 209 105 85 37 187 148 112 236 3 216 33 67 13 231 228 39 77 61 194 131 229 17 52 27 203 75 109 90 234 64 49 59 210 192 7 40 155 29 58 18 36 49 194 208 165 80 149 41 143 158 100 7 173 110 96 15 6 176 163 93 54 156 130 120 179 189 24 105 148 218 188 212 129 34 118 212 238 165 0 101 92 62 180 44 58 82 146 157 156 45 79 178 131 222 54 96 167 175 135 147 21 238 19 140 70 169 77 76 197 200 0 137 158 5 221 136 64 169 110 68 81 238 225 176 136 197 115 3 77 28 0 94 217 106 159 50 198 211 130 74 238 100 42 70 104 113 3 210 6 72 74 123 112 75 82 26 165 190 220 142 78 66 108 19 148 239 137 3 129 148 202 214 12 72 138 195 102 59 2 254 40 28 124 193 29 190 148 166 204 79 128 240 81 232 131 3 194 250 84 166 173 181 197 146 70 5 123 145 186 166 109 128 116 207 38 80 74 101 20 237 214 60 113 203 2 36 65 60 16 153 208 48 116 173 156 83 79 62 181 42 70 131 172 58 193 227 38 109 113 166 205 186 250 14 55 43 85 176 243 134 238 108 58 16 113 166 236 122 23 38 191 46 119 197 0 103 177 95 215 156 229 12 251 42 120 214 17 235 12 230 104 136 206 28 188 151 51 3 165 190 203 141 246 44 197 169 212 151 185 117 32 226 76 82 90 119 97 110 103 242 38 10 254 20 99 252 220 93 145 6 241 116 105 206 150 105 214 134 248 120 216 158 69 206 217 205 16 125 241 218 98 225 118 109 117 155 2 199 240 133 63 126 229 167 25 186 57 62 109 183 167 106 125 90 223 125 94 127 63 237 155 221 243 105 123 160 63 170 93 23 183 112 241 206 79 187 87 203 253 243 247 151 215 171 205 254 249 235 131 251 51 219 159 55 223 143 167 253 11 141 57 194 223 234 13 126 189 218 191 109 15 235 211 30 190 125 243 117 127 170 255 245 125 253 124 125 245 190 126 198 129 176 181 231 38 196 194 208 155 199 224 16 240 171 63 151 187 207 111 235 111 219 159 215 135 111 187 215 227 213 243 246 17 106 122 244 9 26 224 97 247 237 169 251 249 180 127 115 175 194 74 252 235 254 4 231 212 253 246 180 93 63 108 225 28 70 159 96 109 124 220 239 225 226 232 23 56 7 204 251 203 246 244 253 237 234 109 13 39 251 203 238 255 182 95 174 161 0 246 135 221 246 245 180 62 237 246 240 167 137 223 246 135 211 97 189 59 193 201 111 15 167 221 102 253 92 189 185 63 50 126 117 184 221 1 13 135 175 15 238 123 70 110 126 236 15 191 57 50 239 254 95 0 0 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 126 193 138 229 96 1 0 0 116 2 0 0 24 0 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 51 46 120 109 108 140 146 193 106 195 48 12 134 239 131 189 131 241 189 113 218 173 219 26 146 148 65 41 235 97 48 198 182 187 227 40 137 105 108 5 219 93 219 183 159 146 144 50 232 165 55 9 73 159 127 253 114 186 62 153 150 253 130 243 26 109 198 231 81 204 25 88 133 165 182 117 198 191 191 182 179 23 206 124 144 182 148 45 90 200 248 25 60 95 231 247 119 233 17 221 222 55 0 129 17 193 250 140 55 33 116 137 16 94 53 96 164 143 176 3 75 149 10 157 145 129 82 87 11 223 57 144 229 48 100 90 177 136 227 39 97 164 182 124 36 36 238 22 6 86 149 86 176 65 117 48 96 195 8 113 208 202 64 250 125 163 59 63 209 140 186 5 103 164 219 31 186 153 66 211 17 162 208 173 14 231 1 202 153 81 201 174 182 232 100 209 210 222 167 249 163 84 19 123 72 174 240 70 43 135 30 171 16 17 78 140 66 175 119 94 137 149 32 82 158 150 154 54 232 109 103 14 170 140 191 206 185 200 211 193 156 31 13 71 255 47 102 189 215 5 226 190 47 236 202 140 199 125 171 184 234 221 14 94 127 56 86 66 37 15 109 248 196 227 27 232 186 9 116 216 37 105 239 87 72 202 243 6 188 34 239 8 19 45 150 151 71 55 50 72 162 118 178 134 119 233 106 109 61 107 161 26 186 158 57 115 35 38 142 40 14 216 245 179 207 132 44 48 4 52 83 214 208 117 129 174 24 71 15 156 85 136 97 74 122 181 151 255 146 255 1 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 130 159 128 146 254 9 0 0 59 43 0 0 24 0 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 49 46 120 109 108 156 90 93 111 227 182 18 125 47 112 255 131 225 247 198 162 62 44 43 72 82 84 148 22 119 31 10 20 237 189 237 179 214 86 18 97 109 203 149 149 100 183 191 190 67 206 72 36 135 114 98 53 88 108 226 25 206 232 204 112 134 135 148 121 247 211 183 195 126 241 90 119 231 166 61 222 47 197 77 176 92 212 199 109 187 107 142 79 247 203 255 255 239 211 143 155 229 226 220 87 199 93 181 111 143 245 253 242 123 125 94 254 244 240 159 31 238 222 218 238 235 249 185 174 251 5 120 56 158 239 151 207 125 127 186 93 173 206 219 231 250 80 157 111 218 83 125 4 205 99 219 29 170 30 62 118 79 171 243 169 171 171 157 54 58 236 87 97 16 172 87 135 170 57 46 209 195 109 119 141 143 246 241 177 217 214 69 187 125 57 212 199 30 157 116 245 190 234 1 255 249 185 57 157 7 111 135 237 53 238 14 85 247 245 229 244 227 182 61 156 192 197 151 102 223 244 223 181 211 229 226 176 189 253 252 116 108 187 234 203 30 226 254 38 226 106 59 248 214 31 60 247 135 102 219 181 231 246 177 191 1 119 43 4 234 199 156 173 178 21 120 122 184 211 121 248 181 91 60 54 251 190 238 126 105 119 240 20 177 92 61 220 237 26 8 77 205 199 162 171 31 239 151 63 139 219 50 9 149 66 91 252 209 212 111 103 235 239 133 154 136 47 109 251 85 41 62 239 238 151 129 242 93 239 235 173 74 201 162 130 95 175 181 172 247 251 251 165 20 48 151 127 105 167 82 220 74 17 196 155 36 93 43 207 171 209 181 253 247 240 152 79 122 14 1 234 174 126 172 94 246 253 111 237 219 127 235 230 233 185 7 192 9 228 68 165 230 118 247 189 168 207 91 152 19 64 112 19 38 202 235 182 221 131 11 248 127 113 104 84 113 65 78 171 111 250 247 91 179 235 159 149 245 77 42 130 44 74 193 203 246 229 220 183 135 63 73 65 230 104 24 146 33 252 38 195 36 184 202 48 34 67 112 79 134 225 187 134 43 68 172 147 81 84 125 245 112 215 181 111 11 168 75 149 184 83 165 170 92 220 130 51 29 249 230 70 193 158 8 62 130 9 216 42 171 159 149 153 138 114 185 128 172 156 65 252 250 32 196 250 110 245 10 89 222 210 160 124 114 80 234 14 210 51 231 121 218 184 131 138 73 79 153 59 168 156 26 20 6 227 160 21 68 60 134 13 9 183 195 158 136 21 38 122 8 54 196 248 226 56 14 55 208 219 236 185 57 248 50 73 8 199 231 233 68 73 180 141 12 12 45 46 6 151 137 59 188 68 121 28 37 198 192 193 13 243 126 61 110 53 93 48 47 113 156 136 32 16 17 159 30 240 101 112 199 46 16 73 182 12 95 129 98 30 78 137 226 248 18 234 120 14 234 88 163 142 98 17 2 234 32 96 165 144 131 47 131 154 133 36 209 118 205 38 161 32 151 38 167 122 18 74 20 139 205 218 40 156 100 67 117 95 159 108 85 46 175 15 81 16 198 34 1 216 194 205 103 238 116 10 139 73 162 173 8 56 110 146 111 216 228 148 131 60 93 27 79 14 242 245 28 228 107 147 240 24 144 51 16 57 248 26 19 110 181 19 150 55 217 178 104 11 20 199 38 175 152 112 20 139 208 82 56 176 83 23 246 115 179 219 213 184 188 190 223 160 169 142 0 220 2 250 32 19 188 65 193 173 137 128 133 39 209 150 33 45 38 165 37 151 58 224 213 118 194 90 73 223 71 188 25 114 14 61 3 63 108 130 115 240 101 16 51 165 68 91 171 104 113 73 65 113 24 185 133 87 162 88 68 27 19 162 3 59 155 3 59 27 96 135 193 38 8 34 134 44 7 95 6 54 239 77 180 21 220 168 32 159 108 165 41 81 28 175 179 11 184 5 236 231 236 124 95 93 44 96 168 59 149 22 24 193 106 55 87 142 77 20 166 193 176 224 201 218 128 194 228 79 139 75 79 236 164 94 40 198 186 186 100 96 244 128 59 88 67 205 176 252 230 202 219 136 155 175 208 146 172 215 49 11 183 24 220 178 136 74 146 139 44 180 124 185 240 25 137 94 63 3 3 251 33 161 166 172 37 115 97 51 106 196 180 18 180 42 15 12 111 49 45 46 61 177 27 2 227 211 235 67 24 185 85 239 9 66 222 9 194 38 87 94 242 18 180 147 33 76 138 75 111 180 27 2 35 215 235 67 32 250 131 109 141 90 130 214 124 213 20 54 211 242 205 131 4 237 100 8 147 226 210 27 237 134 48 139 104 97 211 169 158 60 108 107 252 62 176 169 54 242 250 119 224 90 119 153 44 6 175 44 11 229 40 55 245 230 98 159 69 181 2 25 80 51 85 176 73 19 246 180 28 244 166 135 45 150 164 181 135 104 149 67 39 167 214 10 175 199 151 244 52 33 44 218 118 193 51 194 125 159 179 4 210 159 218 153 169 213 223 114 170 31 151 131 222 2 239 181 45 90 39 76 94 144 87 238 173 36 57 28 229 46 101 126 22 225 10 162 71 93 235 89 228 159 85 108 202 141 89 59 75 178 22 140 164 10 227 213 157 147 146 20 17 44 212 163 198 77 253 44 222 21 46 241 114 28 57 232 173 212 51 102 144 100 45 12 20 34 45 244 26 178 168 74 26 31 94 218 206 135 140 122 223 47 27 24 173 250 53 11 210 112 157 64 233 48 2 202 149 183 145 183 98 222 175 100 29 166 236 220 88 144 34 230 224 73 14 155 204 181 81 57 169 15 103 209 46 140 214 203 141 72 18 56 150 37 62 124 155 118 173 140 97 203 14 214 60 245 36 183 106 27 91 118 148 27 3 23 59 227 220 15 82 63 18 173 58 1 6 130 37 55 15 109 162 229 157 41 65 171 34 55 89 196 170 33 113 196 228 37 201 69 106 20 46 116 198 181 31 64 71 46 132 197 38 74 224 0 27 176 109 109 30 218 4 155 240 126 5 173 158 52 147 69 194 142 114 191 104 6 185 49 112 177 51 146 253 0 251 200 172 42 237 225 134 149 110 30 218 204 154 240 110 5 237 100 218 81 28 178 57 44 105 184 176 74 201 133 62 139 92 245 91 15 77 174 184 175 241 154 213 38 215 132 97 145 131 53 11 169 32 57 188 59 25 23 67 42 119 100 227 200 214 184 232 103 209 107 72 7 76 122 83 195 57 37 7 189 89 106 248 1 74 146 181 7 158 232 213 7 79 79 187 12 126 22 189 134 72 144 180 175 9 34 190 55 0 189 5 158 209 168 36 107 214 8 197 224 212 7 143 79 3 58 28 167 196 77 252 44 118 13 233 148 137 175 154 130 148 21 70 14 122 11 59 3 41 201 154 25 21 36 182 223 22 80 213 208 211 50 107 130 93 240 179 200 53 68 26 132 196 235 195 184 119 28 1 189 5 158 149 135 36 107 190 209 44 6 175 169 73 48 161 199 199 173 99 171 0 29 244 17 163 215 171 119 244 96 168 87 61 140 35 240 118 9 202 241 200 180 214 171 35 141 75 146 53 131 91 76 139 75 79 236 134 48 139 98 35 115 178 21 9 188 54 231 139 14 232 13 110 158 79 73 214 86 45 232 120 10 146 219 155 95 156 128 193 224 98 237 71 140 100 175 159 0 226 91 117 158 138 163 56 225 11 191 114 60 78 0 175 51 9 90 53 125 222 4 76 138 75 111 180 59 1 179 200 54 26 232 146 112 179 26 207 65 111 225 230 237 75 214 33 139 182 32 185 183 81 32 121 102 177 176 139 157 145 237 245 233 71 138 212 175 142 85 29 177 53 50 143 108 222 77 89 144 18 180 147 233 159 20 151 222 104 55 4 70 186 215 135 48 28 79 213 76 164 65 226 181 130 205 191 124 153 149 17 90 123 21 52 41 46 189 209 110 8 140 121 175 15 1 105 49 11 19 248 183 17 252 101 124 30 217 36 204 207 172 18 180 147 179 48 41 46 189 209 110 8 179 248 55 114 249 151 215 71 14 122 211 4 27 86 91 114 176 54 155 95 90 133 200 171 197 179 180 10 145 2 222 255 78 51 112 196 24 248 250 9 24 201 88 239 225 248 11 180 92 57 30 87 33 254 221 130 4 237 228 4 76 138 75 111 180 59 1 179 120 56 26 121 24 191 175 98 235 76 14 122 11 183 215 190 100 237 77 0 202 189 67 46 61 13 190 161 157 78 127 204 88 248 253 45 63 140 86 89 27 223 141 176 181 48 87 222 76 206 217 78 71 146 181 65 130 181 67 98 206 227 37 201 47 34 159 69 190 177 33 95 245 86 199 35 95 208 27 228 214 203 120 13 81 146 245 134 173 83 5 201 51 22 82 73 242 116 109 105 156 146 137 25 247 126 144 118 34 92 218 240 91 140 162 225 229 202 219 152 246 140 247 44 104 213 164 121 27 204 130 20 214 11 4 236 89 146 139 228 226 107 157 152 241 238 213 77 11 134 10 139 218 132 170 47 153 249 43 227 92 57 54 145 176 180 74 178 54 43 9 21 16 58 101 226 210 27 237 206 0 163 223 15 102 96 228 92 189 121 22 44 199 121 108 115 110 198 218 66 130 86 71 205 228 5 201 249 124 150 36 79 173 153 113 177 255 91 222 141 137 119 69 6 63 34 224 187 249 28 244 86 250 217 209 76 146 53 203 115 49 45 46 61 177 27 194 191 229 221 152 142 163 208 195 65 150 102 27 6 50 7 189 9 193 219 100 75 50 247 98 152 38 94 111 180 27 3 35 222 235 187 0 73 81 239 224 212 98 196 22 249 60 182 57 24 166 105 92 186 105 53 66 115 47 134 73 113 9 206 84 241 153 209 110 12 140 126 63 104 3 198 185 156 187 98 155 115 173 181 143 112 163 53 235 234 2 140 112 77 48 16 105 29 66 69 122 105 235 16 207 226 93 24 173 30 51 112 87 196 214 242 92 121 27 151 30 193 231 68 146 185 119 254 34 185 213 170 4 158 136 58 186 132 62 153 197 188 48 26 147 132 223 164 11 182 148 228 202 155 133 158 83 239 96 206 214 173 130 228 214 119 159 136 126 144 95 58 188 39 179 200 23 70 59 224 25 186 92 121 51 224 249 11 124 73 230 188 110 72 28 178 238 41 135 167 89 65 57 37 15 119 241 102 124 31 13 163 135 178 17 83 189 170 188 25 236 94 175 146 185 135 157 56 153 151 60 13 135 247 169 99 207 35 118 188 224 135 119 218 170 151 190 253 164 47 29 226 5 67 117 23 80 27 226 77 68 217 238 95 14 199 5 92 133 27 110 19 226 213 60 52 81 23 250 244 77 61 242 0 215 60 187 170 111 225 182 219 177 237 203 191 94 170 253 114 241 90 193 101 195 64 223 43 180 199 130 233 202 126 4 124 52 80 30 238 78 213 83 253 75 213 61 53 199 243 98 95 63 66 82 224 174 222 114 209 225 69 67 253 119 223 158 180 20 104 230 75 219 195 117 193 225 211 51 220 43 173 1 67 112 3 27 128 199 182 133 11 149 248 1 110 33 42 191 191 215 253 203 105 113 170 0 236 239 205 223 112 209 18 154 181 237 26 184 173 168 47 142 222 47 79 109 215 119 85 211 3 248 186 235 155 109 181 47 78 13 184 128 231 223 54 187 251 101 247 121 167 239 102 174 198 107 175 15 255 0 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 100 1 189 129 179 6 0 0 218 27 0 0 19 0 0 0 120 108 47 116 104 101 109 101 47 116 104 101 109 101 49 46 120 109 108 236 89 207 110 27 69 24 191 35 241 14 163 189 151 216 137 157 198 81 157 42 118 236 6 218 180 81 236 22 245 56 94 143 189 83 207 238 172 102 198 73 125 171 210 35 18 8 81 16 23 36 224 194 1 1 145 90 196 37 125 7 247 25 2 69 80 164 190 2 223 204 236 174 119 226 13 73 218 8 4 52 135 120 119 246 247 253 255 51 223 236 94 185 122 63 100 104 151 8 73 121 84 247 202 239 148 60 68 34 159 247 105 52 172 123 183 187 237 75 43 30 146 10 71 125 204 120 68 234 222 132 72 239 234 218 219 111 93 193 171 42 32 33 65 64 31 201 85 92 247 2 165 226 213 133 5 233 195 50 150 239 240 152 68 240 108 192 69 136 21 220 138 225 66 95 224 61 224 27 178 133 197 82 105 121 33 196 52 242 80 132 67 96 59 253 122 250 227 244 112 122 128 110 13 6 212 39 222 90 202 191 197 64 72 164 164 94 240 153 232 104 238 36 37 250 234 217 254 244 96 250 116 250 100 122 240 236 1 92 63 133 223 143 12 109 127 84 214 20 114 34 155 76 160 93 204 234 30 136 238 243 189 46 185 175 60 196 176 84 240 160 238 149 204 159 183 176 118 101 1 175 38 68 76 157 64 155 163 107 155 191 132 46 33 232 143 22 141 76 49 236 101 66 203 237 74 237 242 70 198 223 0 152 154 199 181 90 173 102 171 156 241 51 0 236 251 96 185 213 37 207 179 210 94 41 55 82 158 57 144 189 156 231 221 44 85 75 21 23 159 227 191 52 167 115 173 209 104 84 107 137 46 150 169 1 217 203 202 28 126 165 180 92 89 95 116 240 6 100 241 213 57 124 165 177 222 108 46 59 120 3 178 248 229 57 124 251 114 109 185 226 226 13 40 96 52 26 205 161 117 64 219 237 132 123 6 25 112 182 89 8 95 1 248 74 41 129 207 80 144 13 89 182 105 17 3 30 169 179 230 94 136 239 113 209 6 2 77 200 176 162 17 82 147 152 12 176 15 137 222 196 97 79 80 172 5 226 85 130 115 79 236 146 47 231 150 180 108 36 125 65 99 85 247 222 139 49 20 205 140 223 203 195 239 94 30 62 70 47 15 15 142 246 159 28 237 255 116 244 240 225 209 254 15 150 151 67 184 137 163 97 158 240 197 55 31 255 241 197 3 244 251 227 47 95 60 250 180 24 47 243 248 95 190 255 224 231 167 159 20 3 161 162 102 26 61 255 236 224 215 39 7 207 63 255 240 183 111 31 21 192 215 5 238 229 225 93 26 18 137 110 146 61 180 195 67 176 205 56 198 213 156 244 196 249 40 186 1 166 14 5 14 128 119 1 235 150 10 28 224 205 9 102 69 184 6 113 157 119 71 64 51 41 2 94 27 223 115 116 237 4 98 172 104 129 228 235 65 232 0 183 56 103 13 46 10 29 112 93 203 202 121 184 59 142 134 197 194 197 56 143 219 193 120 183 72 118 19 71 78 104 91 227 24 186 106 154 148 142 239 155 1 113 212 220 102 56 82 120 72 34 162 144 126 198 71 132 20 88 119 151 82 199 175 91 212 23 92 242 129 66 119 41 106 96 90 232 146 46 237 57 137 52 35 218 164 33 196 101 82 100 51 132 218 241 205 214 29 212 224 172 200 234 13 178 235 34 161 32 48 43 80 190 75 152 227 198 107 120 172 112 88 196 178 139 67 150 119 248 13 172 130 34 37 59 19 225 231 113 45 169 32 210 67 194 56 106 245 137 148 69 52 183 4 216 155 11 250 117 12 253 171 48 236 91 108 18 186 72 161 232 168 136 231 13 204 121 30 185 193 71 205 0 135 113 17 182 67 163 32 143 125 87 142 32 69 49 218 230 170 8 190 197 221 10 209 247 16 7 28 157 24 238 59 148 56 225 62 189 17 220 166 67 71 165 89 130 232 39 99 81 16 203 107 132 59 249 219 153 176 1 38 166 203 64 139 119 58 117 72 163 191 106 219 140 66 223 182 18 222 180 237 186 183 14 155 88 81 241 108 30 107 214 39 225 254 133 45 122 3 143 163 109 2 85 49 191 69 189 233 208 111 58 180 247 159 239 208 39 213 242 197 247 229 89 43 134 46 173 7 18 59 123 155 73 60 60 243 32 62 160 140 117 212 132 145 27 210 204 226 18 54 164 126 27 22 53 31 115 78 37 217 65 45 14 224 82 87 54 8 116 112 67 129 13 13 18 92 189 79 85 208 9 112 12 115 124 217 211 76 134 50 97 61 148 40 230 18 206 147 102 185 144 183 198 195 89 64 217 211 104 85 159 83 108 39 145 88 109 241 190 93 94 210 203 233 113 36 99 99 180 26 154 51 112 42 104 73 51 56 171 176 165 203 9 83 176 237 85 132 149 181 82 103 150 86 54 170 153 38 233 72 203 76 214 46 54 231 120 112 121 102 26 44 102 222 132 73 7 193 124 4 94 94 134 55 5 90 52 156 127 48 35 125 237 119 27 163 52 44 38 10 23 25 34 25 224 62 73 98 164 237 158 143 81 217 4 41 205 149 57 67 180 29 54 25 244 217 242 20 175 229 164 213 52 219 215 144 118 150 32 229 197 85 78 16 151 70 239 117 162 148 102 240 44 74 192 237 120 57 178 40 95 156 44 66 123 117 175 86 93 172 122 200 199 113 221 27 192 209 25 46 195 24 162 46 245 112 137 217 16 94 81 249 74 216 180 63 181 152 77 149 207 162 89 75 13 115 139 160 12 111 71 172 223 231 12 118 250 64 44 164 218 192 50 176 169 97 30 37 41 192 34 45 201 234 191 88 5 183 94 148 1 5 221 232 108 90 44 173 64 50 252 99 90 128 31 221 208 146 193 128 248 42 31 236 220 138 246 157 189 77 90 41 31 43 34 58 65 127 15 245 216 88 236 96 8 191 78 85 176 167 79 37 188 1 49 29 65 223 192 235 59 237 109 243 200 109 206 73 209 229 95 154 25 156 93 199 44 14 112 210 110 117 137 166 149 108 225 166 33 101 58 152 187 156 122 96 91 161 238 198 184 243 155 98 74 254 130 76 201 167 241 255 204 20 189 159 192 43 137 165 190 142 128 15 47 148 5 70 186 82 234 30 23 42 224 208 133 226 128 250 109 1 131 132 233 29 144 45 240 10 24 30 67 82 193 107 109 243 43 200 174 254 181 53 103 121 152 178 134 147 165 218 161 67 36 40 236 71 42 16 132 108 67 91 50 217 119 10 179 114 178 119 89 150 44 97 100 50 42 167 174 140 173 218 61 178 75 88 87 247 192 101 189 183 123 40 128 84 55 221 36 105 3 6 119 60 255 220 251 164 130 122 67 61 228 228 235 205 233 100 217 222 107 107 224 239 158 124 108 49 131 81 110 31 54 3 77 234 255 76 197 108 60 152 237 170 150 222 144 167 123 111 222 16 253 96 54 102 85 210 170 0 97 185 173 160 150 148 253 43 170 112 206 173 214 118 172 57 139 23 171 169 114 16 197 121 139 97 49 27 136 98 120 177 132 244 63 216 255 168 240 153 253 64 162 55 212 46 223 129 222 138 224 251 134 102 6 105 3 89 125 201 14 30 72 55 72 187 216 131 193 201 46 218 100 210 172 172 107 147 209 73 123 45 221 172 47 120 210 205 228 30 115 182 214 236 44 241 62 167 179 179 225 204 21 231 212 226 69 58 59 241 176 227 107 187 118 162 171 33 178 199 75 20 150 6 233 193 198 4 198 124 92 203 127 252 226 189 123 16 232 13 248 140 48 102 74 154 100 130 79 89 2 195 12 221 49 117 0 197 111 37 26 210 181 63 1 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 91 39 7 248 66 4 0 0 0 18 0 0 13 0 0 0 120 108 47 115 116 121 108 101 115 46 120 109 108 196 88 205 110 227 54 16 190 23 232 59 8 188 59 146 108 217 145 12 203 139 117 178 6 22 216 2 5 146 2 189 210 18 101 19 75 145 2 69 103 237 45 122 238 97 223 161 239 208 99 15 125 135 228 141 58 164 126 29 255 169 141 147 13 16 152 164 200 111 190 249 56 195 161 52 121 183 73 153 245 64 100 78 5 15 145 123 229 32 139 240 72 196 148 47 67 244 203 253 188 231 35 43 87 152 199 152 9 78 66 180 37 57 122 55 253 241 135 73 174 182 140 220 173 8 81 22 64 240 60 68 43 165 178 177 109 231 209 138 164 56 191 18 25 225 240 36 17 50 197 10 186 114 105 231 153 36 56 206 245 162 148 217 125 199 25 217 41 166 28 21 8 227 52 234 2 146 98 249 121 157 245 34 145 102 88 209 5 101 84 109 13 22 178 210 104 252 113 201 133 196 11 6 84 55 174 135 163 10 219 116 246 224 83 26 73 145 139 68 93 1 156 45 146 132 70 100 159 101 96 7 54 32 77 39 137 224 42 183 34 177 230 42 68 67 128 214 22 198 159 185 248 194 231 250 17 8 88 206 154 78 242 175 214 3 102 48 226 34 123 58 137 4 19 210 82 160 12 16 51 35 28 167 164 152 113 131 25 93 72 170 167 37 56 165 108 91 12 247 205 186 21 150 57 72 108 160 250 142 167 199 140 192 229 218 148 130 187 122 208 214 220 10 134 135 109 203 229 34 68 115 248 115 224 79 175 120 77 2 11 77 179 20 192 223 53 246 94 82 204 244 80 39 95 119 220 106 163 126 15 89 119 236 155 173 120 171 109 53 50 228 160 25 101 172 14 64 215 209 193 6 35 211 9 100 130 34 146 207 161 99 149 237 251 109 6 161 198 33 105 181 216 118 49 239 204 236 165 196 91 183 63 236 190 32 23 140 198 154 197 242 198 4 56 229 49 217 144 56 68 222 64 131 44 158 15 143 140 106 118 139 110 87 106 207 45 149 169 52 66 150 162 58 27 157 171 235 32 8 124 119 228 251 126 224 13 92 207 51 249 243 138 12 202 132 114 156 153 51 52 9 245 138 182 74 111 225 200 169 188 29 128 183 215 195 161 63 116 131 190 7 255 230 76 121 69 6 245 241 161 15 144 183 217 219 224 251 121 91 234 253 70 142 94 95 208 81 147 232 112 82 44 132 140 161 170 87 197 170 15 73 90 12 77 39 140 36 10 146 83 210 229 74 255 42 145 233 84 21 74 65 9 156 78 98 138 151 130 99 6 77 187 90 81 253 234 149 112 27 128 194 31 34 181 130 194 93 21 182 58 239 203 4 215 19 75 11 157 230 27 46 134 74 167 233 64 185 98 220 105 126 225 220 97 223 74 39 65 178 136 48 118 167 157 251 53 169 117 211 245 124 147 88 124 157 206 83 245 17 14 54 184 31 233 74 91 53 225 192 45 155 133 70 69 71 107 215 70 43 176 219 176 254 255 194 181 54 73 109 224 24 171 62 16 44 89 65 179 97 229 194 117 165 92 109 225 44 99 91 125 99 209 119 145 178 7 107 154 222 204 68 79 211 127 207 232 146 167 164 88 48 157 192 133 165 232 90 43 33 233 87 0 210 55 157 8 158 19 137 172 47 18 103 247 100 99 192 181 18 155 228 184 134 23 102 11 230 142 233 162 55 238 208 110 237 233 210 248 222 13 109 112 90 229 35 186 158 192 6 70 221 152 238 238 224 127 229 237 181 121 131 58 207 162 163 228 125 130 103 75 209 29 172 61 69 231 47 210 224 12 118 167 40 62 225 5 108 95 165 54 148 215 38 95 246 21 57 104 233 4 114 75 31 184 166 52 200 151 208 167 133 13 213 227 178 216 173 248 59 131 125 80 145 226 60 233 20 141 45 75 103 20 186 160 37 120 161 61 165 215 75 45 65 184 86 241 4 155 212 88 58 26 79 221 34 8 46 67 13 214 37 34 168 165 253 25 236 174 138 152 146 7 69 174 85 73 119 234 104 93 17 45 253 234 25 162 199 63 31 255 122 250 246 244 199 227 63 79 223 30 255 110 29 64 139 53 101 112 207 173 75 93 83 75 1 59 222 52 213 217 220 207 148 126 219 55 117 187 182 6 90 199 36 193 107 166 238 235 135 33 106 218 63 145 152 174 83 112 187 156 245 51 125 16 202 64 132 168 105 127 210 23 36 119 164 47 187 80 205 62 229 112 163 129 95 107 45 105 136 126 251 48 187 14 110 63 204 251 61 223 153 249 61 111 64 134 189 96 56 187 237 13 189 155 217 237 237 60 112 250 206 205 239 224 147 254 52 50 134 239 4 47 248 244 96 62 145 64 97 115 189 113 206 224 3 133 44 157 45 201 223 53 99 33 106 117 10 250 230 93 14 104 67 29 174 156 176 243 250 211 205 244 95 0 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 75 124 184 109 44 7 0 0 227 22 0 0 20 0 0 0 120 108 47 115 104 97 114 101 100 83 116 114 105 110 103 115 46 120 109 108 164 88 219 78 27 87 20 125 175 212 127 56 242 83 162 52 120 206 92 124 65 64 30 42 245 11 218 15 64 137 155 32 129 73 177 83 181 111 132 164 105 170 68 194 129 144 24 99 192 38 41 180 74 37 8 212 137 49 193 252 194 158 63 234 218 103 60 198 62 123 44 156 148 4 4 62 246 190 174 181 246 62 51 117 235 151 133 121 245 115 97 169 52 183 88 156 78 233 9 39 165 10 197 219 139 119 230 138 119 167 83 63 124 255 221 205 92 74 149 202 179 197 59 179 243 139 197 194 116 234 215 66 41 117 107 230 235 175 166 74 165 178 194 103 139 165 233 212 189 114 249 254 100 58 93 186 125 175 176 48 91 154 88 188 95 40 226 228 199 197 165 133 217 50 254 92 186 155 46 221 95 42 204 222 41 221 43 20 202 11 243 105 215 113 50 233 133 217 185 98 74 221 94 124 80 44 79 167 252 140 159 82 15 138 115 63 61 40 124 27 189 162 93 157 154 153 42 205 205 76 149 103 104 157 234 83 233 242 204 84 154 255 238 189 86 163 46 253 43 94 221 166 35 250 72 199 248 121 78 109 106 169 112 5 111 195 159 225 50 29 137 55 179 137 179 155 56 238 138 163 125 106 193 130 252 72 51 92 97 83 124 166 232 2 191 118 225 134 29 34 24 106 195 91 139 206 194 231 194 92 13 31 57 195 59 223 135 203 226 172 73 221 112 57 92 17 175 191 69 212 15 77 244 157 132 64 118 225 187 77 159 168 21 254 30 37 27 174 10 11 27 116 10 11 29 165 21 189 128 161 19 132 216 139 252 79 254 36 71 202 101 10 159 80 199 28 139 50 104 223 247 221 28 218 149 23 182 43 48 217 160 42 213 104 135 154 244 78 193 209 49 76 126 152 80 215 96 207 20 79 161 48 71 236 188 67 39 215 213 100 206 182 1 235 129 118 28 237 101 236 19 216 174 208 107 88 223 98 15 48 192 53 135 135 243 240 25 157 142 118 21 62 13 87 174 219 182 60 31 80 114 240 37 252 27 47 53 248 168 208 43 124 111 15 101 97 37 193 57 8 203 142 235 235 0 150 181 125 66 235 166 59 239 195 103 138 254 66 205 63 209 5 154 117 142 114 119 57 135 209 25 104 83 43 219 156 73 193 135 35 215 62 161 151 244 14 129 31 14 88 28 35 112 215 216 114 242 90 182 181 134 66 112 241 15 208 216 170 162 253 240 17 34 66 232 212 86 215 232 248 186 178 172 155 222 218 65 33 92 159 203 226 248 246 9 140 86 104 151 222 0 49 123 84 81 84 7 120 182 240 253 18 47 31 42 122 207 152 68 137 128 198 8 213 19 3 121 217 176 26 89 41 39 231 56 222 149 174 47 224 203 100 6 88 129 95 225 234 151 184 98 92 105 217 253 225 44 81 50 48 3 210 0 205 24 112 99 254 72 76 74 50 133 1 224 100 224 76 50 133 125 53 80 205 29 122 75 27 40 230 63 3 121 160 208 13 28 48 184 55 149 235 232 128 78 70 176 211 110 84 76 252 172 68 28 19 230 13 48 178 109 200 95 233 187 83 104 185 180 15 252 92 128 0 172 47 199 160 241 35 65 207 216 147 155 212 177 100 79 19 86 213 18 105 207 118 25 131 153 36 140 55 192 154 87 168 204 90 148 69 63 135 68 203 106 82 116 56 86 174 164 126 32 99 228 9 69 127 100 228 143 142 49 39 34 60 3 2 140 180 223 100 15 18 51 48 44 117 114 217 64 102 192 146 181 73 245 203 184 109 147 112 196 146 171 60 187 177 6 73 32 136 235 216 39 166 173 208 218 143 134 132 16 240 33 173 181 29 152 136 39 181 176 18 5 157 247 180 68 42 55 19 246 119 81 247 6 160 186 121 69 244 118 124 113 228 58 176 79 104 139 107 174 32 185 45 140 100 140 67 204 104 158 19 92 119 140 60 86 148 15 92 121 229 124 147 49 130 149 152 140 109 53 239 100 221 76 0 222 137 238 27 217 106 152 201 183 54 196 55 75 28 185 9 182 85 173 131 192 247 130 32 209 42 246 0 124 6 76 9 159 247 139 99 100 226 255 101 210 67 171 163 229 4 220 1 43 187 225 31 144 166 46 150 37 248 122 8 57 52 235 8 4 31 120 237 98 116 153 114 222 192 175 39 6 214 79 120 168 217 149 29 135 145 104 160 23 96 228 59 2 148 64 196 151 132 113 3 97 180 184 235 225 147 241 34 154 16 221 136 54 16 55 151 181 79 16 210 101 186 168 73 180 219 140 147 102 95 208 36 110 118 1 123 134 254 62 239 99 60 249 214 141 120 55 121 214 14 241 1 226 196 90 190 7 153 2 77 134 215 169 68 84 245 246 180 4 86 143 239 179 134 216 42 152 204 216 131 198 246 26 240 4 244 164 64 237 94 54 166 11 76 97 103 142 212 100 56 149 30 25 225 151 223 244 16 155 232 42 68 75 18 60 6 112 86 2 120 32 189 131 104 95 132 81 96 2 72 238 41 152 213 51 46 95 226 16 226 141 37 97 220 69 14 154 209 30 186 11 187 188 253 159 0 15 71 188 18 13 247 102 148 109 179 12 201 180 144 247 14 189 134 154 240 4 175 210 118 159 243 114 135 78 28 16 172 136 58 200 234 4 45 105 194 38 15 137 61 133 31 155 104 234 11 3 189 245 209 46 140 7 53 41 196 213 172 206 190 231 7 146 34 3 78 248 22 208 64 6 44 182 70 54 58 118 109 116 111 98 136 133 162 239 64 78 140 1 7 13 30 30 70 114 145 214 151 184 233 23 75 4 128 234 152 197 9 91 104 68 207 77 198 37 107 241 57 6 10 223 236 78 237 100 146 27 205 235 134 159 117 2 73 124 94 207 184 205 32 52 219 110 51 37 216 54 72 1 213 101 201 239 152 23 78 249 74 166 204 37 64 77 138 133 40 239 6 248 159 211 25 153 194 222 165 82 43 228 195 87 77 172 91 124 71 173 199 219 251 48 84 77 55 70 233 161 147 149 189 24 242 112 192 244 70 129 218 24 169 1 23 131 245 247 44 77 29 91 70 99 49 244 100 200 198 6 236 60 5 79 175 92 190 147 128 25 223 30 69 157 112 229 50 215 45 158 92 87 0 222 142 55 94 50 92 137 246 191 209 191 181 8 41 125 163 54 46 70 210 148 239 36 9 52 61 4 47 249 254 99 238 90 131 178 133 7 23 241 204 177 125 68 87 68 200 164 16 195 184 216 190 32 49 29 226 110 21 221 172 218 202 48 148 31 27 180 12 12 121 178 157 27 173 108 217 174 184 179 66 43 81 130 232 169 130 171 128 103 190 219 226 153 2 162 141 46 81 215 232 72 124 34 142 43 225 82 182 6 46 92 5 0 38 136 12 3 157 242 89 87 181 68 86 141 85 26 124 234 134 143 145 27 51 138 62 133 207 122 75 97 92 215 232 58 59 150 128 235 60 190 180 227 137 130 131 116 144 7 172 79 40 234 192 32 106 26 156 68 87 50 200 162 194 155 80 106 73 54 214 139 124 54 159 147 227 115 7 155 1 223 221 246 89 47 46 176 221 94 32 254 229 254 106 11 116 60 230 9 167 248 74 105 175 62 173 113 114 50 106 200 152 148 68 111 114 184 40 249 25 76 199 197 130 179 85 219 207 103 174 211 125 216 120 138 106 144 14 132 207 209 203 167 86 49 5 61 41 163 209 13 2 31 182 246 124 243 220 32 90 48 70 177 38 17 67 188 87 112 19 180 100 123 221 48 189 74 77 252 187 188 227 142 24 204 32 163 64 97 223 182 68 77 29 116 220 227 41 22 99 230 0 59 87 133 6 31 226 88 61 140 134 103 146 27 218 139 150 114 222 157 108 49 3 128 250 123 149 56 219 192 18 211 54 11 244 138 56 171 51 0 208 159 54 147 90 156 86 233 35 247 15 167 160 150 56 229 77 224 165 120 149 243 171 98 22 109 32 83 190 118 243 211 182 42 109 136 247 241 167 249 153 223 1 222 201 207 136 214 104 71 188 103 223 88 169 136 215 155 160 76 157 199 236 229 73 26 15 169 103 254 3 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 119 236 40 235 149 1 0 0 94 8 0 0 16 0 0 0 120 108 47 99 97 108 99 67 104 97 105 110 46 120 109 108 100 214 221 74 195 48 24 198 241 115 193 123 40 57 119 205 155 207 69 214 237 64 208 27 208 11 40 93 220 6 253 24 109 17 189 123 171 232 38 254 79 10 125 154 188 249 189 105 160 221 236 222 187 182 120 203 227 116 26 250 74 201 74 171 34 247 205 176 63 245 135 74 189 60 63 222 173 85 49 205 117 191 175 219 161 207 149 250 200 147 218 109 111 111 54 77 221 54 15 199 250 212 23 75 133 126 170 212 113 158 207 247 101 57 53 199 220 213 211 106 56 231 126 121 242 58 140 93 61 47 183 227 161 156 206 99 174 247 211 49 231 185 107 75 163 117 40 187 165 128 218 110 154 98 172 212 83 92 214 58 45 8 85 180 95 215 242 146 167 159 252 146 172 23 230 247 200 107 178 204 250 151 24 36 22 137 67 226 145 4 36 17 201 175 252 234 129 57 193 156 96 78 48 39 152 19 204 9 230 4 115 130 57 193 156 96 22 13 180 104 168 69 131 45 26 110 209 128 139 134 92 52 232 162 97 23 13 188 104 234 5 250 136 82 14 4 7 129 227 44 172 239 176 188 199 234 30 91 231 177 115 30 27 231 177 111 30 102 15 179 135 217 195 236 97 14 48 7 152 3 204 1 230 0 115 128 57 192 28 96 14 48 7 152 35 204 17 230 8 115 132 57 194 28 97 118 24 131 50 24 129 34 232 27 109 163 107 52 205 163 45 104 90 208 180 64 43 224 10 188 2 176 64 44 32 11 204 6 47 202 192 108 96 54 48 27 152 13 204 6 102 3 179 129 217 192 108 97 182 48 91 152 45 204 22 102 11 179 133 217 194 108 97 182 48 59 152 29 204 14 102 4 114 57 81 255 191 199 112 186 63 253 150 151 63 131 237 39 0 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 72 128 176 5 164 1 0 0 0 40 0 0 39 0 0 0 120 108 47 112 114 105 110 116 101 114 83 101 116 116 105 110 103 115 47 112 114 105 110 116 101 114 83 101 116 116 105 110 103 115 49 46 98 105 110 236 152 65 75 195 48 20 199 255 217 58 215 177 195 252 8 30 4 65 16 68 122 242 180 225 188 11 67 240 58 232 144 129 122 208 42 30 235 189 7 207 59 123 246 235 120 241 195 248 94 66 215 13 219 206 154 244 80 250 178 173 73 243 146 127 146 95 147 229 53 51 204 113 143 39 60 227 1 183 56 192 53 197 75 188 96 129 71 202 157 227 142 242 174 40 189 164 252 136 210 83 157 54 118 80 80 30 188 111 28 30 141 190 222 148 194 0 171 97 224 135 80 232 227 166 67 86 42 209 165 235 4 1 23 118 28 88 157 26 41 12 179 203 139 105 161 209 177 129 251 98 198 235 88 88 228 26 78 96 208 240 254 75 247 235 35 176 95 147 116 183 38 93 183 178 175 56 33 193 137 222 81 120 167 177 11 230 31 56 142 99 146 121 55 55 118 130 82 187 249 4 188 10 67 96 215 39 34 71 39 162 169 184 64 88 161 102 61 69 79 113 142 237 95 89 59 233 140 231 126 151 57 69 101 26 121 182 30 101 178 43 119 246 235 147 87 186 56 175 202 147 40 86 169 207 98 235 162 166 252 235 235 97 75 148 71 233 56 85 72 139 80 241 66 92 127 115 167 182 38 191 198 79 111 33 89 58 149 218 17 43 14 166 76 150 218 81 231 79 230 255 239 195 125 210 39 207 113 59 226 251 192 231 87 172 213 80 183 63 198 152 226 222 158 167 179 149 94 248 108 252 56 254 236 100 24 116 81 185 8 1 33 32 4 132 128 16 16 2 66 64 8 8 1 119 4 214 46 183 59 73 81 106 22 1 62 120 144 32 4 236 8 40 115 128 107 39 178 81 219 254 116 89 249 72 146 100 67 82 146 45 39 64 155 157 236 119 45 159 3 50 124 33 32 4 132 128 16 16 2 77 38 240 3 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 104 223 165 118 167 1 0 0 116 3 0 0 16 0 8 1 100 111 99 80 114 111 112 115 47 97 112 112 46 120 109 108 32 162 4 1 40 160 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 156 147 193 110 19 49 16 134 239 72 188 195 202 247 198 155 52 66 40 242 186 66 41 168 7 16 145 146 246 62 120 103 19 11 175 109 217 211 85 194 13 174 60 2 47 194 99 52 111 132 55 203 54 187 180 234 129 219 204 252 163 223 223 120 108 113 181 175 77 214 96 136 218 217 130 77 39 57 203 208 42 87 106 187 45 216 237 230 195 197 91 150 69 2 91 130 113 22 11 118 192 200 174 228 235 87 98 21 156 199 64 26 99 150 44 108 44 216 142 200 47 56 143 106 135 53 196 73 146 109 82 42 23 106 160 148 134 45 119 85 165 21 94 59 117 95 163 37 62 203 243 55 28 247 132 182 196 242 194 63 26 178 206 113 209 208 255 154 150 78 181 124 241 110 115 240 9 88 138 119 222 27 173 128 210 148 242 147 86 193 69 87 81 246 126 175 208 8 62 20 69 162 91 163 186 15 154 14 50 23 124 152 138 181 2 131 203 100 44 43 48 17 5 63 23 196 13 66 123 105 43 208 33 74 209 208 162 65 69 46 100 81 127 75 215 54 99 217 23 136 216 226 20 172 129 160 193 82 194 106 219 186 228 20 27 31 41 200 135 95 15 191 143 223 143 63 142 63 5 79 13 93 241 20 14 123 135 177 158 203 249 169 33 5 227 198 214 160 3 73 194 24 113 163 201 96 252 92 173 32 208 51 196 243 33 241 137 161 227 29 51 118 199 254 69 124 132 237 39 152 14 7 120 162 206 94 84 47 135 234 104 140 127 192 151 174 246 96 15 178 125 164 24 4 239 115 241 81 219 175 241 214 111 220 53 16 246 27 27 23 197 122 7 1 203 180 228 94 63 23 196 77 90 86 48 173 201 114 7 118 139 101 223 243 84 104 223 215 93 247 137 228 116 62 201 47 243 244 116 6 53 193 207 223 69 254 1 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 136 136 237 20 114 1 0 0 161 2 0 0 17 0 8 1 100 111 99 80 114 111 112 115 47 99 111 114 101 46 120 109 108 32 162 4 1 40 160 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 140 146 205 74 3 49 20 133 247 130 239 48 100 63 77 50 245 143 48 29 65 197 149 66 193 138 226 70 66 114 109 131 147 100 72 162 109 119 62 128 175 34 136 43 193 151 152 190 145 233 180 51 182 232 194 101 56 231 126 57 231 114 243 227 153 46 147 103 112 94 89 51 64 180 71 80 2 70 88 169 204 120 128 174 71 231 233 17 74 124 224 70 242 210 26 24 160 57 120 116 92 236 238 228 162 98 194 58 24 58 91 129 11 10 124 18 73 198 51 81 13 208 36 132 138 97 236 197 4 52 247 189 232 48 81 124 176 78 243 16 159 110 140 43 46 30 249 24 112 70 200 1 214 16 184 228 129 227 37 48 173 58 34 90 35 165 232 144 213 147 43 27 128 20 24 74 208 96 130 199 180 71 241 143 55 128 211 254 207 129 70 217 112 106 21 230 85 236 180 142 187 201 150 98 37 118 238 153 87 157 113 58 157 246 166 253 38 70 204 79 241 237 229 197 85 83 53 85 102 185 43 1 168 200 165 96 194 1 15 214 21 90 57 235 39 143 202 240 123 203 115 188 161 44 183 88 114 31 46 227 194 31 20 200 147 121 81 191 213 95 139 215 250 163 254 92 188 212 239 57 254 237 104 135 134 78 153 0 178 200 8 221 79 201 97 154 101 35 74 89 159 48 122 120 215 205 181 166 152 167 169 191 10 5 50 137 133 216 170 126 171 220 244 79 207 70 231 104 139 71 24 33 108 111 47 242 90 87 83 42 254 218 1 245 58 251 63 137 25 203 40 35 7 27 196 22 80 52 161 183 143 170 248 6 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 143 135 188 32 165 1 0 0 0 40 0 0 39 0 0 0 120 108 47 112 114 105 110 116 101 114 83 101 116 116 105 110 103 115 47 112 114 105 110 116 101 114 83 101 116 116 105 110 103 115 50 46 98 105 110 236 152 65 75 195 48 20 199 255 113 157 235 216 97 126 4 15 130 32 8 34 61 121 218 112 222 133 33 120 29 116 200 64 61 104 21 189 213 123 15 158 247 5 188 248 125 188 248 97 124 47 161 221 134 109 103 77 115 40 125 217 214 164 121 201 63 201 175 201 242 154 41 102 184 195 35 158 112 143 27 236 227 138 226 5 158 49 199 3 229 206 112 75 121 151 148 94 80 126 68 233 137 78 27 59 40 40 15 222 55 14 14 135 95 111 74 161 143 229 32 240 67 40 244 112 189 67 86 42 209 161 235 24 1 23 174 57 176 58 53 82 24 166 23 231 147 66 99 205 6 238 139 25 111 205 194 34 215 112 2 253 134 247 95 186 239 142 192 158 35 233 142 35 221 122 101 95 112 76 130 99 189 163 240 78 99 23 204 63 112 28 199 36 243 110 110 236 4 165 118 243 9 120 21 134 192 174 79 68 142 78 68 83 113 142 176 66 77 55 69 79 112 134 205 95 89 59 233 140 231 126 151 57 69 101 26 121 182 46 101 178 43 119 250 235 147 87 186 56 175 202 147 40 86 113 103 177 117 81 83 254 238 122 216 18 229 97 58 78 21 210 34 84 188 16 179 111 238 212 214 228 51 252 244 22 178 74 167 82 91 98 197 193 148 89 165 182 212 249 147 249 255 251 112 143 244 201 115 220 140 248 62 240 249 21 107 57 208 237 143 48 162 184 187 235 233 108 165 23 62 27 63 142 62 95 87 24 116 81 185 8 1 33 32 4 132 128 16 16 2 66 64 8 8 129 250 8 100 46 119 125 146 162 212 44 2 124 240 32 65 8 216 17 80 230 0 215 78 100 173 182 253 233 178 242 145 36 201 154 164 36 91 78 128 54 59 217 239 90 62 7 100 248 66 64 8 8 1 33 32 4 154 76 224 7 0 0 255 255 3 0 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 58 240 203 171 141 1 0 0 28 7 0 0 19 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 91 67 111 110 116 101 110 116 95 84 121 112 101 115 93 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 181 85 48 35 245 0 0 0 76 2 0 0 11 0 0 0 0 0 0 0 0 0 0 0 0 0 198 3 0 0 95 114 101 108 115 47 46 114 101 108 115 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 108 251 89 76 41 1 0 0 230 4 0 0 26 0 0 0 0 0 0 0 0 0 0 0 0 0 236 6 0 0 120 108 47 95 114 101 108 115 47 119 111 114 107 98 111 111 107 46 120 109 108 46 114 101 108 115 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 233 11 116 222 219 1 0 0 161 3 0 0 15 0 0 0 0 0 0 0 0 0 0 0 0 0 85 9 0 0 120 108 47 119 111 114 107 98 111 111 107 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 126 193 138 229 96 1 0 0 116 2 0 0 24 0 0 0 0 0 0 0 0 0 0 0 0 0 93 11 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 52 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 19 196 44 19 194 0 0 0 66 1 0 0 35 0 0 0 0 0 0 0 0 0 0 0 0 0 243 12 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 95 114 101 108 115 47 115 104 101 101 116 50 46 120 109 108 46 114 101 108 115 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 59 109 50 75 193 0 0 0 66 1 0 0 35 0 0 0 0 0 0 0 0 0 0 0 0 0 246 13 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 95 114 101 108 115 47 115 104 101 101 116 49 46 120 109 108 46 114 101 108 115 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 75 248 57 47 182 22 0 0 34 131 0 0 24 0 0 0 0 0 0 0 0 0 0 0 0 0 248 14 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 50 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 126 193 138 229 96 1 0 0 116 2 0 0 24 0 0 0 0 0 0 0 0 0 0 0 0 0 228 37 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 51 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 130 159 128 146 254 9 0 0 59 43 0 0 24 0 0 0 0 0 0 0 0 0 0 0 0 0 122 39 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 49 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 100 1 189 129 179 6 0 0 218 27 0 0 19 0 0 0 0 0 0 0 0 0 0 0 0 0 174 49 0 0 120 108 47 116 104 101 109 101 47 116 104 101 109 101 49 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 91 39 7 248 66 4 0 0 0 18 0 0 13 0 0 0 0 0 0 0 0 0 0 0 0 0 146 56 0 0 120 108 47 115 116 121 108 101 115 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 75 124 184 109 44 7 0 0 227 22 0 0 20 0 0 0 0 0 0 0 0 0 0 0 0 0 255 60 0 0 120 108 47 115 104 97 114 101 100 83 116 114 105 110 103 115 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 119 236 40 235 149 1 0 0 94 8 0 0 16 0 0 0 0 0 0 0 0 0 0 0 0 0 93 68 0 0 120 108 47 99 97 108 99 67 104 97 105 110 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 72 128 176 5 164 1 0 0 0 40 0 0 39 0 0 0 0 0 0 0 0 0 0 0 0 0 32 70 0 0 120 108 47 112 114 105 110 116 101 114 83 101 116 116 105 110 103 115 47 112 114 105 110 116 101 114 83 101 116 116 105 110 103 115 49 46 98 105 110 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 104 223 165 118 167 1 0 0 116 3 0 0 16 0 0 0 0 0 0 0 0 0 0 0 0 0 9 72 0 0 100 111 99 80 114 111 112 115 47 97 112 112 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 136 136 237 20 114 1 0 0 161 2 0 0 17 0 0 0 0 0 0 0 0 0 0 0 0 0 230 74 0 0 100 111 99 80 114 111 112 115 47 99 111 114 101 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 143 135 188 32 165 1 0 0 0 40 0 0 39 0 0 0 0 0 0 0 0 0 0 0 0 0 143 77 0 0 120 108 47 112 114 105 110 116 101 114 83 101 116 116 105 110 103 115 47 112 114 105 110 116 101 114 83 101 116 116 105 110 103 115 50 46 98 105 110 80 75 5 6 0 0 0 0 18 0 18 0 220 4 0 0 121 79 0 0 0 0]! !

!TabularResources class methodsFor: 'example creation' stamp: 'MYI 8/2/2015 11:07'!
createTestNamed: aName fromFileNamed: aFile
	TabularResources class
		compile:
			aName,	'
 ^ ' , aFile asFileReference binaryReadStream contents fullPrintString! !

!TabularResources class methodsFor: 'example creation' stamp: 'HannesHirzel 8/11/2015 21:21'!
example1Creation

self createTestNamed: 'testExcelFile1OneSheetOnly' fromFileNamed: (FileLocator home / self fileNameOfExample1)
! !

!TabularResources class methodsFor: 'example creation' stamp: 'HannesHirzel 8/11/2015 21:01'!
example3Creation

self createTestNamed: 'testExcelFile3WithAlignment' fromFileNamed: (FileLocator home / 'TabularTest3.xlsx')
! !

!TabularResources class methodsFor: 'example creation' stamp: 'HannesHirzel 8/11/2015 21:22'!
fileNameOfExample1

 ^ 'TabularTestExcelFile1OneSheetOnly.xlsx'
! !

!TabularResources class methodsFor: 'example creation' stamp: 'HannesHirzel 8/12/2015 04:55'!
fileNameOfExample2

 ^ 'TabularTestExcelFile2withTreeSheets.xlsx'
! !

!TabularResources class methodsFor: 'example creation' stamp: 'HannesHirzel 8/12/2015 06:02'!
fileNameOfExample3

 ^ 'TabularTestExcelFile3withAlignment.xlsx'
! !

!TabularResources class methodsFor: 'as yet unclassified' stamp: 'VincentBlondeau 12/11/2014 12:56'!
openTestFile: aTestName
	|  fileName writeStream |
	fileName := FileLocator home / (aTestName asString , '.xlsx').
	[ 
	writeStream := StandardFileStream forceNewFileNamed: fileName.
	writeStream << (self perform: aTestName) asString ]
		ensure: [  writeStream close].
	[ NBWin32Shell shellOpen: fileName fullName ] fork! !

!TabularResources class methodsFor: 'examples' stamp: 'HannesHirzel 8/12/2015 04:56'!
testExcelFile1OneSheetOnly

"  (FileLocator home / self fileNameOfExample1  ) asFileReference writeStreamDo: [ :stream | 
    stream 
        binary; 
        nextPutAll: self testExcelFile1OneSheetOnly ]
"
"see http://stackoverflow.com/questions/31934877/pharo-filesystem-how-do-i-write-a-binary-file"


 ^ #[80 75 3 4 20 0 8 8 8 0 185 168 11 71 0 0 0 0 0 0 0 0 0 0 0 0 11 0 0 0 95 114 101 108 115 47 46 114 101 108 115 173 146 207 74 3 49 16 135 239 125 138 144 123 119 182 21 68 100 179 189 136 208 155 72 125 128 152 204 254 97 55 153 48 25 117 125 123 131 8 90 169 165 7 143 73 126 243 205 55 67 154 221 18 102 245 138 156 71 138 70 111 170 90 43 140 142 252 24 123 163 159 14 247 235 27 189 107 87 205 35 206 86 74 36 15 99 202 170 212 196 108 244 32 146 110 1 178 27 48 216 92 81 194 88 94 58 226 96 165 28 185 135 100 221 100 123 132 109 93 95 3 255 100 232 246 136 169 246 222 104 222 251 141 86 135 247 132 151 176 169 235 70 135 119 228 94 2 70 57 209 226 87 162 144 45 247 40 70 47 51 188 17 79 207 68 83 85 160 26 78 187 108 47 119 249 123 78 8 40 214 91 177 224 136 113 157 184 84 179 140 152 191 117 60 185 135 114 157 63 19 231 132 174 254 115 57 184 8 70 143 254 188 146 77 233 203 104 213 192 209 39 104 63 0 80 75 7 8 102 170 130 183 224 0 0 0 59 2 0 0 80 75 3 4 20 0 8 8 8 0 185 168 11 71 0 0 0 0 0 0 0 0 0 0 0 0 16 0 0 0 100 111 99 80 114 111 112 115 47 97 112 112 46 120 109 108 157 208 203 106 195 48 16 5 208 125 191 66 136 108 45 41 206 131 16 100 135 150 210 85 160 93 184 221 6 69 26 39 42 214 3 105 28 156 191 175 218 66 147 117 151 151 11 135 59 35 119 147 27 200 5 82 182 193 55 116 206 4 37 224 117 48 214 159 26 250 222 189 84 27 74 50 42 111 212 16 60 52 244 10 153 238 218 7 249 150 66 132 132 22 50 41 130 207 13 61 35 198 45 231 89 159 193 169 204 74 237 75 211 135 228 20 150 152 78 60 244 189 213 240 28 244 232 192 35 175 133 88 115 152 16 188 1 83 197 63 144 254 138 219 11 254 23 53 65 127 239 203 31 221 53 22 175 149 93 64 53 116 214 65 59 175 87 146 223 162 124 140 113 176 90 97 57 191 221 219 99 130 215 31 143 47 217 130 173 88 61 219 91 63 78 135 105 179 38 119 237 161 140 253 4 141 124 185 16 78 204 158 70 59 152 170 150 252 30 147 252 246 162 246 11 80 75 7 8 102 48 75 49 225 0 0 0 103 1 0 0 80 75 3 4 20 0 8 8 8 0 185 168 11 71 0 0 0 0 0 0 0 0 0 0 0 0 17 0 0 0 100 111 99 80 114 111 112 115 47 99 111 114 101 46 120 109 108 141 146 95 79 194 48 20 197 223 253 20 75 223 183 174 3 12 105 182 145 160 193 23 73 76 196 104 124 107 186 203 104 92 187 165 45 12 190 189 93 101 21 149 7 223 122 239 57 253 221 211 63 249 226 40 155 232 0 218 136 86 21 136 36 41 138 64 241 182 18 170 46 208 203 102 21 207 81 100 44 83 21 107 90 5 5 58 129 65 139 242 38 231 29 229 173 134 39 221 118 160 173 0 19 57 144 50 148 119 5 218 89 219 81 140 13 223 129 100 38 113 14 229 196 109 171 37 179 174 212 53 238 24 255 96 53 224 44 77 111 177 4 203 42 102 25 30 128 113 23 136 232 140 172 120 64 118 123 221 120 64 197 49 52 32 65 89 131 73 66 240 183 215 130 150 230 234 6 175 92 56 165 176 167 14 174 90 71 49 184 143 70 4 99 223 247 73 63 241 86 151 159 224 183 245 227 179 63 106 44 212 112 85 28 80 153 159 131 80 174 129 89 168 34 7 160 95 227 70 229 117 114 119 191 89 161 50 75 201 44 78 231 49 33 155 140 208 116 66 167 211 247 28 255 218 63 0 191 214 173 46 247 6 116 52 88 66 103 80 27 166 234 189 187 212 18 84 252 176 244 114 104 13 207 213 48 99 215 238 97 183 2 170 229 105 132 252 21 66 116 121 238 253 63 251 140 206 210 139 236 35 192 143 215 112 16 195 39 43 51 63 52 148 190 250 249 149 202 79 80 75 7 8 106 101 61 3 73 1 0 0 150 2 0 0 80 75 3 4 20 0 8 8 8 0 185 168 11 71 0 0 0 0 0 0 0 0 0 0 0 0 26 0 0 0 120 108 47 95 114 101 108 115 47 119 111 114 107 98 111 111 107 46 120 109 108 46 114 101 108 115 173 145 77 107 195 48 12 134 239 253 21 70 247 197 73 7 99 140 56 189 140 65 175 253 248 1 198 81 226 208 196 54 146 214 181 255 126 46 27 91 10 101 236 208 147 208 215 243 190 72 245 234 52 141 234 136 196 67 12 6 170 162 4 133 193 197 118 8 189 129 253 238 237 225 25 86 205 162 222 224 104 37 143 176 31 18 171 188 19 216 128 23 73 47 90 179 243 56 89 46 98 194 144 59 93 164 201 74 78 169 215 201 186 131 237 81 47 203 242 73 211 156 1 205 21 83 173 91 3 180 110 43 80 187 115 194 255 176 99 215 13 14 95 163 123 159 48 200 13 9 205 114 30 145 51 209 82 143 98 224 43 47 50 7 244 109 249 229 61 229 63 34 29 216 35 202 175 131 159 82 54 119 9 213 95 102 30 239 122 11 111 9 219 173 80 126 236 252 36 243 242 183 153 69 173 175 222 221 124 2 80 75 7 8 79 240 249 122 210 0 0 0 37 2 0 0 80 75 3 4 20 0 8 8 8 0 185 168 11 71 0 0 0 0 0 0 0 0 0 0 0 0 20 0 0 0 120 108 47 115 104 97 114 101 100 83 116 114 105 110 103 115 46 120 109 108 53 205 65 10 194 48 16 133 225 189 167 8 179 183 83 93 136 72 146 46 4 79 160 7 8 237 216 6 154 73 155 153 138 222 222 184 112 249 241 120 252 182 123 167 217 188 168 72 204 236 224 208 180 96 136 251 60 68 30 29 60 238 183 253 25 140 104 224 33 204 153 201 193 135 4 58 191 179 34 106 234 149 197 193 164 186 92 16 165 159 40 5 105 242 66 92 151 103 46 41 104 101 25 81 150 66 97 144 137 72 211 140 199 182 61 97 10 145 193 244 121 99 173 89 48 27 199 117 163 235 223 222 74 244 86 189 177 168 222 226 15 88 147 254 11 80 75 7 8 125 2 174 20 145 0 0 0 176 0 0 0 80 75 3 4 20 0 8 8 8 0 185 168 11 71 0 0 0 0 0 0 0 0 0 0 0 0 24 0 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 49 46 120 109 108 189 86 77 115 219 54 16 189 247 87 112 120 200 169 21 73 201 146 63 66 49 227 210 85 147 25 199 210 88 78 51 211 27 68 44 69 140 65 128 1 64 41 246 175 239 2 252 172 228 67 167 7 251 32 19 139 197 219 183 111 193 93 198 159 126 150 220 59 128 210 76 138 165 31 77 66 223 3 145 73 202 196 126 233 127 123 90 253 118 229 123 218 16 65 9 151 2 150 254 11 104 255 83 242 75 124 148 234 89 23 0 198 67 0 161 151 126 97 76 117 19 4 58 43 160 36 122 34 43 16 184 147 75 85 18 131 75 181 15 116 165 128 80 119 168 228 193 52 12 23 65 73 152 240 27 132 27 245 95 48 100 158 179 12 238 100 86 151 32 76 3 162 128 19 131 244 117 193 42 237 39 177 139 176 81 94 206 184 1 245 85 82 164 157 19 174 1 247 42 178 135 45 152 111 149 219 55 79 114 131 134 110 59 72 226 160 61 156 196 148 97 4 171 138 167 32 95 250 183 209 77 122 109 61 156 195 95 12 142 122 244 236 29 153 160 242 184 81 210 64 102 156 148 13 164 167 11 121 92 97 2 53 39 250 95 198 63 21 163 247 76 0 90 141 170 91 227 163 60 166 146 127 70 153 176 34 227 141 191 65 201 222 160 216 190 64 234 247 144 155 30 210 144 221 22 56 6 7 58 62 183 174 13 199 32 219 151 114 39 121 15 64 33 39 53 55 150 2 134 147 170 179 31 48 149 165 47 172 222 28 33 101 101 67 164 192 185 205 223 247 50 235 251 5 241 23 23 190 247 42 101 185 205 8 71 245 162 48 28 173 31 220 241 83 171 213 249 158 188 200 218 233 213 238 218 75 180 147 242 217 154 44 110 104 171 231 178 176 186 87 196 94 184 150 133 239 17 180 30 160 97 147 70 225 216 208 156 245 244 15 87 42 187 217 151 210 66 143 159 187 170 173 220 165 194 91 208 106 129 202 127 6 171 43 82 155 78 174 252 238 76 231 151 196 152 189 118 191 86 7 78 42 109 149 110 213 47 24 165 48 20 189 36 63 109 134 211 57 62 50 251 90 217 119 232 197 74 101 147 102 212 20 104 139 38 243 105 120 17 94 69 139 217 116 49 159 57 202 77 12 23 248 142 24 146 196 74 30 61 229 0 178 90 27 89 54 116 134 184 29 221 83 6 141 119 151 81 107 148 205 101 184 135 3 112 71 229 44 17 204 207 134 179 197 214 206 3 15 11 180 30 146 40 138 131 131 101 216 186 252 126 238 50 61 113 73 207 93 102 131 75 128 169 245 249 205 222 55 191 116 118 206 108 246 54 179 139 119 102 118 49 98 166 29 179 240 109 98 139 119 38 182 56 151 108 241 54 179 235 119 102 118 125 206 236 250 132 89 48 122 165 42 197 132 89 87 110 98 120 5 182 90 28 117 67 107 222 15 109 249 212 130 115 163 107 148 133 84 236 85 10 67 120 138 99 8 212 168 21 224 44 53 44 59 223 8 154 225 243 149 168 61 195 192 220 53 239 112 114 121 117 57 111 59 250 176 196 158 231 102 241 124 122 217 255 161 108 59 105 80 167 183 118 10 55 49 6 128 92 226 32 26 214 65 63 248 234 10 219 106 5 106 203 94 193 85 74 143 90 120 206 148 54 182 81 63 212 229 14 154 182 227 134 228 247 182 101 181 203 190 81 250 158 133 93 43 23 27 231 159 120 42 64 172 81 1 44 159 98 40 0 105 102 97 37 149 81 132 97 19 175 53 108 172 254 160 238 154 190 59 232 188 227 36 123 190 21 244 123 193 76 63 146 61 170 200 104 202 101 216 236 83 89 218 217 175 237 160 18 224 32 87 167 196 79 171 116 87 49 108 50 54 199 174 60 131 37 147 21 179 229 142 172 76 141 144 43 39 159 71 89 158 99 9 133 113 248 3 165 206 188 166 244 143 195 112 143 147 88 82 218 204 238 228 3 41 171 143 169 251 253 240 163 150 230 227 19 126 78 104 239 1 63 21 30 101 73 196 175 143 176 199 79 2 213 108 58 191 104 234 254 221 198 193 0 99 17 27 50 255 15 209 106 226 185 231 141 131 109 177 226 96 156 39 46 251 175 185 228 31 80 75 7 8 84 159 201 242 182 3 0 0 17 10 0 0 80 75 3 4 20 0 8 8 8 0 185 168 11 71 0 0 0 0 0 0 0 0 0 0 0 0 13 0 0 0 120 108 47 115 116 121 108 101 115 46 120 109 108 237 152 93 79 219 48 20 134 239 247 43 44 223 143 164 165 20 152 210 32 96 116 154 52 33 4 69 154 52 237 194 36 78 98 225 143 200 118 161 225 215 115 28 167 105 82 132 182 118 23 43 82 175 108 191 57 231 241 155 99 91 117 26 157 45 4 71 79 84 27 166 228 4 15 14 66 140 168 76 84 202 100 62 193 247 179 233 231 19 140 140 37 50 37 92 73 58 193 21 53 248 44 254 20 25 91 113 122 87 80 106 17 16 164 153 224 194 218 242 75 16 152 164 160 130 152 3 85 82 9 79 50 165 5 177 48 212 121 96 74 77 73 106 92 146 224 193 48 12 199 129 32 76 226 56 146 115 49 21 214 160 68 205 165 5 27 173 132 124 243 61 5 113 60 194 200 227 46 85 10 86 190 93 93 95 221 158 255 192 65 28 5 13 32 142 50 37 87 156 17 246 66 28 153 23 244 68 56 64 66 23 46 137 160 126 124 174 25 225 78 202 136 96 188 242 226 176 70 250 196 45 210 195 157 73 175 27 87 20 198 121 91 148 33 246 66 28 149 196 90 170 229 20 6 168 233 207 170 18 42 43 97 169 61 166 142 251 67 116 174 73 53 24 30 117 18 234 6 230 125 80 58 133 173 213 93 86 47 161 148 145 92 73 194 239 203 9 206 8 55 20 183 210 87 245 44 151 98 28 113 154 89 0 107 150 23 174 181 170 12 28 196 90 37 160 179 204 113 83 123 114 219 129 233 19 202 249 157 219 167 63 179 213 219 135 0 93 100 111 247 149 172 7 176 253 157 247 166 235 73 205 128 148 37 175 166 202 65 172 158 211 70 184 168 67 122 210 57 103 185 20 116 45 240 70 43 75 19 91 31 179 90 142 35 178 12 68 133 210 236 5 208 110 1 115 42 169 134 117 117 167 210 178 196 73 254 125 49 178 116 97 111 149 37 158 2 158 158 53 41 103 32 182 69 100 50 173 39 134 103 166 208 76 62 206 212 148 181 143 161 76 101 107 3 113 149 60 210 116 105 178 96 41 164 118 34 131 69 182 86 169 112 85 167 193 182 117 106 124 174 23 170 43 119 43 181 220 6 31 199 204 112 111 230 29 51 91 159 173 189 153 189 153 189 153 189 153 189 153 109 204 140 14 119 233 151 114 52 216 41 55 163 157 114 51 220 37 55 167 255 217 76 208 189 190 251 203 124 231 30 63 216 246 26 191 200 222 58 239 250 249 71 235 31 224 78 31 52 165 236 124 32 181 101 29 227 142 138 220 167 230 4 95 187 111 110 222 169 220 195 156 113 203 100 51 74 230 6 94 228 194 107 157 185 214 49 151 74 8 178 164 12 142 122 152 195 13 49 232 87 248 187 69 141 123 168 241 6 168 185 214 84 38 85 75 58 238 145 70 155 147 122 190 78 122 180 227 191 167 221 80 157 192 138 183 160 211 30 232 232 125 208 234 200 192 226 6 171 191 104 226 87 80 75 7 8 164 181 22 187 150 2 0 0 231 17 0 0 80 75 3 4 20 0 8 8 8 0 185 168 11 71 0 0 0 0 0 0 0 0 0 0 0 0 15 0 0 0 120 108 47 119 111 114 107 98 111 111 107 46 120 109 108 141 82 77 111 219 48 12 189 239 87 8 186 55 182 211 34 72 131 40 197 208 162 104 15 251 192 218 181 103 90 162 99 45 178 100 72 76 220 238 215 143 86 226 174 3 118 232 73 34 31 245 248 30 169 245 213 75 231 196 1 99 178 193 43 89 205 74 41 208 235 96 172 223 42 249 243 241 246 108 41 69 34 240 6 92 240 168 228 43 38 121 181 249 180 30 66 220 213 33 236 4 191 247 73 201 150 168 95 21 69 210 45 118 144 102 161 71 207 72 19 98 7 196 97 220 22 169 143 8 38 181 136 212 185 98 94 150 139 162 3 235 229 145 97 21 63 194 17 154 198 106 188 9 122 223 161 167 35 73 68 7 196 234 83 107 251 36 55 235 198 58 124 58 26 18 208 247 95 161 99 217 215 224 180 44 54 111 178 191 71 81 131 222 237 251 91 174 86 178 1 151 144 141 182 97 248 86 255 66 77 236 8 156 147 194 0 97 117 89 94 76 37 255 80 4 226 74 110 195 201 49 241 100 113 72 127 241 49 204 140 119 33 218 223 193 19 184 7 29 131 115 74 82 220 159 186 177 80 178 250 127 200 195 56 168 71 168 211 148 124 121 182 222 132 65 73 94 209 235 187 251 144 175 207 214 80 203 11 92 156 47 47 166 220 29 218 109 75 74 46 171 203 185 20 4 245 143 113 80 74 206 207 23 82 52 54 38 202 77 50 11 176 147 3 114 191 49 98 67 197 59 71 121 103 211 41 124 30 104 126 89 141 82 249 188 55 220 57 255 19 98 232 96 147 173 29 43 142 43 203 64 188 55 243 204 56 209 176 93 205 243 183 132 145 235 175 195 222 179 132 170 100 17 17 155 47 193 48 197 103 102 59 225 111 203 57 197 55 232 8 88 228 172 44 171 76 59 205 123 243 7 80 75 7 8 243 41 8 163 155 1 0 0 204 2 0 0 80 75 3 4 20 0 8 8 8 0 185 168 11 71 0 0 0 0 0 0 0 0 0 0 0 0 19 0 0 0 91 67 111 110 116 101 110 116 95 84 121 112 101 115 93 46 120 109 108 189 148 193 75 195 48 20 198 239 251 43 74 174 210 166 243 32 34 237 118 16 60 234 192 121 150 152 188 173 161 109 18 222 139 179 251 239 125 169 155 160 8 219 216 240 210 80 242 190 239 247 222 151 144 106 62 244 93 182 1 36 235 93 45 166 69 41 50 112 218 27 235 214 181 120 89 62 228 183 98 62 155 84 203 109 0 202 184 214 81 45 154 24 195 157 148 164 27 232 21 21 62 128 227 157 149 199 94 69 254 197 181 12 74 183 106 13 242 186 44 111 164 246 46 130 139 121 76 30 98 86 61 49 14 173 129 108 161 48 62 170 30 106 33 95 17 58 146 69 250 138 236 254 75 144 152 181 80 33 116 86 171 200 253 201 141 51 191 104 249 142 148 148 99 13 53 54 208 21 23 8 249 55 201 120 189 64 31 72 178 113 145 234 78 194 249 213 202 106 96 143 247 158 37 5 12 172 52 96 242 192 150 128 209 194 113 108 237 17 78 135 239 103 77 234 35 137 67 183 139 246 195 99 251 230 125 155 168 255 17 51 131 169 81 8 230 57 34 223 37 58 59 106 10 8 202 80 3 16 121 130 31 222 7 250 72 163 143 58 146 227 50 189 112 47 223 254 135 242 136 219 14 46 30 196 104 122 68 2 251 195 191 232 33 240 90 244 202 186 29 127 82 201 241 161 152 125 2 80 75 7 8 98 20 195 28 52 1 0 0 87 4 0 0 80 75 1 2 20 0 20 0 8 8 8 0 185 168 11 71 102 170 130 183 224 0 0 0 59 2 0 0 11 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 95 114 101 108 115 47 46 114 101 108 115 80 75 1 2 20 0 20 0 8 8 8 0 185 168 11 71 102 48 75 49 225 0 0 0 103 1 0 0 16 0 0 0 0 0 0 0 0 0 0 0 0 0 25 1 0 0 100 111 99 80 114 111 112 115 47 97 112 112 46 120 109 108 80 75 1 2 20 0 20 0 8 8 8 0 185 168 11 71 106 101 61 3 73 1 0 0 150 2 0 0 17 0 0 0 0 0 0 0 0 0 0 0 0 0 56 2 0 0 100 111 99 80 114 111 112 115 47 99 111 114 101 46 120 109 108 80 75 1 2 20 0 20 0 8 8 8 0 185 168 11 71 79 240 249 122 210 0 0 0 37 2 0 0 26 0 0 0 0 0 0 0 0 0 0 0 0 0 192 3 0 0 120 108 47 95 114 101 108 115 47 119 111 114 107 98 111 111 107 46 120 109 108 46 114 101 108 115 80 75 1 2 20 0 20 0 8 8 8 0 185 168 11 71 125 2 174 20 145 0 0 0 176 0 0 0 20 0 0 0 0 0 0 0 0 0 0 0 0 0 218 4 0 0 120 108 47 115 104 97 114 101 100 83 116 114 105 110 103 115 46 120 109 108 80 75 1 2 20 0 20 0 8 8 8 0 185 168 11 71 84 159 201 242 182 3 0 0 17 10 0 0 24 0 0 0 0 0 0 0 0 0 0 0 0 0 173 5 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 49 46 120 109 108 80 75 1 2 20 0 20 0 8 8 8 0 185 168 11 71 164 181 22 187 150 2 0 0 231 17 0 0 13 0 0 0 0 0 0 0 0 0 0 0 0 0 169 9 0 0 120 108 47 115 116 121 108 101 115 46 120 109 108 80 75 1 2 20 0 20 0 8 8 8 0 185 168 11 71 243 41 8 163 155 1 0 0 204 2 0 0 15 0 0 0 0 0 0 0 0 0 0 0 0 0 122 12 0 0 120 108 47 119 111 114 107 98 111 111 107 46 120 109 108 80 75 1 2 20 0 20 0 8 8 8 0 185 168 11 71 98 20 195 28 52 1 0 0 87 4 0 0 19 0 0 0 0 0 0 0 0 0 0 0 0 0 82 14 0 0 91 67 111 110 116 101 110 116 95 84 121 112 101 115 93 46 120 109 108 80 75 5 6 0 0 0 0 9 0 9 0 63 2 0 0 199 15 0 0 0 0]! !

!TabularResources class methodsFor: 'examples' stamp: 'HannesHirzel 8/12/2015 04:53'!
testExcelFile2withThreeSheets

"  (FileLocator home / self fileNameOfExample2  ) asFileReference writeStreamDo: [ :stream | 
    stream 
        binary; 
        nextPutAll: self testExcelFile2withThreeSheets ]
"
"see http://stackoverflow.com/questions/31934877/pharo-filesystem-how-do-i-write-a-binary-file"


 ^ #[80 75 3 4 20 0 6 0 8 0 0 0 33 0 199 122 151 144 120 1 0 0 32 6 0 0 19 0 8 2 91 67 111 110 116 101 110 116 95 84 121 112 101 115 93 46 120 109 108 32 162 4 2 40 160 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 204 148 223 74 195 48 20 198 239 5 223 161 228 86 218 108 19 68 100 221 46 166 94 234 192 249 0 49 57 93 203 210 36 228 100 115 123 123 79 179 63 200 168 27 195 130 222 52 180 57 231 251 126 73 154 111 56 94 215 58 89 129 199 202 154 156 245 179 30 75 192 72 171 42 51 207 217 251 236 57 189 103 9 6 97 148 208 214 64 206 54 128 108 60 186 190 26 206 54 14 48 161 110 131 57 43 67 112 15 156 163 44 161 22 152 89 7 134 102 10 235 107 17 232 213 207 185 19 114 33 230 192 7 189 222 29 151 214 4 48 33 13 141 6 27 13 31 161 16 75 29 146 167 53 125 222 146 120 208 200 146 201 182 176 241 202 153 112 78 87 82 4 34 229 43 163 142 92 210 157 67 70 157 177 6 203 202 225 13 97 48 222 234 208 204 252 108 176 235 123 165 173 241 149 130 100 42 124 120 17 53 97 240 181 230 159 214 47 62 172 93 100 167 69 90 40 109 81 84 18 148 149 203 154 118 32 67 231 65 40 44 1 66 173 179 56 102 181 168 204 158 251 132 127 44 70 30 135 126 199 32 205 250 162 240 133 28 131 127 194 113 251 71 28 129 254 127 224 241 249 251 35 137 50 103 14 0 195 70 3 118 188 218 173 232 57 231 82 120 80 111 193 83 82 116 14 240 93 251 12 135 20 90 78 74 186 50 29 111 194 65 247 148 63 221 227 169 183 14 41 209 60 92 14 176 143 172 166 59 117 36 4 62 84 112 8 173 182 203 127 112 164 52 188 220 240 40 125 160 201 91 5 170 197 155 199 124 31 125 1 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 181 85 48 35 245 0 0 0 76 2 0 0 11 0 8 2 95 114 101 108 115 47 46 114 101 108 115 32 162 4 2 40 160 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 140 146 207 78 195 48 12 198 239 72 188 67 228 251 234 110 72 8 161 165 187 76 72 187 33 84 30 192 36 238 31 181 141 163 36 64 247 246 132 3 130 74 99 219 209 246 231 207 63 91 222 238 230 105 84 31 28 98 47 78 195 186 40 65 177 51 98 123 215 106 120 173 159 86 15 160 98 34 103 105 20 199 26 142 28 97 87 221 222 108 95 120 164 148 155 98 215 251 168 178 139 139 26 186 148 252 35 98 52 29 79 20 11 241 236 114 165 145 48 81 202 97 104 209 147 25 168 101 220 148 229 61 134 191 30 80 45 60 213 193 106 8 7 123 7 170 62 250 60 249 178 183 52 77 111 120 47 230 125 98 151 78 140 64 158 19 59 203 118 229 67 102 11 169 207 219 168 154 66 203 73 131 21 243 156 211 17 201 251 34 99 3 158 38 218 92 79 244 255 182 56 113 34 75 137 208 72 224 243 60 223 138 115 64 235 235 129 46 159 104 169 248 189 206 60 226 167 132 225 77 100 248 97 193 197 15 84 95 0 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 244 245 7 59 27 1 0 0 89 4 0 0 26 0 8 1 120 108 47 95 114 101 108 115 47 119 111 114 107 98 111 111 107 46 120 109 108 46 114 101 108 115 32 162 4 1 40 160 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 188 148 207 74 196 48 16 198 239 130 239 16 230 110 211 118 117 21 217 116 15 138 176 87 93 31 32 164 211 166 108 155 148 76 252 211 183 55 20 73 45 44 245 82 246 18 152 25 242 125 191 76 50 217 237 191 187 150 125 162 163 198 26 1 89 146 2 67 163 108 217 152 90 192 251 241 229 230 1 24 121 105 74 217 90 131 2 6 36 216 23 215 87 187 87 108 165 15 155 72 55 61 177 160 98 72 128 246 190 127 228 156 148 198 78 82 98 123 52 161 82 89 215 73 31 66 87 243 94 170 147 172 145 231 105 186 229 238 175 6 20 51 77 118 40 5 184 67 185 1 118 28 250 224 252 191 182 173 170 70 225 179 85 31 29 26 127 198 130 127 89 119 34 141 232 131 168 116 53 122 1 49 69 124 172 108 146 64 12 252 60 204 253 154 48 74 182 234 73 203 198 76 48 49 181 4 145 175 9 17 143 63 65 196 212 111 71 242 37 152 236 194 48 217 18 204 118 77 24 210 210 97 249 230 93 24 5 154 186 51 75 47 193 220 173 10 227 135 54 76 94 124 181 52 198 75 246 183 107 218 251 48 207 56 185 143 33 31 215 120 31 124 246 33 20 63 0 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 95 77 123 205 95 1 0 0 113 2 0 0 15 0 0 0 120 108 47 119 111 114 107 98 111 111 107 46 120 109 108 140 82 203 78 195 48 16 188 35 241 15 150 239 212 121 180 161 84 77 42 33 168 232 5 113 40 237 217 196 155 198 170 99 71 182 67 218 191 103 147 42 161 8 14 156 188 235 29 207 206 76 178 92 157 42 69 62 193 58 105 116 74 195 73 64 9 232 220 8 169 15 41 125 223 174 239 230 148 56 207 181 224 202 104 72 233 25 28 93 101 183 55 203 214 216 227 135 49 71 130 4 218 165 180 244 190 94 48 230 242 18 42 238 38 166 6 141 147 194 216 138 123 108 237 129 185 218 2 23 174 4 240 149 98 81 16 36 172 226 82 211 11 195 194 254 135 195 20 133 204 225 201 228 77 5 218 95 72 44 40 238 81 190 43 101 237 104 182 44 164 130 221 197 17 225 117 253 202 43 212 125 82 148 40 238 252 179 144 30 68 74 103 216 154 22 126 92 216 166 126 108 164 194 233 67 28 196 148 101 163 201 55 75 4 20 188 81 126 139 246 6 118 204 43 154 70 81 210 33 187 40 118 18 90 247 253 168 107 201 105 47 181 48 109 7 197 104 207 67 119 143 251 219 126 178 151 194 151 41 141 230 179 112 188 123 1 121 40 61 190 137 231 73 208 177 179 43 250 62 64 92 211 159 68 247 238 214 128 186 67 252 82 93 184 27 52 128 181 93 72 44 236 70 132 29 195 47 116 116 133 198 122 68 71 127 162 227 43 52 214 35 186 79 137 13 146 114 174 114 140 170 59 122 17 211 89 18 245 219 217 240 183 100 95 0 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 1 14 86 208 152 6 0 0 168 27 0 0 19 0 0 0 120 108 47 116 104 101 109 101 47 116 104 101 109 101 49 46 120 109 108 236 89 79 111 27 69 20 191 35 241 29 70 123 111 109 39 182 27 71 117 170 216 177 27 104 211 70 177 91 212 227 120 61 222 157 122 118 103 53 51 78 234 27 106 143 72 72 136 130 184 32 113 3 9 1 149 90 137 75 57 241 81 2 69 80 164 126 5 222 204 236 174 119 226 53 73 74 4 2 234 67 178 59 243 155 247 255 189 121 51 123 245 218 131 136 161 67 34 36 229 113 219 171 93 174 122 136 196 62 31 211 56 104 123 119 134 253 75 27 30 146 10 199 99 204 120 76 218 222 156 72 239 218 214 219 111 93 197 155 42 36 17 65 176 62 150 155 184 237 133 74 37 155 149 138 244 97 24 203 203 60 33 49 204 77 184 136 176 130 87 17 84 198 2 31 1 221 136 85 214 170 213 102 37 194 52 246 80 140 35 32 59 12 127 252 10 136 221 158 76 168 79 188 173 140 122 143 1 139 88 73 61 224 51 49 208 180 73 186 164 128 29 79 107 26 33 231 178 203 4 58 196 172 237 1 163 49 63 26 146 7 202 67 12 75 5 19 109 175 106 126 94 101 235 106 5 111 166 139 152 90 177 182 176 174 111 126 233 186 116 193 120 186 102 120 138 96 148 51 173 245 235 173 43 59 57 125 3 96 106 25 215 235 245 186 189 90 78 207 0 176 239 131 166 86 150 34 205 122 127 163 214 201 104 22 64 246 113 153 118 183 218 168 214 93 124 129 254 250 146 204 173 78 167 211 104 165 178 88 162 6 100 31 235 75 248 141 106 179 190 189 230 224 13 200 226 27 75 248 122 103 187 219 109 58 120 3 178 248 230 18 190 127 165 213 172 187 120 3 10 25 141 167 75 104 237 208 126 63 165 158 67 38 156 237 150 194 55 0 190 81 77 225 11 20 68 67 30 93 154 197 132 199 106 85 172 69 248 62 23 125 0 104 32 195 138 198 72 205 19 50 193 62 132 113 23 71 35 65 177 102 128 55 9 46 204 216 33 95 46 13 105 94 72 250 130 38 170 237 189 155 96 72 137 5 189 87 207 191 121 245 252 41 122 245 252 201 241 195 103 199 15 191 63 126 244 232 248 225 119 150 150 179 112 23 199 65 113 225 203 47 63 250 253 243 247 209 111 79 191 120 249 248 147 114 188 44 226 127 254 246 131 159 126 248 184 28 8 25 180 144 232 197 167 79 126 121 246 228 197 103 31 254 250 245 227 18 248 182 192 163 34 124 72 35 34 209 45 114 132 14 120 4 186 25 195 184 146 147 145 56 223 138 97 136 169 179 2 135 64 187 132 116 79 133 14 240 214 28 179 50 92 135 184 198 187 43 160 120 148 1 175 207 238 59 178 14 66 49 83 180 132 243 141 48 114 128 123 156 179 14 23 165 6 184 161 121 21 44 60 156 197 65 57 115 49 43 226 14 48 62 44 227 221 197 177 227 218 222 44 129 170 153 5 165 99 251 110 72 28 49 247 25 142 21 14 72 76 20 210 115 124 74 72 137 118 247 40 117 236 186 71 125 193 37 159 40 116 143 162 14 166 165 38 25 210 145 19 72 139 69 187 52 2 191 204 203 116 6 87 59 182 217 187 139 58 156 149 105 189 67 14 93 36 36 4 102 37 194 15 9 115 204 120 29 207 20 142 202 72 14 113 196 138 6 191 137 85 88 38 228 96 46 252 34 174 39 21 120 58 32 140 163 222 152 72 89 182 230 182 0 125 11 78 191 129 161 94 149 186 125 143 205 35 23 41 20 157 150 209 188 137 57 47 34 119 248 180 27 226 40 41 195 14 104 28 22 177 239 200 41 132 40 70 251 92 149 193 247 184 155 33 250 29 252 128 227 149 238 190 75 137 227 238 211 11 193 29 26 56 34 45 2 68 207 204 68 137 47 175 19 238 196 239 96 206 38 152 152 42 3 37 221 169 212 17 141 255 172 108 51 10 117 219 114 120 83 182 219 222 54 108 98 101 201 179 123 162 88 175 194 253 11 75 244 14 158 197 251 4 178 98 121 139 122 83 161 223 84 104 239 63 95 161 87 229 242 197 215 229 69 41 134 42 173 27 18 219 107 155 206 59 90 217 120 79 40 99 3 53 103 228 166 52 189 183 132 13 104 220 135 65 189 206 156 58 73 126 16 75 66 120 212 153 12 12 28 92 32 176 89 131 4 87 239 81 21 14 66 156 64 223 94 243 52 145 64 166 164 3 137 18 46 225 188 104 134 75 105 107 60 244 254 202 158 54 27 250 28 98 43 135 196 106 143 143 237 240 186 30 206 142 27 57 25 35 85 96 206 180 25 163 117 77 224 172 204 214 175 164 68 65 183 215 97 86 211 66 157 153 91 205 136 102 138 162 195 45 87 89 155 216 156 203 193 228 185 106 48 152 91 19 58 27 4 253 16 88 185 9 231 126 205 26 206 59 152 145 177 182 187 245 81 230 22 227 133 139 116 145 12 241 152 164 62 210 122 47 251 168 102 156 148 197 202 146 34 90 15 27 12 250 236 120 138 213 10 220 90 154 236 95 224 118 22 39 21 217 213 87 176 203 188 247 87 188 148 69 240 194 75 64 237 100 58 178 184 152 156 44 70 71 109 175 213 88 107 120 200 199 73 219 155 192 81 25 30 163 4 188 46 117 51 137 89 0 23 78 190 18 54 236 79 77 102 147 229 11 111 182 50 197 220 36 168 193 237 135 181 251 146 194 78 29 72 132 84 59 88 134 54 52 204 84 26 2 44 214 156 172 252 107 13 48 235 69 41 80 82 141 206 38 197 250 6 4 195 63 38 5 216 209 117 45 153 76 136 175 138 206 46 140 104 219 217 215 180 148 242 153 34 98 16 142 143 208 136 205 196 1 6 247 235 80 5 125 198 84 194 141 135 169 8 250 5 174 231 180 181 205 148 91 156 211 164 43 94 138 25 156 29 199 44 9 113 90 110 117 138 102 153 108 225 166 32 229 50 152 183 130 120 160 91 169 236 70 185 243 171 98 82 254 130 84 41 134 241 255 76 21 189 159 192 21 196 250 88 123 192 135 235 97 129 145 206 148 182 199 133 10 57 84 161 36 164 126 95 64 227 96 106 7 68 11 92 241 194 52 4 21 92 82 155 255 130 28 234 255 54 231 44 13 147 214 112 146 84 7 52 64 130 194 126 164 66 65 200 62 148 37 19 125 167 16 171 165 123 151 37 201 82 66 38 162 10 226 202 196 138 61 34 135 132 13 117 13 108 234 189 221 67 33 132 186 169 38 105 25 48 184 147 241 231 190 167 25 52 10 116 147 83 204 55 167 146 229 123 175 205 129 191 187 243 177 201 12 74 185 117 216 52 52 153 253 115 17 243 246 96 177 171 218 245 102 121 182 247 22 21 209 19 139 54 171 158 101 5 48 43 108 5 173 52 237 95 83 132 115 110 181 182 98 45 105 188 214 200 132 3 47 46 107 12 131 121 67 148 192 69 18 210 127 96 255 163 194 103 246 131 135 222 80 135 252 0 106 43 130 239 23 154 24 132 13 68 245 37 219 120 32 93 32 237 224 8 26 39 59 104 131 73 147 178 166 77 91 39 109 181 108 179 190 224 78 55 231 123 194 216 90 178 179 248 251 156 198 206 155 51 151 157 147 139 23 105 236 212 194 142 173 237 216 74 83 131 103 79 166 40 12 77 178 131 140 113 140 249 84 86 252 152 197 71 247 193 209 59 240 217 96 198 148 52 193 4 159 170 4 134 30 122 96 242 0 146 223 114 52 75 183 254 0 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 159 202 189 227 109 1 0 0 134 2 0 0 24 0 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 50 46 120 109 108 140 146 77 107 195 48 12 134 239 131 253 7 227 251 226 180 251 108 105 90 198 202 88 15 131 49 246 113 118 28 37 49 181 173 96 171 107 251 239 167 164 116 12 122 233 77 178 228 199 122 95 121 182 216 121 39 126 32 38 139 161 144 163 44 151 2 130 193 202 134 166 144 159 31 207 87 15 82 36 210 161 210 14 3 20 114 15 73 46 230 151 23 179 45 198 117 106 1 72 48 33 164 66 182 68 221 84 169 100 90 240 58 101 216 65 224 74 141 209 107 226 52 54 42 117 17 116 53 92 242 78 141 243 252 78 121 109 131 60 16 166 241 28 6 214 181 53 176 68 179 241 16 232 0 137 224 52 241 252 169 181 93 58 210 188 57 7 231 117 92 111 186 43 131 190 99 68 105 157 165 253 0 149 194 155 233 170 9 24 117 233 88 247 110 116 163 205 145 61 36 39 120 111 77 196 132 53 101 140 83 135 65 79 53 79 212 68 49 105 62 171 44 43 232 109 23 17 234 66 62 142 164 154 207 6 115 190 44 108 211 191 88 244 94 151 136 235 190 176 170 10 153 247 173 234 164 247 121 240 250 45 138 82 39 120 66 247 109 43 106 121 169 188 211 10 106 189 113 244 142 219 23 176 77 75 124 122 203 106 122 81 211 106 191 132 100 216 77 6 103 227 219 191 49 150 154 52 191 211 233 6 94 117 108 108 72 194 65 61 116 221 75 17 15 152 60 227 152 176 235 239 222 51 178 68 34 244 199 172 229 125 3 239 53 207 174 165 168 17 233 152 244 243 255 253 160 249 47 0 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 159 202 189 227 109 1 0 0 134 2 0 0 24 0 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 51 46 120 109 108 140 146 77 107 195 48 12 134 239 131 253 7 227 251 226 180 251 108 105 90 198 202 88 15 131 49 246 113 118 28 37 49 181 173 96 171 107 251 239 167 164 116 12 122 233 77 178 228 199 122 95 121 182 216 121 39 126 32 38 139 161 144 163 44 151 2 130 193 202 134 166 144 159 31 207 87 15 82 36 210 161 210 14 3 20 114 15 73 46 230 151 23 179 45 198 117 106 1 72 48 33 164 66 182 68 221 84 169 100 90 240 58 101 216 65 224 74 141 209 107 226 52 54 42 117 17 116 53 92 242 78 141 243 252 78 121 109 131 60 16 166 241 28 6 214 181 53 176 68 179 241 16 232 0 137 224 52 241 252 169 181 93 58 210 188 57 7 231 117 92 111 186 43 131 190 99 68 105 157 165 253 0 149 194 155 233 170 9 24 117 233 88 247 110 116 163 205 145 61 36 39 120 111 77 196 132 53 101 140 83 135 65 79 53 79 212 68 49 105 62 171 44 43 232 109 23 17 234 66 62 142 164 154 207 6 115 190 44 108 211 191 88 244 94 151 136 235 190 176 170 10 153 247 173 234 164 247 121 240 250 45 138 82 39 120 66 247 109 43 106 121 169 188 211 10 106 189 113 244 142 219 23 176 77 75 124 122 203 106 122 81 211 106 191 132 100 216 77 6 103 227 219 191 49 150 154 52 191 211 233 6 94 117 108 108 72 194 65 61 116 221 75 17 15 152 60 227 152 176 235 239 222 51 178 68 34 244 199 172 229 125 3 239 53 207 174 165 168 17 233 152 244 243 255 253 160 249 47 0 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 195 7 21 126 38 7 0 0 152 43 0 0 24 0 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 49 46 120 109 108 148 154 93 115 155 86 16 134 239 59 211 255 160 97 114 209 206 52 150 192 95 177 70 86 70 156 15 154 139 166 157 54 109 175 49 66 22 19 73 168 128 237 228 223 247 5 14 7 157 77 140 150 11 207 88 66 207 46 135 135 5 189 54 139 247 95 246 187 201 115 90 148 89 126 184 247 252 139 153 55 73 15 73 190 206 14 143 247 222 223 159 244 219 119 222 164 172 226 195 58 222 229 135 244 222 251 154 150 222 251 229 143 63 44 94 242 226 115 185 77 211 106 130 10 135 242 222 219 86 213 113 62 157 150 201 54 221 199 229 69 126 76 15 216 178 201 139 125 92 225 101 241 56 45 143 69 26 175 27 104 191 155 6 179 217 205 116 31 103 7 175 173 48 47 56 53 242 205 38 75 82 153 39 79 251 244 80 181 69 138 116 23 87 216 255 114 155 29 203 174 218 62 225 148 219 199 197 231 167 227 219 36 223 31 81 226 33 219 101 213 215 166 168 55 217 39 243 15 143 135 188 136 31 118 88 247 23 255 42 78 186 218 205 139 111 202 239 179 164 200 203 124 83 93 160 220 180 221 209 111 215 124 55 189 155 162 210 114 177 206 176 130 250 176 79 138 116 115 239 173 252 121 20 220 122 211 229 162 57 64 255 100 233 75 121 242 251 164 138 31 254 74 119 105 82 165 107 120 242 38 245 241 127 200 243 207 245 7 63 224 173 25 74 150 205 7 234 146 113 82 101 207 169 72 119 59 84 14 160 240 191 182 73 80 55 152 218 14 167 191 119 221 116 99 236 143 98 242 16 151 169 200 119 255 102 235 106 139 150 56 51 214 233 38 126 218 85 127 230 47 191 166 217 227 182 194 187 215 56 38 245 161 153 175 191 202 180 76 224 4 187 114 17 92 219 133 200 184 138 151 139 34 127 153 192 47 246 187 60 198 245 217 226 207 111 95 35 151 139 164 254 236 10 31 70 177 18 235 122 94 222 44 166 207 216 217 4 63 40 101 235 213 43 227 214 11 241 97 91 111 102 235 53 189 196 233 54 223 221 38 79 183 5 238 54 117 186 237 210 221 166 79 183 93 185 219 162 211 109 215 118 155 179 182 203 17 107 91 93 54 71 137 236 121 136 18 245 138 171 2 91 55 75 241 251 71 177 250 164 62 226 231 167 240 77 240 203 155 213 229 207 139 233 166 62 188 43 66 10 135 108 138 108 227 34 93 123 237 185 42 46 231 145 95 95 24 178 230 188 59 45 44 220 194 33 41 44 95 45 220 214 194 217 249 188 20 4 82 28 72 18 72 115 32 69 160 136 3 233 30 114 132 93 141 17 118 213 8 35 167 83 136 18 189 176 111 14 123 120 213 92 34 154 195 238 123 223 241 121 101 125 146 194 226 213 194 39 135 61 36 144 228 64 130 64 138 3 73 2 105 14 164 8 20 113 32 221 67 142 43 92 182 216 23 142 213 117 227 138 140 119 136 18 223 119 85 31 82 191 190 254 97 174 8 36 6 161 89 11 133 4 146 28 72 16 72 113 32 73 32 205 129 20 129 34 14 164 123 200 241 112 51 198 195 77 227 129 92 74 67 148 56 239 129 64 98 16 234 60 16 72 114 32 65 32 197 129 36 129 52 7 82 4 138 56 144 238 33 199 3 110 198 252 121 184 109 60 244 183 173 230 22 26 162 196 121 15 4 18 131 80 231 129 64 146 3 9 2 41 14 36 9 164 57 144 34 80 196 129 116 15 57 30 234 155 42 247 11 205 234 93 227 161 255 106 212 122 64 137 243 30 8 36 6 161 206 3 129 36 7 18 4 82 28 72 18 72 115 32 69 160 136 3 233 30 114 60 220 141 241 112 215 120 184 181 95 227 90 15 40 113 222 3 129 196 32 212 121 32 144 228 64 130 64 138 3 73 2 105 14 164 8 20 113 32 221 67 142 135 58 117 240 7 2 159 174 239 186 239 136 137 186 200 121 21 132 18 195 84 231 130 80 146 69 9 66 41 22 37 9 165 89 148 34 84 196 162 116 79 185 62 198 37 56 124 75 133 143 59 234 195 36 187 54 151 52 106 76 186 56 253 234 68 40 225 15 82 157 15 66 73 22 37 8 165 88 148 36 148 102 81 138 80 17 139 210 61 229 250 64 144 28 49 31 65 227 195 39 233 55 244 77 28 29 22 66 49 49 140 117 70 40 38 89 24 198 207 61 107 20 11 195 252 185 152 102 97 24 64 23 139 88 24 38 208 98 174 22 228 200 17 90 76 122 239 115 101 123 7 241 7 211 104 23 49 124 130 137 97 204 106 33 152 100 97 152 66 187 226 102 39 21 11 195 24 186 152 102 97 152 67 23 139 88 24 6 209 98 174 22 68 198 17 90 218 140 238 247 17 210 104 25 12 158 86 11 193 132 63 136 89 45 4 147 44 12 163 104 87 108 180 112 186 97 20 93 76 179 186 97 20 93 44 98 97 24 69 139 185 90 144 32 71 104 105 227 184 223 39 74 163 101 48 135 90 45 4 19 245 95 48 95 255 114 96 181 16 76 178 48 140 162 93 177 209 194 233 134 81 116 49 205 234 134 81 116 177 136 133 97 20 45 230 106 65 160 28 161 165 77 231 126 31 48 141 150 193 88 106 181 16 76 248 131 152 213 66 48 201 194 48 138 118 197 70 11 167 27 70 209 197 52 171 155 162 88 196 194 48 138 182 155 171 5 249 114 132 150 54 172 251 125 222 52 90 6 83 170 213 66 48 225 15 98 86 11 193 36 11 195 40 218 21 27 45 156 110 24 69 23 211 172 110 138 98 17 11 195 40 218 110 174 22 196 205 17 90 218 236 238 247 241 211 104 25 12 173 86 11 193 68 253 199 120 198 69 140 96 146 133 97 20 237 138 141 22 78 55 140 162 139 105 86 55 69 177 230 31 13 103 215 134 81 180 221 92 45 72 159 35 180 180 81 222 239 211 168 209 50 152 97 173 22 130 9 159 131 133 180 155 100 97 24 69 187 98 163 133 211 13 163 232 98 154 213 77 81 44 98 97 24 69 219 205 209 18 140 202 245 248 116 157 35 253 62 148 182 90 234 42 175 159 26 86 11 193 4 11 11 105 55 201 194 48 138 118 197 173 22 22 134 81 116 49 205 194 20 197 34 22 134 81 180 221 92 45 163 226 125 208 198 123 191 207 166 70 203 96 82 183 90 8 38 80 238 188 205 144 118 147 44 12 163 104 87 108 180 112 186 97 20 93 76 179 186 41 138 69 44 12 163 104 187 185 90 70 165 252 160 77 249 65 159 77 141 22 86 202 167 152 64 57 134 22 138 73 22 134 81 180 43 54 90 56 221 48 138 46 166 89 221 20 197 34 22 134 81 180 221 92 45 163 82 126 208 166 252 160 207 166 70 11 43 229 83 76 160 28 71 11 233 38 89 24 70 209 174 216 104 225 116 195 40 186 152 102 117 83 20 139 88 24 70 209 118 115 181 140 74 249 129 249 79 124 159 77 141 150 193 0 221 93 196 2 130 9 148 227 104 33 152 100 97 24 69 187 98 163 133 211 13 163 232 98 154 213 77 81 44 98 97 24 69 219 205 213 50 42 229 227 9 162 250 150 31 244 217 212 104 25 12 208 86 11 193 4 202 113 180 16 76 178 48 140 162 93 177 209 194 233 134 81 116 49 205 234 166 40 22 177 48 140 162 237 230 106 25 149 242 131 54 229 7 125 54 53 90 6 3 180 213 66 48 129 114 28 45 4 147 44 12 163 104 87 108 180 112 186 97 20 93 76 179 186 41 138 69 44 12 163 104 187 185 90 70 165 124 60 56 216 76 75 159 77 141 150 193 0 109 181 16 76 160 28 71 11 193 36 11 195 40 218 21 27 45 156 110 24 69 23 211 172 110 138 98 245 51 150 231 215 134 81 180 221 90 45 237 51 147 237 195 140 199 248 49 253 45 46 30 179 67 57 217 165 27 36 144 217 5 170 22 237 35 145 205 239 85 126 108 222 197 133 224 33 175 170 124 223 189 218 226 9 216 20 79 55 206 46 112 71 221 228 121 213 189 168 159 203 180 207 212 46 255 7 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 157 65 219 210 188 0 0 0 41 1 0 0 20 0 0 0 120 108 47 115 104 97 114 101 100 83 116 114 105 110 103 115 46 120 109 108 92 208 193 78 195 48 12 6 224 59 210 222 33 242 125 75 225 48 16 74 50 141 193 158 0 30 192 164 94 27 169 113 74 237 34 246 246 4 33 132 148 227 255 249 247 193 118 135 175 60 153 79 90 36 21 246 112 187 235 192 16 199 210 39 30 60 188 189 158 183 15 96 68 145 123 156 10 147 135 43 9 28 194 230 198 137 168 169 187 44 30 70 213 249 209 90 137 35 101 148 93 153 137 235 228 82 150 140 90 227 50 88 153 23 194 94 70 34 205 147 189 235 186 189 205 152 24 76 44 43 171 135 123 48 43 167 143 149 78 127 57 56 73 193 105 56 58 171 193 217 159 240 11 79 45 156 90 120 110 225 165 133 115 11 177 112 68 37 70 173 111 48 138 239 19 253 87 108 61 53 124 3 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 208 204 72 148 72 2 0 0 236 4 0 0 13 0 0 0 120 108 47 115 116 121 108 101 115 46 120 109 108 164 148 77 139 219 48 16 134 239 133 254 7 161 187 35 199 77 182 73 176 189 144 100 13 11 219 82 72 10 189 42 182 236 136 213 135 145 228 212 105 233 127 239 200 118 156 132 61 180 176 23 107 52 26 61 122 103 52 114 252 216 74 129 78 204 88 174 85 130 167 147 16 35 166 114 93 112 85 37 248 251 62 11 22 24 89 71 85 65 133 86 44 193 103 102 241 99 250 241 67 108 221 89 176 221 145 49 135 0 161 108 130 143 206 213 43 66 108 126 100 146 218 137 174 153 130 149 82 27 73 29 76 77 69 108 109 24 45 172 223 36 5 137 194 240 129 72 202 21 238 9 43 153 255 15 68 82 243 218 212 65 174 101 77 29 63 112 193 221 185 99 97 36 243 213 115 165 180 161 7 1 82 219 233 140 230 23 118 55 121 131 151 60 55 218 234 210 77 0 71 116 89 242 156 189 85 185 36 75 2 164 52 46 181 114 22 229 186 81 14 106 5 104 127 194 234 85 233 159 42 243 75 222 217 71 165 177 253 133 78 84 128 103 138 73 26 231 90 104 131 28 84 6 132 117 30 69 37 235 35 54 84 240 131 225 62 172 164 146 139 115 239 142 188 163 43 230 16 39 57 164 230 157 196 235 24 6 11 155 184 16 163 170 200 11 0 71 26 67 117 28 51 42 131 9 26 236 253 185 134 227 21 92 100 143 233 226 254 17 93 25 122 158 70 243 155 13 164 59 48 141 15 218 20 208 56 215 122 92 92 105 44 88 233 64 168 225 213 209 143 78 215 240 61 104 231 160 202 105 92 112 90 105 69 5 152 164 135 140 6 164 147 51 33 118 190 185 126 148 119 236 182 68 170 145 153 116 207 69 130 161 77 125 17 46 38 36 50 152 61 175 159 120 254 45 173 103 191 27 139 218 242 158 15 196 27 217 119 162 199 227 145 191 239 4 127 245 175 65 64 231 12 8 116 104 184 112 92 221 3 187 244 129 89 180 215 18 132 254 6 156 239 236 126 245 82 118 168 68 193 74 218 8 183 31 23 19 124 181 191 176 130 55 50 26 163 190 241 147 118 29 34 193 87 251 197 223 212 244 193 159 193 90 247 98 161 189 96 68 141 225 9 254 253 180 254 188 220 62 101 81 176 8 215 139 96 246 137 205 131 229 124 189 13 230 179 205 122 187 205 150 97 20 110 254 220 60 180 119 60 179 238 119 144 198 240 176 86 86 192 99 52 67 178 67 138 187 171 47 193 55 147 94 126 215 163 32 27 174 253 146 4 177 227 111 42 253 11 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 28 144 44 217 69 1 0 0 113 2 0 0 17 0 8 1 100 111 99 80 114 111 112 115 47 99 111 114 101 46 120 109 108 32 162 4 1 40 160 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 140 146 95 107 195 32 20 197 223 7 251 14 193 247 196 152 142 178 74 146 66 55 250 180 194 96 221 31 246 38 122 219 202 162 17 181 75 251 237 103 146 54 203 104 31 246 168 231 220 159 231 92 204 231 7 85 69 223 96 157 172 117 129 72 146 162 8 52 175 133 212 219 2 189 174 151 241 61 138 156 103 90 176 170 214 80 160 35 56 52 47 111 111 114 110 40 175 45 60 219 218 128 245 18 92 20 72 218 81 110 10 180 243 222 80 140 29 223 129 98 46 9 14 29 196 77 109 21 243 225 104 183 216 48 254 197 182 128 179 52 157 98 5 158 9 230 25 110 129 177 25 136 232 132 20 124 64 154 189 173 58 128 224 24 42 80 160 189 195 36 33 248 215 235 193 42 119 117 160 83 70 78 37 253 209 132 78 167 184 99 182 224 189 56 184 15 78 14 198 166 105 146 102 210 197 8 249 9 254 88 61 189 116 85 99 169 219 93 113 64 101 46 56 229 22 152 175 109 185 8 171 19 192 246 209 155 12 154 246 57 30 137 237 34 43 230 252 42 236 124 35 65 44 142 87 252 151 158 192 239 234 244 143 128 136 66 64 218 215 57 43 239 147 135 199 245 18 149 89 74 238 98 146 197 132 172 73 74 211 41 205 102 159 109 132 63 243 109 224 254 66 157 130 252 159 56 163 36 27 17 207 128 50 199 23 159 164 252 1 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 149 20 73 78 173 1 0 0 117 3 0 0 16 0 8 1 100 111 99 80 114 111 112 115 47 97 112 112 46 120 109 108 32 162 4 1 40 160 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 156 147 77 111 27 33 16 134 239 149 250 31 86 220 99 214 118 84 85 22 75 20 57 141 114 104 85 75 222 36 103 202 206 218 40 44 32 24 175 236 254 250 206 238 202 49 238 199 165 183 153 121 135 151 135 1 196 221 177 179 69 15 49 25 239 42 54 159 149 172 0 167 125 99 220 174 98 207 245 227 205 103 86 36 84 174 81 214 59 168 216 9 18 187 147 31 63 136 77 244 1 34 26 72 5 89 184 84 177 61 98 88 113 158 244 30 58 149 102 36 59 82 90 31 59 133 148 198 29 247 109 107 52 60 120 125 232 192 33 95 148 229 39 14 71 4 215 64 115 19 222 13 217 228 184 234 241 127 77 27 175 7 190 244 82 159 2 1 75 81 123 84 182 54 29 200 82 240 75 34 238 67 176 70 43 164 211 203 111 70 71 159 124 139 197 151 163 6 43 120 46 10 162 222 130 62 68 131 167 193 35 79 197 86 43 11 107 218 80 182 202 38 16 252 82 16 79 160 134 97 110 148 137 73 138 30 87 61 104 244 177 72 230 39 141 115 193 138 31 42 193 128 89 177 94 69 163 28 18 238 208 54 37 99 108 67 194 40 31 225 96 172 165 121 55 80 208 134 250 64 136 212 56 137 99 152 175 201 99 115 43 151 99 3 5 215 141 131 193 4 68 194 53 106 109 144 54 251 222 110 84 196 191 144 47 115 242 145 97 226 206 88 231 57 223 59 233 120 140 197 191 165 137 52 63 213 56 48 226 251 141 104 237 187 160 220 73 222 163 79 197 171 143 182 177 198 209 240 207 117 241 213 184 183 244 28 106 255 160 16 206 87 115 93 20 219 189 138 208 208 109 158 245 75 65 60 209 173 68 242 124 75 235 189 114 59 104 206 61 127 10 195 67 122 153 126 145 156 223 206 202 101 73 111 36 171 9 126 249 47 242 23 0 0 0 255 255 3 0 80 75 3 4 20 0 6 0 8 0 0 0 33 0 126 148 213 45 209 1 0 0 250 10 0 0 16 0 0 0 120 108 47 99 97 108 99 67 104 97 105 110 46 120 109 108 100 214 219 106 219 80 16 133 225 251 66 223 65 232 190 81 164 158 75 156 192 236 61 51 47 208 62 128 112 212 216 96 203 193 50 165 125 251 170 37 9 237 250 111 4 250 180 217 163 195 204 66 55 119 63 143 135 230 199 116 94 246 167 121 211 246 87 215 109 51 205 219 211 253 126 126 216 180 223 190 198 155 79 109 179 92 198 249 126 60 156 230 105 211 254 154 150 246 238 246 245 171 155 237 120 216 150 221 184 159 155 117 135 121 217 180 187 203 229 241 75 215 45 219 221 116 28 151 171 211 227 52 175 87 190 159 206 199 241 178 158 158 31 186 229 241 60 141 247 203 110 154 46 199 67 55 92 95 127 232 142 235 6 237 237 205 182 57 111 90 123 215 54 251 245 30 218 230 240 231 216 61 113 121 230 103 168 10 174 16 10 169 96 239 159 106 61 111 90 20 170 130 43 132 66 42 216 7 173 162 80 21 92 33 20 82 193 62 106 21 133 170 224 10 161 144 10 182 54 194 223 175 243 242 198 20 170 130 43 132 66 42 216 103 173 162 80 21 92 33 20 82 193 250 181 205 255 127 24 72 133 56 36 32 9 177 126 109 104 169 165 82 177 198 33 1 73 136 245 3 106 169 84 172 113 72 64 18 98 253 91 212 82 169 88 227 144 128 36 196 122 157 223 2 169 16 135 4 36 33 214 235 20 23 72 133 56 36 32 9 177 94 103 185 64 42 196 33 1 73 136 245 58 209 5 82 33 14 9 72 66 172 215 185 46 144 10 113 72 64 18 98 189 78 119 129 84 136 67 2 146 16 27 144 27 144 10 113 72 64 18 98 131 166 68 129 84 136 67 2 146 16 27 52 37 10 164 66 28 18 144 132 216 160 41 81 32 21 226 144 128 36 196 6 228 6 164 66 28 18 144 132 216 128 220 128 84 136 67 2 146 16 27 144 27 144 10 113 72 64 18 98 3 114 3 82 33 14 9 72 66 138 182 70 85 112 133 80 72 5 251 7 186 151 191 214 219 223 0 0 0 255 255 3 0 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 199 122 151 144 120 1 0 0 32 6 0 0 19 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 91 67 111 110 116 101 110 116 95 84 121 112 101 115 93 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 181 85 48 35 245 0 0 0 76 2 0 0 11 0 0 0 0 0 0 0 0 0 0 0 0 0 177 3 0 0 95 114 101 108 115 47 46 114 101 108 115 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 244 245 7 59 27 1 0 0 89 4 0 0 26 0 0 0 0 0 0 0 0 0 0 0 0 0 215 6 0 0 120 108 47 95 114 101 108 115 47 119 111 114 107 98 111 111 107 46 120 109 108 46 114 101 108 115 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 95 77 123 205 95 1 0 0 113 2 0 0 15 0 0 0 0 0 0 0 0 0 0 0 0 0 50 9 0 0 120 108 47 119 111 114 107 98 111 111 107 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 1 14 86 208 152 6 0 0 168 27 0 0 19 0 0 0 0 0 0 0 0 0 0 0 0 0 190 10 0 0 120 108 47 116 104 101 109 101 47 116 104 101 109 101 49 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 159 202 189 227 109 1 0 0 134 2 0 0 24 0 0 0 0 0 0 0 0 0 0 0 0 0 135 17 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 50 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 159 202 189 227 109 1 0 0 134 2 0 0 24 0 0 0 0 0 0 0 0 0 0 0 0 0 42 19 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 51 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 195 7 21 126 38 7 0 0 152 43 0 0 24 0 0 0 0 0 0 0 0 0 0 0 0 0 205 20 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 49 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 157 65 219 210 188 0 0 0 41 1 0 0 20 0 0 0 0 0 0 0 0 0 0 0 0 0 41 28 0 0 120 108 47 115 104 97 114 101 100 83 116 114 105 110 103 115 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 208 204 72 148 72 2 0 0 236 4 0 0 13 0 0 0 0 0 0 0 0 0 0 0 0 0 23 29 0 0 120 108 47 115 116 121 108 101 115 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 28 144 44 217 69 1 0 0 113 2 0 0 17 0 0 0 0 0 0 0 0 0 0 0 0 0 138 31 0 0 100 111 99 80 114 111 112 115 47 99 111 114 101 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 149 20 73 78 173 1 0 0 117 3 0 0 16 0 0 0 0 0 0 0 0 0 0 0 0 0 6 34 0 0 100 111 99 80 114 111 112 115 47 97 112 112 46 120 109 108 80 75 1 2 45 0 20 0 6 0 8 0 0 0 33 0 126 148 213 45 209 1 0 0 250 10 0 0 16 0 0 0 0 0 0 0 0 0 0 0 0 0 233 36 0 0 120 108 47 99 97 108 99 67 104 97 105 110 46 120 109 108 80 75 5 6 0 0 0 0 13 0 13 0 74 3 0 0 232 38 0 0 0 0]! !

!TabularResources class methodsFor: 'examples' stamp: 'HannesHirzel 8/12/2015 06:11'!
testExcelFile3WithAlignment
"was created 
self example3Creation 
from a manually constructed file. 

To get it back do:
(FileLocator home / self fileNameOfExample3  ) asFileReference writeStreamDo: [ :stream | 
    stream 
        binary; 
        nextPutAll: self testExcelFile3WithAlignment ]


"

 ^ #[80 75 3 4 20 0 8 8 8 0 212 122 9 71 0 0 0 0 0 0 0 0 0 0 0 0 11 0 0 0 95 114 101 108 115 47 46 114 101 108 115 173 146 207 74 3 49 16 135 239 125 138 144 123 119 182 21 68 100 179 189 136 208 155 72 125 128 152 204 254 97 55 153 48 25 117 125 123 131 8 90 169 165 7 143 73 126 243 205 55 67 154 221 18 102 245 138 156 71 138 70 111 170 90 43 140 142 252 24 123 163 159 14 247 235 27 189 107 87 205 35 206 86 74 36 15 99 202 170 212 196 108 244 32 146 110 1 178 27 48 216 92 81 194 88 94 58 226 96 165 28 185 135 100 221 100 123 132 109 93 95 3 255 100 232 246 136 169 246 222 104 222 251 141 86 135 247 132 151 176 169 235 70 135 119 228 94 2 70 57 209 226 87 162 144 45 247 40 70 47 51 188 17 79 207 68 83 85 160 26 78 187 108 47 119 249 123 78 8 40 214 91 177 224 136 113 157 184 84 179 140 152 191 117 60 185 135 114 157 63 19 231 132 174 254 115 57 184 8 70 143 254 188 146 77 233 203 104 213 192 209 39 104 63 0 80 75 7 8 102 170 130 183 224 0 0 0 59 2 0 0 80 75 3 4 20 0 8 8 8 0 212 122 9 71 0 0 0 0 0 0 0 0 0 0 0 0 16 0 0 0 100 111 99 80 114 111 112 115 47 97 112 112 46 120 109 108 157 208 203 106 195 48 16 5 208 125 191 66 136 108 109 217 206 131 16 100 135 150 146 85 32 93 184 221 6 69 26 39 42 122 33 141 131 243 247 85 91 104 178 238 242 114 225 112 103 248 118 178 134 92 33 38 237 93 75 235 178 162 4 156 244 74 187 115 75 223 251 93 177 166 36 161 112 74 24 239 160 165 55 72 116 219 61 241 183 232 3 68 212 144 72 22 92 106 233 5 49 108 24 75 242 2 86 164 50 215 46 55 131 143 86 96 142 241 204 252 48 104 9 175 94 142 22 28 178 166 170 86 12 38 4 167 64 21 225 15 164 191 226 230 138 255 69 149 151 223 251 210 71 127 11 217 235 120 239 81 152 94 91 232 234 122 201 217 61 242 231 16 140 150 2 243 249 221 94 159 34 28 126 60 182 40 231 229 178 108 102 123 237 198 233 56 173 87 228 161 61 230 177 159 32 145 45 230 149 173 102 47 163 54 170 104 56 123 196 56 187 191 168 251 2 80 75 7 8 83 32 75 25 225 0 0 0 103 1 0 0 80 75 3 4 20 0 8 8 8 0 212 122 9 71 0 0 0 0 0 0 0 0 0 0 0 0 17 0 0 0 100 111 99 80 114 111 112 115 47 99 111 114 101 46 120 109 108 141 146 95 79 194 48 20 197 223 253 20 75 223 183 174 35 24 104 182 145 160 193 23 73 76 196 104 124 107 186 203 104 92 187 165 45 12 190 189 93 101 21 149 7 223 122 239 57 253 221 211 63 249 226 40 155 232 0 218 136 86 21 136 36 41 138 64 241 182 18 170 46 208 203 102 21 207 80 100 44 83 21 107 90 5 5 58 129 65 139 242 38 231 29 229 173 134 39 221 118 160 173 0 19 57 144 50 148 119 5 218 89 219 81 140 13 223 129 100 38 113 14 229 196 109 171 37 179 174 212 53 238 24 255 96 53 224 44 77 111 177 4 203 42 102 25 30 128 113 23 136 232 140 172 120 64 118 123 221 120 64 197 49 52 32 65 89 131 73 66 240 183 215 130 150 230 234 6 175 92 56 165 176 167 14 174 90 71 49 184 143 70 4 99 223 247 73 63 241 86 151 159 224 183 245 227 179 63 106 44 212 112 85 28 80 153 159 131 80 174 129 89 168 34 7 160 95 227 70 229 117 114 119 191 89 161 50 75 201 52 78 103 113 58 223 144 41 205 82 154 77 222 115 252 107 255 0 252 90 183 186 220 27 208 209 96 9 157 65 109 152 170 247 238 82 75 80 241 195 210 203 161 53 60 87 195 140 93 187 135 221 10 168 150 167 17 242 87 8 209 229 185 247 255 236 25 37 243 139 236 35 192 143 215 112 16 195 39 43 137 31 26 74 95 253 252 74 229 39 80 75 7 8 195 18 13 53 73 1 0 0 150 2 0 0 80 75 3 4 20 0 8 8 8 0 212 122 9 71 0 0 0 0 0 0 0 0 0 0 0 0 26 0 0 0 120 108 47 95 114 101 108 115 47 119 111 114 107 98 111 111 107 46 120 109 108 46 114 101 108 115 173 145 77 107 195 48 12 134 239 253 21 70 247 197 73 7 99 140 56 189 140 65 175 253 248 1 198 81 226 208 196 54 146 214 181 255 126 46 27 91 10 101 236 208 147 208 215 243 190 72 245 234 52 141 234 136 196 67 12 6 170 162 4 133 193 197 118 8 189 129 253 238 237 225 25 86 205 162 222 224 104 37 143 176 31 18 171 188 19 216 128 23 73 47 90 179 243 56 89 46 98 194 144 59 93 164 201 74 78 169 215 201 186 131 237 81 47 203 242 73 211 156 1 205 21 83 173 91 3 180 110 43 80 187 115 194 255 176 99 215 13 14 95 163 123 159 48 200 13 9 205 114 30 145 51 209 82 143 98 224 43 47 50 7 244 109 249 229 61 229 63 34 29 216 35 202 175 131 159 82 54 119 9 213 95 102 30 239 122 11 111 9 219 173 80 126 236 252 36 243 242 183 153 69 173 175 222 221 124 2 80 75 7 8 79 240 249 122 210 0 0 0 37 2 0 0 80 75 3 4 20 0 8 8 8 0 212 122 9 71 0 0 0 0 0 0 0 0 0 0 0 0 20 0 0 0 120 108 47 115 104 97 114 101 100 83 116 114 105 110 103 115 46 120 109 108 93 206 209 106 2 49 16 5 208 119 191 34 204 187 102 107 75 41 146 68 68 240 11 244 3 210 100 154 13 36 147 109 102 86 236 223 187 69 164 208 199 123 15 23 174 217 223 106 81 87 236 156 27 89 120 217 12 160 144 66 139 153 146 133 203 249 180 254 0 197 226 41 250 210 8 45 252 32 195 222 173 12 179 168 101 74 108 97 20 153 118 90 115 24 177 122 222 180 9 105 145 175 214 171 151 37 246 164 121 234 232 35 143 136 82 139 222 14 195 187 174 62 19 168 208 102 18 11 175 160 102 202 223 51 30 159 217 25 206 206 136 123 83 1 75 97 85 177 39 140 70 139 51 250 87 30 234 63 67 196 255 101 207 105 148 67 201 137 48 158 241 38 127 174 151 211 238 14 80 75 7 8 24 10 31 104 178 0 0 0 242 0 0 0 80 75 3 4 20 0 8 8 8 0 212 122 9 71 0 0 0 0 0 0 0 0 0 0 0 0 24 0 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 49 46 120 109 108 189 86 93 111 219 54 20 125 223 175 16 244 208 167 205 146 229 207 165 178 138 192 153 215 1 105 108 196 105 11 236 141 22 175 44 34 20 169 146 148 221 228 215 239 146 250 156 155 2 237 6 36 64 44 241 146 60 247 220 67 138 135 241 187 175 5 247 78 160 52 147 98 229 143 71 161 239 129 72 37 101 226 184 242 63 62 108 126 91 250 158 54 68 80 194 165 128 149 255 4 218 127 151 252 18 159 165 122 212 57 128 241 16 64 232 149 159 27 83 94 5 129 78 115 40 136 30 201 18 4 246 100 82 21 196 96 83 29 3 93 42 32 212 77 42 120 16 133 225 60 40 8 19 126 141 112 165 126 4 67 102 25 75 225 70 166 85 1 194 212 32 10 56 49 72 95 231 172 212 126 18 187 12 59 229 101 140 27 80 31 36 69 218 25 225 26 176 175 36 71 216 131 249 88 186 126 243 32 119 24 104 187 131 36 14 154 201 73 76 25 102 176 170 120 10 178 149 127 61 190 186 94 218 17 110 192 39 6 103 61 120 247 206 76 80 121 222 41 105 32 53 78 202 26 210 211 185 60 111 176 128 138 19 253 175 224 159 138 209 91 38 0 163 70 85 77 240 94 158 215 146 191 71 153 112 69 134 29 127 131 146 93 64 177 99 142 212 111 33 51 29 164 33 135 61 112 76 14 116 56 111 91 25 142 73 246 79 197 65 242 14 128 66 70 42 110 44 5 76 39 85 27 63 97 41 43 95 88 189 57 66 202 210 166 88 3 231 182 126 223 75 237 216 191 16 127 62 245 189 103 41 139 125 74 56 170 55 14 195 65 251 206 77 191 140 90 157 111 201 147 172 156 94 77 175 221 68 7 41 31 109 200 226 134 118 245 92 21 86 247 146 216 13 215 176 240 61 130 209 19 52 108 22 195 118 61 213 211 95 234 149 90 244 11 105 129 135 239 237 154 109 220 150 194 61 208 40 129 186 191 7 171 42 18 139 70 75 191 157 211 142 75 98 172 93 187 95 171 2 39 165 182 58 55 218 231 140 82 232 151 188 32 95 17 6 159 76 184 167 54 79 86 37 91 47 163 38 95 249 81 56 90 78 198 243 73 52 159 77 194 249 56 178 124 127 2 57 140 102 13 120 244 2 248 120 60 154 69 225 52 92 54 9 156 24 53 123 87 210 13 49 36 137 149 60 123 202 177 75 43 109 100 81 23 218 231 109 133 184 100 80 143 110 181 170 119 141 172 247 216 45 156 128 59 38 223 212 129 229 217 108 118 15 105 151 20 231 218 47 245 148 132 113 112 178 252 240 31 41 117 188 162 255 199 171 9 254 56 177 168 33 22 92 240 152 188 50 143 201 119 120 76 95 153 199 244 59 60 22 175 204 99 225 120 132 131 13 51 126 121 195 44 95 153 216 210 17 139 6 196 162 11 98 193 224 107 43 64 29 221 73 165 17 177 18 150 147 63 136 246 14 51 117 138 247 195 209 176 20 19 102 91 58 127 243 114 52 6 52 230 222 72 142 189 137 92 70 208 229 218 15 52 151 138 61 75 97 8 95 163 105 130 26 28 48 232 252 134 165 223 118 4 181 85 126 32 234 200 48 49 119 86 19 142 22 203 197 172 241 159 190 137 39 180 187 57 204 162 69 247 135 250 28 164 65 133 95 234 201 157 191 245 0 153 68 219 236 219 65 103 211 85 137 38 80 130 218 179 103 60 227 126 71 205 7 134 147 49 165 141 181 149 187 170 56 64 125 152 57 75 255 220 28 132 77 179 59 216 125 207 194 110 149 203 141 110 45 30 114 16 91 84 0 23 94 49 20 128 212 206 93 74 101 20 97 104 57 149 134 157 213 31 212 77 237 19 189 206 7 78 210 199 107 65 63 231 204 116 23 8 143 42 50 240 228 20 151 112 45 11 123 83 209 214 86 5 56 200 205 37 241 203 85 186 41 25 30 61 182 198 118 121 250 72 42 75 6 237 183 89 11 185 113 242 121 148 101 25 46 161 48 14 191 167 212 134 183 148 254 113 234 191 128 36 150 148 214 55 141 228 13 41 202 183 107 247 251 230 75 37 205 219 7 188 252 104 239 14 47 54 247 178 32 226 215 123 56 226 5 70 213 157 110 220 56 114 143 235 56 232 97 44 98 77 230 191 33 90 77 60 247 190 115 176 13 86 28 12 235 196 102 119 247 76 254 1 80 75 7 8 118 96 225 57 218 3 0 0 191 10 0 0 80 75 3 4 20 0 8 8 8 0 212 122 9 71 0 0 0 0 0 0 0 0 0 0 0 0 13 0 0 0 120 108 47 115 116 121 108 101 115 46 120 109 108 237 152 209 78 219 48 20 134 239 247 20 150 239 71 210 210 22 152 210 32 96 116 154 52 33 4 69 154 52 237 194 36 78 98 225 216 145 237 66 195 211 115 28 167 105 82 212 141 150 139 21 173 87 182 255 248 124 254 115 108 183 118 130 211 121 206 209 35 85 154 73 49 198 189 3 31 35 42 34 25 51 145 142 241 221 116 242 249 24 35 109 136 136 9 151 130 142 113 73 53 62 13 63 5 218 148 156 222 102 148 26 4 4 161 199 56 51 166 248 226 121 58 202 104 78 244 129 44 168 128 39 137 84 57 49 208 84 169 167 11 69 73 172 109 80 206 189 190 239 143 188 156 48 129 195 64 204 242 73 110 52 138 228 76 24 176 209 72 200 21 223 99 16 71 3 140 28 238 66 198 96 229 219 229 213 229 205 217 15 236 133 129 87 3 194 32 145 98 201 25 96 39 132 129 126 70 143 132 3 196 183 221 5 201 169 107 159 41 70 184 149 18 146 51 94 58 177 95 33 93 224 22 225 254 206 132 87 133 77 10 227 188 73 74 31 59 33 12 10 98 12 85 98 2 13 84 215 167 101 1 153 21 48 213 14 83 245 251 75 239 84 145 178 215 31 182 2 170 2 198 189 151 42 134 165 213 158 86 39 161 152 145 84 10 194 239 138 49 78 8 215 20 55 210 87 249 36 22 98 24 112 154 24 0 43 150 102 182 52 178 240 44 196 24 153 67 101 17 99 135 118 228 166 2 195 71 148 243 91 187 78 127 38 203 183 247 1 58 79 94 175 43 81 53 96 249 91 239 117 213 145 234 6 41 10 94 78 164 133 24 53 163 181 112 94 117 233 72 103 156 165 34 167 43 29 175 149 52 52 50 213 54 171 228 48 32 139 142 40 147 138 61 3 218 78 96 74 5 85 48 175 118 87 26 22 89 201 189 47 70 134 206 205 141 52 196 81 192 211 147 34 197 20 196 38 137 76 196 213 192 240 76 103 138 137 135 169 156 176 230 49 164 169 104 108 32 46 163 7 26 47 76 102 44 134 208 86 79 111 158 172 100 202 95 230 169 183 109 158 106 159 171 137 106 203 237 76 45 150 193 199 49 211 223 155 89 99 102 235 189 181 55 179 55 179 55 179 55 179 55 179 141 153 193 225 46 253 83 14 122 59 229 102 176 83 110 250 187 228 230 228 31 155 241 218 199 119 119 152 111 157 227 15 183 61 198 207 147 215 206 219 126 222 105 253 163 157 233 223 147 182 183 79 248 154 123 208 198 73 131 235 223 31 51 230 198 249 95 19 86 93 146 119 99 141 121 245 118 109 93 194 155 173 59 194 45 21 217 207 25 99 124 101 191 235 240 86 214 238 103 140 27 38 234 86 52 211 240 34 231 78 107 141 181 138 185 144 121 78 22 148 222 176 131 57 220 16 131 126 249 191 27 212 168 131 26 109 128 154 41 69 69 84 54 164 163 14 105 176 57 169 227 235 184 67 59 122 59 237 154 170 8 102 188 1 157 116 64 195 245 160 229 207 50 76 174 183 252 12 24 190 0 80 75 7 8 199 76 64 105 180 2 0 0 75 20 0 0 80 75 3 4 20 0 8 8 8 0 212 122 9 71 0 0 0 0 0 0 0 0 0 0 0 0 15 0 0 0 120 108 47 119 111 114 107 98 111 111 107 46 120 109 108 141 82 77 111 219 48 12 189 239 87 8 186 55 182 211 34 72 131 40 197 208 162 104 15 251 192 218 181 103 90 162 99 45 178 100 72 76 220 238 215 143 86 226 174 3 118 232 73 34 31 245 248 30 169 245 213 75 231 196 1 99 178 193 43 89 205 74 41 208 235 96 172 223 42 249 243 241 246 108 41 69 34 240 6 92 240 168 228 43 38 121 181 249 180 30 66 220 213 33 236 4 191 247 73 201 150 168 95 21 69 210 45 118 144 102 161 71 207 72 19 98 7 196 97 220 22 169 143 8 38 181 136 212 185 98 94 150 139 162 3 235 229 145 97 21 63 194 17 154 198 106 188 9 122 223 161 167 35 73 68 7 196 234 83 107 251 36 55 235 198 58 124 58 26 18 208 247 95 161 99 217 215 224 180 44 54 111 178 191 71 81 131 222 237 251 91 174 86 178 1 151 144 141 182 97 248 86 255 66 77 236 8 156 147 194 0 97 117 89 94 76 37 255 80 4 226 74 110 195 201 49 241 100 113 72 127 241 49 204 140 119 33 218 223 193 19 184 7 29 131 115 74 82 220 159 186 177 80 178 250 127 200 195 56 168 71 168 211 148 124 121 182 222 132 65 73 94 209 235 187 251 144 175 207 214 80 203 11 92 156 47 47 166 220 29 218 109 75 74 46 171 203 185 20 4 245 143 113 80 74 206 207 23 82 52 54 38 202 77 50 11 176 147 3 114 191 49 98 67 197 59 71 121 103 211 41 124 30 104 126 89 141 82 249 188 55 220 57 255 19 98 232 96 147 173 29 43 142 43 203 64 188 55 243 204 56 209 176 93 205 243 183 132 145 235 175 195 222 179 132 170 100 17 17 155 47 193 48 197 103 102 59 225 111 203 57 197 55 232 8 88 228 172 44 171 76 59 205 123 243 7 80 75 7 8 243 41 8 163 155 1 0 0 204 2 0 0 80 75 3 4 20 0 8 8 8 0 212 122 9 71 0 0 0 0 0 0 0 0 0 0 0 0 19 0 0 0 91 67 111 110 116 101 110 116 95 84 121 112 101 115 93 46 120 109 108 189 148 193 75 195 48 20 198 239 251 43 74 174 210 166 243 32 34 237 118 16 60 234 192 121 150 152 188 173 161 109 18 222 139 179 251 239 125 169 155 160 8 219 216 240 210 80 242 190 239 247 222 151 144 106 62 244 93 182 1 36 235 93 45 166 69 41 50 112 218 27 235 214 181 120 89 62 228 183 98 62 155 84 203 109 0 202 184 214 81 45 154 24 195 157 148 164 27 232 21 21 62 128 227 157 149 199 94 69 254 197 181 12 74 183 106 13 242 186 44 111 164 246 46 130 139 121 76 30 98 86 61 49 14 173 129 108 161 48 62 170 30 106 33 95 17 58 146 69 250 138 236 254 75 144 152 181 80 33 116 86 171 200 253 201 141 51 191 104 249 142 148 148 99 13 53 54 208 21 23 8 249 55 201 120 189 64 31 72 178 113 145 234 78 194 249 213 202 106 96 143 247 158 37 5 12 172 52 96 242 192 150 128 209 194 113 108 237 17 78 135 239 103 77 234 35 137 67 183 139 246 195 99 251 230 125 155 168 255 17 51 131 169 81 8 230 57 34 223 37 58 59 106 10 8 202 80 3 16 121 130 31 222 7 250 72 163 143 58 146 227 50 189 112 47 223 254 135 242 136 219 14 46 30 196 104 122 68 2 251 195 191 232 33 240 90 244 202 186 29 127 82 201 241 161 152 125 2 80 75 7 8 98 20 195 28 52 1 0 0 87 4 0 0 80 75 1 2 20 0 20 0 8 8 8 0 212 122 9 71 102 170 130 183 224 0 0 0 59 2 0 0 11 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 95 114 101 108 115 47 46 114 101 108 115 80 75 1 2 20 0 20 0 8 8 8 0 212 122 9 71 83 32 75 25 225 0 0 0 103 1 0 0 16 0 0 0 0 0 0 0 0 0 0 0 0 0 25 1 0 0 100 111 99 80 114 111 112 115 47 97 112 112 46 120 109 108 80 75 1 2 20 0 20 0 8 8 8 0 212 122 9 71 195 18 13 53 73 1 0 0 150 2 0 0 17 0 0 0 0 0 0 0 0 0 0 0 0 0 56 2 0 0 100 111 99 80 114 111 112 115 47 99 111 114 101 46 120 109 108 80 75 1 2 20 0 20 0 8 8 8 0 212 122 9 71 79 240 249 122 210 0 0 0 37 2 0 0 26 0 0 0 0 0 0 0 0 0 0 0 0 0 192 3 0 0 120 108 47 95 114 101 108 115 47 119 111 114 107 98 111 111 107 46 120 109 108 46 114 101 108 115 80 75 1 2 20 0 20 0 8 8 8 0 212 122 9 71 24 10 31 104 178 0 0 0 242 0 0 0 20 0 0 0 0 0 0 0 0 0 0 0 0 0 218 4 0 0 120 108 47 115 104 97 114 101 100 83 116 114 105 110 103 115 46 120 109 108 80 75 1 2 20 0 20 0 8 8 8 0 212 122 9 71 118 96 225 57 218 3 0 0 191 10 0 0 24 0 0 0 0 0 0 0 0 0 0 0 0 0 206 5 0 0 120 108 47 119 111 114 107 115 104 101 101 116 115 47 115 104 101 101 116 49 46 120 109 108 80 75 1 2 20 0 20 0 8 8 8 0 212 122 9 71 199 76 64 105 180 2 0 0 75 20 0 0 13 0 0 0 0 0 0 0 0 0 0 0 0 0 238 9 0 0 120 108 47 115 116 121 108 101 115 46 120 109 108 80 75 1 2 20 0 20 0 8 8 8 0 212 122 9 71 243 41 8 163 155 1 0 0 204 2 0 0 15 0 0 0 0 0 0 0 0 0 0 0 0 0 221 12 0 0 120 108 47 119 111 114 107 98 111 111 107 46 120 109 108 80 75 1 2 20 0 20 0 8 8 8 0 212 122 9 71 98 20 195 28 52 1 0 0 87 4 0 0 19 0 0 0 0 0 0 0 0 0 0 0 0 0 181 14 0 0 91 67 111 110 116 101 110 116 95 84 121 112 101 115 93 46 120 109 108 80 75 5 6 0 0 0 0 9 0 9 0 63 2 0 0 42 16 0 0 0 0]! !

!String methodsFor: '*Tabular' stamp: 'VincentBlondeau 1/14/2015 15:31'!
asPoint
	"'A1' asPoint -> 1 @ 1
	'B3' asPoint -> 2 @ 3"

	| decomp |
	decomp := self stemAndNumericSuffix.
	^ decomp first base26AsInteger @ decomp second! !

!String methodsFor: '*Tabular' stamp: 'VincentBlondeau 12/11/2014 13:55'!
base26AsInteger
	^ (self capitalized asOrderedCollection reverse
		withIndexCollect: [ :letter :index | (letter asInteger - $A asciiValue + 1) * (26 raisedTo: index - 1) ]) sum! !
